      PROGRAM ARITVE2K
C     VERSION 2.00
C     Last update January 2000
C     First version : 1984
C
C     A. Le Bail  alb@cristal.org
C
C
C     ARITVE: A PROGRAM FOR MODELLING INTERFERENCE FUNCTIONS OF
C                       AMORPHOUS MATERIALS.
C        
C     GAUSSIAN PEAK SHAPE WITH CAGLIOTTI LAW.
C
C     MAXIS:  70 REFINED PARAMETERS = REF    
C             20000 HKL OVERLAP
C             1200 points on each pattern
C             3 patterns maxi
C
C             SMM size = (REF*REF)/2 +REF/2 = 2485
C
C
C
************************************************************************
*
*    Copyright (C) 1984-1999 Armel Le Bail
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*
***********************************************************************
      character*20 file
      character*24 temp
      logical qex
      DIMENSION XL(110,14),STAND(70)
      DIMENSION FLAG(110,14),LP(110,14),SMM(2485)
      DIMENSION DUMPA(500),S(3,4,21),F(3,4,21),SM(24,3,3),T(24,3)
      COMMON /RCEE/ RCE(3,6)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     2 6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)   
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)      
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2 ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3 ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM, 
     2 MNEQPO,MNOVRF,MNPATS
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT           
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /RELX/RELAXB,RELAXC,RELAXS,RELAXH                     
      COMMON /GEOM/DEGRAD,RADDEG                                 
      COMMON /INPUT/NPOINT,MODE,LINO,READIN(6)
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
      PI=36000./3.14159265359           
      DEGRAD=3.14159265359/180.0  
      RADDEG=1.0/DEGRAD           
      LCA=20
      PRINT 1
1     format('  entry file (no extension) ??',$)
      READ 3,file
3     format(A20)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
	 lfile=lfile-1
      enddo
      temp=file(1:lfile)//'.dat'
      call open_read1(20,temp)
      MNCONF=4 
      MNCONT=9 
      MMATOR=70
      MNEUTS=8 
      MNATOM=70
      MNEQPO=24
      MNOVRF=20000
      LINES=80 
      MNPATS=3 
      MODE=0   
      LINO=1   
      MATORD=0
10    ICYCLE=0   
      CALL DATAIN(FILE,LFILE,XL,FLAG,LP,S,F,DUMPA,SM,T,LG)
30    ICYCLE=ICYCLE+1
      IF(NCYCLE)50,50,40 
40    IF(ICYCLE-NCYCLE)50,50,140
50    CALL CLEAR(SMM)
100   CALL ITER(DUMPA,XL,FLAG,LP,SMM,SM,T,LG,FILE,NCHR)
      IF(NCYCLE)120,120,110
110   CALL MATRIX(SMM,STAND)
120   CALL OUTPUT(XL,FLAG,LP,SMM,STAND)
      CALL DATOUT(XL,LPT)
130   IF(NCYCLE)180,180,30
140   NCYCLE=0            
      GOTO 50             
180   PRINT 190
190   FORMAT('   Thanks for using ARIT'//
     &'   Please type any number and a return to stop')
      Read *,bidon
      STOP
      END
*
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
*
      subroutine open_read2(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old',form='unformatted')
      return
      end
*
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
*
      subroutine open_write2(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='scratch')
      return
      end
*
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close(unit,status='delete')
      return
      end
C	
C	Special Lazy version for creating hkl files
C
      SUBROUTINE LAZYR(SLABDA,OMEG,CELPRE,IGR)
      character*20 bidon
      character*20 file
      DIMENSION CELPRE(6),IGR(36)
      CALL PREDAT(FILE,SLABDA,OMEG,CELPRE,IGR)
	CALL JAZY1(FILE)
C      close(30,status='delete')
C      close(31,status='delete')
      CALL AHKL
	RETURN
	END
C	
C	Subroutine for preparing .dat files for LAZYR
C
      SUBROUTINE PREDAT(FILE,SLABDA,OMEG,CELPRE,IGR)
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
      character*20 file
      character*24 temp
      logical qex
      character*20 bidon
      DIMENSION COMPND(19),CELPRE(6),IGR(36)
      IPR=28
      file='bidon'
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
         lfile=lfile-1
      enddo
      temp=file(1:lfile)//'.dat'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.)go to 100
      call filedel(28,temp)
100   call open_write2(28,temp)
C      PRINT *,'TITLE CARD ?'
C      READ 44,(COMPND(I),I=1,19)
C 44   FORMAT(18A4,A2)
C-----T I T L E  CARD
      WRITE(IPR,45) (COMPND(I),I=1,19)
 45   FORMAT ('TITL  ',18A4,A2)
C      PRINT *,'Wavelenght and 2-theta end ?'
C      READ *,WL,TH
      WL=SLABDA
      TH=OMEG
      TL=0.
C-----C O N D I T  CARD                                                  
      WRITE(IPR,53)WL,TL,TH
 53   FORMAT ('CONDIT',8X,F6.4,2F5.0)
C      PRINT *,'A,B,C,ALPHA,BETA,GAMMA ?'
C      READ *,A,B,C,ALPHA,BETA,GAMMA
      A=CELPRE(1)
      B=CELPRE(2)
      C=CELPRE(3)
      ALPHA=CELPRE(4)
      BETA=CELPRE(5)
      GAMMA=CELPRE(6)
      IF(A.EQ.B)B=0.
      IF(A.EQ.C)C=0.
      IF(ALPHA.EQ.90.)ALPHA=0.
      IF(BETA.EQ.90.)BETA=0.
      IF(GAMMA.EQ.90.)GAMMA=0.
C-----C E L L  CARD
C      PRINT *,A,B,C,ALPHA,BETA,GAMMA
      WRITE(IPR,49) A,B,C,ALPHA,BETA,GAMMA
 49   FORMAT ('CELL',9X,3F8.4,3F9.3)
C      PRINT *,'Space Group ?'
C      READ 50,(IGR(I),I=1,36)
C 50   FORMAT (36A1)
C-----S P C G R P  CARD
      WRITE(IPR,54) (IGR(I),I=1,36)
 54   FORMAT ('SPCGRP',1X,36A1)
C-----A T O M  CARD
      WRITE(IPR,46)
 46   FORMAT ('ATOM   MN   10.1240  0.1760  0.2259  0.73')
C-----END  CARD
      WRITE(IPR,47)
 47   FORMAT ('END')
C-----FINISH  CARD
      WRITE(IPR,48)
 48   FORMAT ('FINISH')
	RETURN
	END
C
C      ERAPRE
C
      SUBROUTINE ERAPRE(file,npat,celpre,P,Q,R,SLABDA,IGR,KXR)
C
C    MAXI 60000 HKL    
C    MAXI OVERLAP 20000 HKL    
C         1200 Points on each pattern
C
      character*20 file
      character*24 temp,fiche
      logical qex
      DIMENSION A(3,3),SLABDA(3),PLOR(3,60000),IH(3,
     260000),IHIGH(3,10),INDEX(3,60000),LOW(3,10),
     3YY(3,1200),MULT(60000),ICM(3,60000),IHT(3,60000),
     4IHILO(3,1200),INB(3),OLIM(3),PI(3),TL(3,60000)
      DIMENSION MMM(3),SCALE(3),N(3),MAXR(3),KXR(3)
      DIMENSION BCELL(3,3),TT(3,60000),LL(3,60000),NCU(3)
      DIMENSION WDT(3),ICODE(3),IALFA(3),ISTAP(3),IOMEG(3)
      DIMENSION P(3),Q(3),R(3),HWL(3,60000),CELPRE(6),IGR(36)
      COMMON IKK
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM, 
     2 MNEQPO,MNOVRF,MNPATS
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)      
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
	RAD=3.14159265359/36000.
14    FORMAT(A24)
C      PRINT *,FILE
      lfile=len(FILE)
      do while (FILE(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
      temp=file(1:lfile)//'.pre'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 6000
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(22,temp)
6000  if(IF3.EQ.0)call open_write2(22,temp)
      if(IF3.EQ.1)call open_write1(22,temp)
	IPR=14
      temp=file(1:lfile)//'.out'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 6001
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(ipr,temp)
6001  if(if1.eq.1)call open_write1(ipr,temp)
      if(if1.eq.0)call open_write2(ipr,temp)
10    WRITE(IPR,650)             
      WRITE(IPR,910)(TEXT(I),I=1,20)
      NKEY=0          
32      FORMAT(10X,I4)
      IKK=0
C	READ(13,*)NPAT
      IF(NPAT.EQ.0)NPAT=1
      CALL DUMP(12345.)
      WRITE(IPR,920) 
      CALL CELL(A,CELPRE,LPR) 
      DO 30 J=1,3    
      DO 30 K=1,3    
30    BCELL(K,J)=A(K,J)
C.....READ AND PRINT WAVELENGTH(S),ZEROPOINT.....
	DO 40 I=1,NPAT
C	N(I)=NREF
C	READ(LCA,*)WDT(I),P(I),Q(I),R(I)
      WDT(I)=4.0
      WRITE(IPR,810)SLABDA(I)
C      IF(WDT(I).LT..001)WDT(I)=1.5
      WRITE(IPR,70)WDT(I),P(I),Q(I),R(I)
40    CONTINUE
60    FORMAT(35H Weights calculated from W=250/I+B+,F6.0,3H**2) 
70    FORMAT(23H Base of Peak = 2.0*HW*,F8.2/
     1' HALFWIDTH PARAMETERS U,V,W *10000.'3F14.1)                   
80    FORMAT(28H Absorption Correction=-0.1*,F8.4,11H*sin 2theta)
	DO 120 J=1,NPAT
	READ(LCA,*)NN
	NCU(J)=NN
	IF(NN.EQ.0)GO TO 120
	DO 119 II=1,NN
	READ(LCA,*)LOW(J,II),IHIGH(J,II)
119   CONTINUE
      WRITE(IPR,880)    
      WRITE(IPR,890)(LOW(J,I),IHIGH(J,I),I=1,NCU(J))
200   IF(NCU(J).EQ.0)WRITE(IPR,870)
120   CONTINUE
	DO 210 I=1,NPAT
C	READ(LCA,*)ICODE(I),SCALE(I)
      ICODE(I)=KXR(I)
	READ(LCA,*)SCALE(I)
210   CONTINUE
      I=1
      SABDA=10.
      DMIN=100.0
	DO 211 KKK=1,NPAT
      THET=LOW(KKK,NCU(KKK))
      DDD=SLABDA(KKK)/(2.*SIN(RAD*THET))
      IF(DDD.LT.DMIN)KKKK=KKK
      IF(DDD.LT.DMIN)DMIN=DDD
C      PRINT *,'thet, ddd, KKKK  ',THET,DDD,KKKK
211   ICODE(KKK)=ICODE(KKK)+10*KKK
C
C.....PREPARE REFLEXIONS
C
C.....OMEG is max angle for hkl in theta
C
      SABDA=SLABDA(KKKK)
      
      OMEG=LOW(KKKK,NCU(KKKK))
      OMEG=OMEG/200.+15.
      IF(OMEG.GT.85.)OMEG=85.
C      PRINT *,'OMEG = ',OMEG
C
C
      N=0
      CALL LAZYR(SABDA,OMEG,CELPRE,IGR)
      REWIND 36
	READ(36,*)NREF
C	PRINT 5000,NREF
C5000  FORMAT('  Number of hkl reflexions:',I5)
C	PRINT 5001
C5001  FORMAT(' New Number of reflexions?',$)
C	READ *,NREF
      NREF=NREF/5
      NREF=NREF*5
      IF(NREF.GT.60000)NREF=60000
C	PRINT 1
C1       FORMAT(' Number of overlapping reflexions (<20000) ?',$)
	MNOVRF=20000
	OVRF=MNOVRF
C
C
C
	N(1)=NREF
	N(2)=NREF
	N(3)=NREF
C
C
C
	JJ=1
212   J=JJ-(JJ-1)/5*5
	JJ9=JJ+4
      IF(J.EQ.1)READ(36,*)((IH(K,J),K=1,3),MULT(J),J=JJ,JJ9)
	DO 261 KKK=1,NPAT
      D=0.                               
      ICM(KKK,JJ)=100*ICODE(KKK)+MULT(JJ)
      KJ=ICODE(KKK)/10
      IC=ICODE(KKK)-10*KJ
      ICODD=IC   
      DO 230 JI=1,3          
      DO 230 K=JI,3          
230   D=BCELL(JI,K)*IH(JI,JJ)*IH(K,JJ)+D
      DLABDA=0.25*SLABDA(KKK)*SLABDA(KKK)
      D=DLABDA*D    
      IF(D-1.)250,250,240
240   N(KKK)=N(KKK)-1
      GO TO 261
250   CONTINUE
      PLOR(KKK,JJ)=1./(2.*D*SQRT(1.-D))
      TAN=SQRT(D/(1.-D))                                             
      LL(KKK,JJ)=JJ
      TL(KKK,JJ)=ATAN(TAN)/RAD 
      HWL(KKK,JJ)=SQRT(P(KKK)*TAN*TAN+Q(KKK)*TAN+R(KKK))
      INDEX(KKK,JJ)=0 
261   CONTINUE
      JJ=JJ+1
      IF(JJ-NREF)212,212,260
260   CONTINUE
      DO 262 KKK=1,NPAT      
      NREFP=NREF-N(KKK)        
      WRITE(IPR,270)NREFP,KKK
270   FORMAT(1H0,I5,' REFLECTIONS REJECTED WITH SINE THETA GREATER THAN
     2 1.0 FOR PATTERN ',I5)      
262     CONTINUE
	DO 271 III=1,NPAT
	IPRR=IPR+III
C	PRINT 272,III
C272     FORMAT('  Intensity file number ',I2,' ?',$)
	READ(LCA,14)FICHE
      lfile=len(FICHE)
      do while (FICHE(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
        CALL OPEN_READ1(IPRR,FICHE(1:lfile))
	READ(IPRR,*)MMM(III),ALPHA,STAP
	IALFA(III)=ALPHA*100.+0.5
	ISTAP(III)=STAP*100.+0.5
	IOMEG(III)=IALFA(III)+(MMM(III)-1)*ISTAP(III)+0.5
	DO 279 IIK=1,NCU(III)
	IF(LOW(III,IIK).LE.IALFA(III))LOW(III,IIK)=IALFA(III)
	IF(IHIGH(III,IIK).LE.IALFA(III))IHIGH(III,IIK)=LOW(III,IIK)
	IF(LOW(III,IIK).GE.IOMEG(III))LOW(III,IIK)=IOMEG(III)
	IF(IHIGH(III,IIK).GE.IOMEG(III))IHIGH(III,IIK)=IOMEG(III)
279     CONTINUE
      MAXR(III)=N(III)
      PI(III)=FLOAT(ISTAP(III))/(100.*SQRT(RAD))
      JJ=1
      I=1
      MINR=1
      IS=IALFA(III)
280   CONTINUE     
290   J=JJ-(JJ-1)/10*10
	JJ9=JJ+9
	IF(J.EQ.1)READ(IPRR,*)(YY(III,J),J=JJ,JJ9)
300     Y=YY(III,JJ)    
      IHT(III,JJ)=IALFA(III)+ISTAP(III)*(JJ-1)
	IS=IHT(III,JJ)
      LOWJ=0                 
      IHIGHJ=0               
      IF(NCU(III))330,330,310     
310   DO 320 J=1,NCU(III)         
      IF(IS.GE.LOW(III,J).AND.IS.LE.IHIGH(III,J))Y=0.
320   YY(III,JJ)=Y
330   IF(Y.EQ.0.)GOTO 390    
      MARK=0                 
C.....DETERMINE WHAT REFLECTIONS CAN CONTRIBUTE TO INTENSITY I.E. ARE
C     WITHIN WDT*HALFWIDTH FROM INTENSITY POSITION.
      DO 370 J=MINR,MAXR(III)     
      LLS=LL(III,J)              
      WIDTH=HWL(III,LLS)*WDT(III)     
      ST=TL(III,LLS)             
      MIN=ST-WIDTH-0.5        
      MAX=ST+WIDTH+0.5    
C       IF(IS.LT.MIN)GO TO 360
C       IF(IS.GT.MAX)GO TO 360
      IF(.NOT.((IS.GE.MIN).AND.(IS.LE.MAX)))GO TO 360
      IF(MARK)350,340,350
340   I=J                 
      LOWJ=J              
      MARK=1              
350   INDEX(III,J)=-1
      GOTO 370            
360   IF(MARK.EQ.1)GOTO 380
370   CONTINUE             
380   IF(MARK.EQ.1)IHIGHJ=J-1
      MINR=I                 
390   IS=IS+ISTAP(III)            
      IDELT=IHIGHJ-LOWJ      
      IHILO(III,JJ)=100000*IDELT+LOWJ
      JJ=JJ+1                   
      IF(IS-IOMEG(III))280,280,273
273   CONTINUE
      OLIM(III)=1.
      JJ1=JJ-1                  
      DO 410 I=1,JJ1            
      LOWJ=MOD(IHILO(III,I),100000)  
      IDELT=IHILO(III,I)/100000      
      IHIGHJ=LOWJ+IDELT         
      IF(LOWJ.EQ.0)YY(III,I)=0.     
      Y=IHIGHJ-LOWJ             
410   IF(Y.GT.OLIM(III))OLIM(III)=Y       
      OLIM(III)=OLIM(III)+1.
      IF(OLIM(III).GT.OVRF)OLIM(III)=OVRF   
      INB(III)=0                       
      DO 420 IS=1,N(III)             
      IF(INDEX(III,IS).EQ.-1)INB(III)=INB(III)+1
420   CONTINUE
271     CONTINUE
	OLI=0.
	INBB=0.
	DO 274 III=1,NPAT
	OLI=AMAX1(OLI,OLIM(III))
274     INBB=INBB+INB(III)
      CALL DUMP(OLI)
      CALL DUMP(FLOAT(INBB))       
      I=0
	DO 471 III=1,NPAT
      DO 470 IS=1,N(III)  
      LLS=LL(III,IS)                
      M=MOD(ICM(III,LLS),100)       
      ICODE(III)=ICM(III,LLS)/100        
      IZ=0     !!!!!!!!!!!!!!!!!!!! AU LIEU DE 0                      
      IF(INDEX(III,IS).EQ.-1)IZ=1   
      IF(IZ-1)460,440,460  !!!!!!!!!!!!!!!!!!!!!       
440   I=I+1                     
      TT(III,IS)=I                  
      CALL DUMP(FLOAT(ICODE(III)))   
      DO 450 J=1,3              
450   CALL DUMP(FLOAT(IH(J,LLS)))
      XX=FLOAT(M)*PI(III)*PLOR(III,LLS)
      CALL DUMP(XX)              
      GOTO 470
460   TT(III,IS)=0.
470   CONTINUE
471     CONTINUE
	DO 472 II=1,NPAT
      WRITE(IPR,900)IALFA(II),IOMEG(II),ISTAP(II)    
      LIMO=OLIM(II)+0.5                 
      WRITE(IPR,760)
      CALL DUMP(FLOAT(IALFA(II)))    
      CALL DUMP(FLOAT(ISTAP(II)))    
      CALL DUMP(FLOAT(IOMEG(II)))
      JJ=1         
      IZ=0         
      NZ=0         
480   Y=YY(II,JJ)/SCALE(II)
      LOWJ=MOD(IHILO(II,JJ),100000)
      IDELT=IHILO(II,JJ)/100000    
      IHIGHJ=LOWJ+IDELT        
      I=IHT(II,JJ) 
      IF(Y)500,490,500         
490   NZ=NZ+1                  
      IZ=1                     
      CALL DUMP(0.)            
      CALL DUMP(FLOAT(I)) 
      GOTO 630            
500   CONTINUE            
530   CONTINUE          
      W=250./(Y)     
      YL=Y
      IF(YL.EQ.0.)YL=1.     
      L=0                   
      III=0                 
540   IF(IZ-1)600,550,600   
550   IF(NZ-4)560,560,570   
560   WRITE(IPR,770)(III,K=1,NZ)
      GOTO 580                
570   WRITE(IPR,770)(III,K=1,2) 
      NZ4=NZ-4                
      WRITE(IPR,780)NZ4         
      WRITE(IPR,770)(III,K=1,2) 
580   IF(I-IOMEG(II))590,590,472  
590   IZ=0                    
      NZ=0                    
600   CALL DUMP(YL)           
      CALL DUMP(W)
      K1=LOWJ            
      K1=TT(II,K1)+0.5      
      K2=IHIGHJ          
      K2=TT(II,K2)+0.5      
      KD=K2-K1+1         
      IF(KD.LE.MNOVRF)GOTO 620 
      WRITE(IPR,610)K1,K2    
610   FORMAT(6H Refl ,I5,14H Through Refl ,I5,
     2 59Hcontribute to this observation, only 20000 of these are used)
      K1=K1+(KD-MNOVRF)/2                         
      K2=K2-(KD-MNOVRF-1)/2                         
620   CALL DUMP(FLOAT(K1))                    
      CALL DUMP(FLOAT(K2))                    
      CALL DUMP(FLOAT(I))      
      WRITE(IPR,790)I,Y,YL,W,K1,K2   
630   I=I+ISTAP(II)                  
      JJ=JJ+1                    
      IF(I.LE.IOMEG(II))GOTO 480     
      IF(IZ.EQ.1)GOTO 540
472     CONTINUE
640     CALL DUMP(-12345.)
      WRITE(IPR,800)         
650   FORMAT(16H0PREPARATION FOR)
670   FORMAT(20A4)                                                    
680   FORMAT(51H0   No.  Code    h   k   l   Mult     hw       posn)  
690   FORMAT(8X,I4,2X,3I4) 
700   FORMAT(5I8)          
710   FORMAT(3I8)          
720   FORMAT(10(I2,F6.0))  
730   FORMAT(1X,I5,I6,2X,3I4,I6,F9.1,F11.1)     
740   FORMAT(7H    ***,I6,2X,3I4,I6,F9.1,F11.1) 
750   FORMAT(1H0,3I6)                           
760   FORMAT('   Posn   I+B      B     I       W ')
770   FORMAT(1X,I12)                           
780   FORMAT(6X,1H(,I4,7H Zeros))              
790   FORMAT(1X,I6,2F7.0,F9.4,2I7/37X,20I4)   
800   FORMAT(1X,70(1H+))                      
810   FORMAT(15H0Wavelength(s)=,2F7.4)      
830   FORMAT(22H0Halfwidth Parameters ,1X,11Hfor Pattern,I2)
840   FORMAT(3H U=,F9.1,3X,2HV=,F9.1,3X,2HW=,F9.1)          
850   FORMAT(12H0Background=/9H Position,4X,9HIntensity)    
860   FORMAT(1X,F7.0,6X,F6.0)                        
870   FORMAT(21H0NO Excluded Regions.)               
880   FORMAT(18H0Excluded Regions=/5H from,5X,2Hto)  
890   FORMAT(1X,I6,4X,I6)                            
900   FORMAT(13H0Diagram from,I6,1X,2Hto,I6,1X,11Hin steps of,I3,1X,
     2 15H1/100ths degree,/,                                       
     3 41H0If IALFA = 1, angles are on input cards.) 
910   FORMAT(1X,20A4)      
920   FORMAT(1X,29(1H-))   
930   FORMAT(1X,35(1H-))   
940   FORMAT(I8,F8.0)      
950   FORMAT(//,28H Cell Dimensions for Pattern,I2)
C      PRINT *,'END'
      RETURN
      END                                          
      SUBROUTINE CELL(X,CELPRE,LPR)
      DIMENSION X(3,3),CELPRE(6)
      RAD=3.14159265359/180.             
C      READ(13,*)A,B,C,D,E,F
      A=CELPRE(1)
      B=CELPRE(2)
      C=CELPRE(3)
      D=CELPRE(4)
      E=CELPRE(5)
      F=CELPRE(6)
      ISW=0       
      IPR=14
      IF(A.LT.1.)ISW=1 
      IF(ISW.EQ.0)GOTO 10
      X(1,1)=A  
      X(2,2)=B  
      X(3,3)=C  
      X(1,2)=F  
      X(1,3)=E  
      X(2,3)=D  
      A=SQRT(A) 
      B=SQRT(B) 
      C=SQRT(C) 
      COSA=D/(2.*B*C) 
      COSB=E/(2.*A*C) 
      COSC=F/(2.*A*B) 
      GOTO 20         
10    COSA=COS(RAD*D) 
      COSB=COS(RAD*E) 
      COSC=COS(RAD*F) 
20    SINA=SQRT(1.-COSA*COSA) 
      SINB=SQRT(1.-COSB*COSB) 
      SINC=SQRT(1.-COSC*COSC) 
      V=A*B*C*SQRT(1.-COSA*COSA-COSB*COSB-COSC*COSC+2.*COSA*COSB*COSC)
      AS=B*C*SINA/V                       
      BS=C*A*SINB/V                       
      CS=A*B*SINC/V                       
      COSAS=(COSB*COSC-COSA)/(SINB*SINC)  
      COSBS=(COSC*COSA-COSB)/(SINC*SINA)  
      COSCS=(COSA*COSB-COSC)/(SINA*SINB)  
      IF(ISW.EQ.0)GOTO 30
      A=AS    
      B=BS    
      C=CS    
      D=ATAN2(SQRT(1.-COSAS*COSAS),COSAS)/RAD 
      E=ATAN2(SQRT(1.-COSBS*COSBS),COSBS)/RAD 
      F=ATAN2(SQRT(1.-COSCS*COSCS),COSCS)/RAD 
      GOTO 40         
30    X(1,1)=AS*AS    
      X(2,2)=BS*BS    
      X(3,3)=CS*CS    
      X(1,2)=2.*AS*BS*COSCS 
      X(1,3)=2.*AS*CS*COSBS 
      X(2,3)=2.*BS*CS*COSAS 
40    WRITE(IPR,50)A,B,C,D,E,F
50    FORMAT(3H A=,F8.4,6X,2HB=,F8.4,6X,2HC=,F8.4/7H ALPHA=,F7.3,3X,
     2 5HBETA=,F7.3,4X,6HGAMMA=,F7.3)                               
      RETURN                                                        
      END                                                           
      SUBROUTINE DUMP(X)
      DIMENSION DUMPA(500),TEXT(20)
      COMMON IKK
      IKK=IKK+1
      DUMPA(IKK)=X              
      IF(IKK.NE.500)GOTO 20     
      WRITE(22,*)(DUMPA(I),I=1,500)            
      IKK=0                     
20    IF(X.NE.-12345.)GOTO 30  
      WRITE(22,*)(DUMPA(I),I=1,500)
      DUMPA(1)=-12345.
      WRITE(22,*)(DUMPA(I),I=1,500)    
      ENDFILE 22          
      REWIND 22           
30    RETURN             
      END                
*
*
*
      SUBROUTINE DATOUT(XL,LPT)
      DIMENSION XL(110,14)
      COMMON /RCEE/ RCE(3,6)
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     1ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),
     1    CELLN(6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /NUMB/ N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
	DO 940 J=1,N
	WRITE(LPT,938)ATEXT(J)
940     WRITE(LPT,8000)NTYP(J),(XL(J,I),I=1,4)
8000  FORMAT(I2,4F9.5)
938   FORMAT(A4)
 1120 DO 1185 NP=1,NPAT
      N1=N+NP
      N3=N6+NP
 1180 WRITE(LPT,8001)XL(N1,3),XL(N3,1),XL(N3,2),XL(N3,3)
 1185 CONTINUE
      WRITE(LPT,8002) (RCE(1,I),I=1,6)
8001  FORMAT(1X,F12.5,3F12.1)
8002  FORMAT(1X,6F12.5)
      RETURN                                         
      END
      SUBROUTINE FLEES(AA,DUMPA)
      DIMENSION DUMPA(500)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LT9,LPUN    
      LLL=LLL+1                 
      AA=DUMPA(LLL) 
      IF(LLL.NE.500)GOTO 10     
      READ(LPRE,*,END=20)(DUMPA(I),I=1,500)    
      NKEY=NKEY+1               
      LLL=0                 
20    CONTINUE
10    RETURN                
      END                   
      SUBROUTINE PERM(I,J,K)
      IF(I-2)10,20,30    
10    J=2        
      K=3        
      RETURN     
20    J=3        
      K=1        
      RETURN     
30    J=1        
      K=2        
      RETURN     
      END        
      SUBROUTINE TRCL(CELLN,RCELLN,V)
      DIMENSION CELLN(6),RCELLN(6)
      DIMENSION SINA(3)
      ABC=1.0        
      PROD=2.0       
      V=-2.0
      DO 10 I=1,3    
      L=I+3          
      SINA(I)=1.0-CELLN(L)**2
      V=V+SINA(I)       
      SINA(I)=SQRT(SINA(I))     
      PROD=PROD*CELLN(L)     
10    ABC=ABC*CELLN(I)       
      V=ABC*SQRT(V+PROD)
      DO 20 I=1,3               
      CALL PERM(I,J,K)          
      RCELLN(I)=CELLN(J)*CELLN(K)*SINA(I)/V
      L=I+3                                              
20    RCELLN(L)=(CELLN(J+3)*CELLN(K+3)-CELLN(L))/(SINA(J) 
     2*SINA(K))
      RETURN                               
      END
      SUBROUTINE REPCEL(RCELLN,AL)
      DIMENSION RCELLN(6),AL(3,3)
      DO 10 I=1,3                    
10    RCELLN(I)=SQRT(AL(I,I))  
      DO 40 I=1,3         
      CALL PERM(I,J,K)    
      IF(J-K)30,40,20   
20    M=K               
      K=J               
      J=M               
30    RCELLN(I+3)=0.5*AL(J,K)/(RCELLN(J)*RCELLN(K))  
40    CONTINUE
      RETURN                                                
      END                                                   
      SUBROUTINE SHIFT(XL)
      DIMENSION XL(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      DO 40 NP=1,NPAT     
      N1=N+NP
      N3=N6+NP          
      AH(NP)=XL(N3,1)
      BH(NP)=XL(N3,2)
      CH(NP)=XL(N3,3)
40    SCALE(NP)=1.0/XL(N1,3)
      N2=N7+1
      DO 30 I=1,3              
      AL(I,I)=XL(N2,I)      
      CALL PERM(I,J,K)       
      IF(J-K)10,20,20        
10    AL(J,K)=XL(N2,I+3)  
      GOTO 30                
20    AL(K,J)=XL(N2,I+3)  
30    CONTINUE
      RETURN                 
      END                    
      SUBROUTINE PARS(I,NPAR)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      IF(I-N)10,10,60       
10    CONTINUE
20    NPAR=8   
      RETURN   
50    NPAR=10  
      RETURN   
60    IF(I-N6)50,70,80
70    NPAR=3          
      RETURN          
80    IF(I-N7)90,90,100
90    NPAR=3   
      RETURN   
100   NPAR=6   
      RETURN   
      END      
      SUBROUTINE XCOPY(KK,CHAR,DUM) 
      DIMENSION DUM(70) 
      KK=KK+1           
      DUM(KK)=CHAR      
      RETURN            
      END               
      SUBROUTINE LOC(I,J,NU,MATORD) 
      IF(J.GE.I)GOTO 10   
      K=J                 
      J=I              
      I=K              
10    L=I-1            
      NU=MOD(L,2)      
      IF(NU)30,20,30   
20    NU=-(L*L+L)/2    
      GOTO 40          
30    NU=-L*(L/2+1)    
40    NU=NU+L*(MATORD+1)
      NU=NU+J-I+1       
      RETURN            
      END
      FUNCTION CIGN(A,B)          
      IF(B)10,20,10           
10    C=B                
      GOTO 30            
20    C=1.0              
30    CIGN=SIGN(A,C)     
      RETURN             
      END                
      SUBROUTINE CLEAR(SMM)
      DIMENSION SMM(2485)
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      SW=0.0      
      SUMAW=0.0   
      SUMW=0.0    
      DO 400 J=1,3  
      SUMOBS(J)=0.0  
400   SUMDIF(J)=0.0  
      SOM=0.0
      IF(NCYCLE.EQ.0)RETURN 
      DO 10 I=1,MATORD      
10    V(I)=0.0              
      DO 20 I=1,MATSIZ      
20    SMM(I)=0.0            
      RETURN                
      END
C
C
C
      SUBROUTINE DATAIN(FILE,LFILE,XL,FLAG,LP,S,F,DUMPA,SM,T,LG)
      CHARACTER*20 FILE
      character*24 temp
      logical qex
      CHARACTER*4 TABNC(128),TBXC(256),NAMB(8),NAMX(8)
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128)
      DIMENSION HH(3),XL(110,14),LP(110,14),FLAG(110,14)
	DIMENSION IGR(36),QLABDA(3),WDT(3),P1(3),Q1(3),R1(3)
      DIMENSION NDD(3),ND1(3),ND2(3),CELPRE(6)
      DIMENSION DUMPA(500),S(3,4,21),F(3,4,21),SM(24,3,3),T(24,3)
      DIMENSION FA(4,10,3),FB(4,10,3),FC(10,3),DELFR(10,3)
      COMMON /LAZY/ ASS(24,3,3),ATS(24,3),IASYM,IABRA,NAG
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     1ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),
     1CELLN(6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /MINIM/ DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /MAXDIM/ MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     1MNEQPO,MNOVRF,MNPATS
      COMMON /CONTRL/ NCYCLE,MAXS,KXR(3),KKZ,
     1ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     2ICYCLE,KLOOP,LINES
      COMMON /MATR/ MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /NUMB/ N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /RELX/ RELAXB,RELAXC,RELAXS,RELAXH
      COMMON /INPUT/ NPOINT,MODE,LINO,READIN(6)
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
      DO 10 I=1,110
      DO 10 J=1,14
      FLAG(I,J)=0.
      LP(I,J)=0
10    XL(I,J)=0.
      READ(LCA,1) TEXT
      READ(LCA,*)NCYCLE,NPAT,MAXS,LG,IF1,IF2,IF3,IF4,IF5,IF6
      IF(NCYCLE.EQ.0)MAXS=0
      LPR=21
      temp=file(1:lfile)//'.imp'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 2200
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(21,temp)
2200  call open_write1(21,temp)
      LT4=23
      temp=file(1:lfile)//'.lt4'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 2201
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(23,temp)
2201  if(if6.eq.0)call open_write2(23,temp)
      if(if6.eq.1)call open_write1(23,temp)
      LT8=24
      temp=file(1:lfile)//'.lt8'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 2202
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(24,temp)
2202  call open_write2(24,temp)
      LPT=27
      temp=file(1:lfile)//'.par'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.) go to 2203
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(27,temp)
2203  call open_write1(27,temp)
C
C
C
      DO 25 NP=1,NPAT
      READ(LCA,6) (PTEXT(NP,J),J=1,4)
   25 CONTINUE
      READ(LCA,*)(KXR(NP),NP=1,NPAT)
      DO 30  NP=1,NPAT
      KXRNP=KXRNP+KXR(NP)
   30 CONTINUE
      N1=0 
      N2=0
      READ(LCA,*)NA,KL
      N=NA
      KM=KL
      KLL=KL
      KMN=KM
   40 CONTINUE
      N4=N+3*NPAT+1
      N6=N+NPAT+1
      N7=N6+NPAT
      IF(KMN) 50,50,60
   50 KLOOP=1
      GOTO 70
   60 KLOOP=KMN
70    READ(LCA,*)(DLABDA(NP),NP=1,NPAT)
100   CONTINUE
      READ(LCA,*)RELAXC,RELAXB,RELAXS,RELAXH
      IF(RELAXC.LE.0.0) RELAXC=0.8
      IF(RELAXB.LE.0.0) RELAXB=0.8
      IF(RELAXS.LE.0.0) RELAXS=0.8
      IF(RELAXH.LE.0.0) RELAXH=0.8
  190 CONTINUE
      WRITE(LPR,161) TEXT
      WRITE(LPR,41)NCYCLE,MAXS,NPAT
      WRITE(LPR,2051) RELAXC,RELAXB,RELAXS,RELAXH
      DO 750 NP=1,NPAT
      WRITE(LPR,235) NP,(PTEXT(NP,J),J=1,4)
750   WRITE(LPR,21) DLABDA(NP)
235   FORMAT(/,1X,30(1H*),/,1X,1H*,7HPATTERN,I2,2X,4A4,1X,1H*,/,1X,
     A30(1H*))
185   DO 186 I=1,NPAT
      QLABDA(I)=DLABDA(I)
186   DLABDA(I)=0.25*DLABDA(I)*DLABDA(I)
C
C.....READ SPACE GROUP FOR PHASE NP
C
      READ(LCA,479)(IGR(IR),IR=1,36)
  479 FORMAT(36A1)
      WRITE(LPR,478)(IGR(IR),IR=1,36)
  478 FORMAT(/'  SPACE GROUP  : ',36A1)
7500  DO 562 J=1,NPAT
      IF(KXR(J).EQ.4) GO TO 559
560   READ(LCA,*)(B(J,I),I=1,KLL)
      GO TO 562
559   READ(LCA,*)(B(J,I),I=1,KMN)
      DO 561 I=1,KMN
561   READ(LCA,*)(FA(L,I,J),FB(L,I,J),L=1,4),FC(I,J),DELFR(I,J)
562   CONTINUE
      DO 788 J=1,NPAT
790   WRITE(LPR,56) (B(J,I),I,I=1,KLL)
      IF(KXR(J).EQ.4)GO TO 810
      GO TO 788
810   DO 812 I=1,KMN
812   WRITE(LPR,62)(FA(L,I,J),FB(L,I,J),L=1,4),FC(I,J),DELFR(I,J)
788   CONTINUE
930   CONTINUE
      WRITE(LPR,57)
      MODE=0
938   FORMAT(A4)
      DO 940 J=1,N
      READ(LCA,938)ATEXT(J)
940   READ(LCA,*)NTYP(J),(XL(J,I),I=1,4)
      CTOT=0.
      DO 1970 J=1,N
      CTOT=CTOT+XL(J,4)
1970  CONTINUE
      WRITE(LPR,171) (ATEXT(I),NTYP(I),(XL(I,J),J=1,4),I=1,N)
 1120 DO 1185 NP=1,NPAT
      N1=N+NP
      N3=N6+NP
      READ(LCA,*)XL(N1,3),XL(N3,1),XL(N3,2),XL(N3,3)
      P1(NP)=XL(N3,1)
      Q1(NP)=XL(N3,2)
      R1(NP)=XL(N3,3)
 1180 WRITE(LPR,66) XL(N1,3)
      WRITE(LPR,68)XL(N3,1),XL(N3,2),XL(N3,3)
 1185 CONTINUE
      N2=N7+1
      CALL DCELL(CELPRE)
      DO 1200 I=1,3
 1200 XL(N2,I)=AL(I,I)
      XL(N2,4)=AL(2,3)
      XL(N2,5)=AL(1,3)
      XL(N2,6)=AL(1,2)
 1210 WRITE(LPR,76) (XL(N2,I),I=1,6)
C
C
      CALL ERAPRE(file,npat,celpre,P1,Q1,R1,QLABDA,IGR,KXR)
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
	 lfile=lfile-1
      enddo
      LPRE=22
  200 READ(LPRE,*,END=220)(DUMPA(I),I=1,500)
C     COUNTERS FOR INPUT BLOCK TRANSFERS;
C     LLL=MAX. NO. OF OVERLAPPING REFLECTIONS
C     NKEY=(NO. OF BLOCKS TRANSFERRED)+1
  210 LLL=2
      NKEY=1
  220 CONTINUE
C
C
      CALL FLEES(AA,DUMPA)
      NN=AA+0.5
      NN5=NN*5+3
C
C.....BUILD AND PRINT OF SYMMETRY MATRICES
C
C      DO 740 NP=1,NPAT
      IRLL=NAG
C   IF BRAVAIS LATTICE A,B,C, THEN ADD SYMMETRY WITH TRANSLATION
C                IABRA=5,6,7
      GO TO(7199,7199,7199,7199,7100,7120,7130),IABRA
      GO TO 7199
7100  IRLL=IRLL*2
      DO 7101 IR=NAG+1,IRLL
      DO 7101 I=1,3
      DO 7101 J=1,3
      IRR=IR-NAG
7101  ASS(IR,I,J)=ASS(IRR,I,J)
      DO 7102 IR=NAG+1,IRLL
      IRR=IR-NAG
      ATS(IR,1)=ATS(IRR,1)
      ATS(IR,2)=ATS(IRR,2)+0.5
7102  ATS(IR,3)=ATS(IRR,3)+0.5
      GO TO 7199
7120  IRLL=IRLL*2
      DO 7121 IR=NAG+1,IRLL
      DO 7121 I=1,3
      DO 7121 J=1,3
      IRR=IR-NAG
7121  ASS(IR,I,J)=ASS(IRR,I,J)
      DO 7122 IR=NAG+1,IRLL
      IRR=IR-NAG
      ATS(IR,1)=ATS(IRR,1)+0.5
      ATS(IR,2)=ATS(IRR,2)
7122  ATS(IR,3)=ATS(IRR,3)+0.5
      GO TO 7199
7130  IRLL=IRLL*2
      DO 7131 IR=NAG+1,IRLL
      DO 7131 I=1,3
      DO 7131 J=1,3
      IRR=IR-NAG
7131  ASS(IR,I,J)=ASS(IRR,I,J)
      DO 7132 IR=NAG+1,IRLL
      IRR=IR-NAG
      ATS(IR,1)=ATS(IRR,1)+0.5
      ATS(IR,2)=ATS(IRR,2)+0.5
7132  ATS(IR,3)=ATS(IRR,3)
7199  IRL=IRLL
      DO 7200 IR=1,IRL
      DO 7200 I=1,3
      T(IR,I)=ATS(IR,I)
      DO 7200 J=1,3
7200  SM(IR,I,J)=ASS(IR,I,J)
      ICENTT=IASYM+1
      ICENT=ICENTT
691	FORMAT(2X,I4)
      IF(ICENT.EQ.2) GOTO 690
      WRITE(LPR,301)
      GOTO 700
  690 WRITE(LPR,303)
  700 IF(IRL-2) 751,710,710
  710 WRITE(LPR,49)
C      WRITE(LPR,1611)
      DO 740 IR=1,IRL
      WRITE(LPR,152) IR,((SM(IR,I,J),J=1,3),I=1,3),(T(IR,I),I=1,3)
  740 CONTINUE
C MODIF...
  751 CONTINUE
C
C
C
 1315 CONTINUE
      IF(NCYCLE.LE.0)GOTO 1660
      WRITE(LPR,82)
      DO 1380 I=1,N
      READ(LCA,*)(FLAG(I,J),J=1,4)
 1380 CONTINUE
      WRITE(LPR,85) (ATEXT(I),(FLAG(I,J),J=1,4),I=1,N)
 1420 DO 1560 NP=1,NPAT
      N1=N+NP
      READ(LCA,*)FLAG(N1,3)
 1465 WRITE(LPR,89) FLAG(N1,3)
 1560 CONTINUE
      DO 1570 NP=1,NPAT
      N3=N6+NP
      READ(LCA,*)FLAG(N3,1),FLAG(N3,2),FLAG(N3,3)
      WRITE(LPR,91)FLAG(N3,1),FLAG(N3,2),FLAG(N3,3)
 1570 CONTINUE
      N2=N7+1
      READ(LCA,*)(FLAG(N2,J),J=1,6)
      WRITE(LPR,93)(FLAG(N2,J),J=1,6)
      DO 1610 I=1,N4
      CALL PARS(I,NPAR)
      DO 1600 J=1,NPAR
      X=FLAG(I,J)
      Y=INT(ABS(X))/10
      LP(I,J)=Y+0.5
 1600 FLAG(I,J)=(ABS(X)-10.*Y)*CIGN(1.,X)
 1610 CONTINUE
      MATORD=MAXS
      MATSIZ=MATORD*(MATORD+1)
      MATSIZ=MATSIZ/2
1660  CONTINUE
1680  CALL SHIFT(XL)
      FLOG =4.*ALOG(2.)
      FLOG2=2.*FLOG
      SLOG =1./SQRT(FLOG)
      DO 1960 I=1,NN
      CALL FLEES(AA,DUMPA)
      ICODE=AA+0.5
      ICODD=ICODE/10
      ICODE=ICODE-ICODD*10
      NP  =ICODD
      DO 1830 J=1,3
      CALL FLEES(AA,DUMPA)
1830  HH(J)=AA
      CALL FLEES(AA,DUMPA)
      SJJ=AA
      X=0.
      DO 1840 J=1,3
      DO 1840 K=J,3
 1840 X=AL(J,K)*HH(  J)*HH(  K)+X
      IC=ICODE
      IF(IC.GE.4)IC=1
 1910 X=SQRT(X)*0.5
      FF(1)=0.
      IF(KXR(NP).NE.4)GO TO 1950
 1920 CONTINUE
      DO 1930 J=1,KMN
      FF(J)=0.
      DO 1930 K=1,4
      AR=-FB(K,J,NP)*X**2
      FF(J)=FF(J)+FA(K,J,NP)*EXP(AR)
1930  CONTINUE
      DO 1940 J=1,KMN
1940  FF(J)=FF(J)+DELFR(J,NP)+FC(J,NP)
C
C      CALCUL DE <F**2>
C
      FAC=0.
      DO 1980 J=1,N
      FAC=FAC+XL(J,4)*(FF(NTYP(J))**2+B(NP,NTYP(J))**2)
1980  CONTINUE
      FAC=FAC/CTOT
 1950 WRITE(LT8,*)(HH(J),J=1,3),ICODE,ICODD,SJJ,FAC,(FF(J),J=1,KLOOP)
 1960 CONTINUE                                                         
    1 FORMAT(20A4)                                                     
    6 FORMAT(4A4)                                                      
   21 FORMAT('   WAVELENGTH',F8.5)
   41 FORMAT(1H ,I3,27H CYCLE(S) OF REFINEMENT OF ,I3,13H PARAMETER(S),
     12X,4H FOR,I2,9H PATTERNS)                                        
   49 FORMAT(1H+,38X,33HAND THE EQUIVALENT POSITIONS ARE:)        
   51 FORMAT('  SCATTERING LENGTHS'/)             
   56 FORMAT(1H0,8(F8.4,5H = B(,I1,2H);))                         
   57 FORMAT(/52X,18HINITIAL PARAMETERS   /' ATOM  NTYP',6X
     1,1HX,9X,1HY,9X,1HZ,9X,1HN/)        
   61 FORMAT(11H0ATOM TYPE ,I2)                          
   62 FORMAT(2X,10F10.6)               
   65 FORMAT(A4,I4,5F8.5,2I4,3F8.4)                      
   66 FORMAT(22H0OVERALL SCALE FACTORS,2F12.7)
   68 FORMAT('   U V W     PARAM. ',3F12.4)
   75 FORMAT(6F10.8)                               
   76 FORMAT(16H CELL CONSTANTS ,6X,6F10.7)        
   82 FORMAT(1H ,50X,19HCODING OF VARIABLES/5H ATOM,24X,1HX,9X,1HY,9X,1H 
     1Z,9X,1HN)   
   85 FORMAT(1X,A4,17X,4F10.2)                   
   89 FORMAT(22H0OVERALL SCALE FACTORS,2F10.2)
   91 FORMAT(22H  U V W    PARAMETERS ,3F10.2)   
   93 FORMAT(16H CELL CONSTANTS ,6X,6F10.2)      
  159 FORMAT(30H0REAL X-RAY SCATTERING FACTORS)        
  152 FORMAT(9H0POSITION ,I3,10X,9F6.1,3F10.5)     
  161 FORMAT(/1H ,20X,20A4/)                       
  171 FORMAT(1X,A4,I3,4F10.5)               
  215 FORMAT(32H INCORRECT FILE LOADED ON UNIT 3)         
  301 FORMAT('   NON CENTRO.,')   
  303 FORMAT('   CENTRO.,')
 2051 FORMAT(/,1X,23HRELAXATION FACTORS FOR:,/,      
     A6X,17HATOMIC PARAMETERS,10X,F4.2,/,            
     B6X,19H    UNUSED         ,8X,F4.2,/,           
     C6X,25HSCALE,OCCUPATION         ,2X,F4.2,/,     
     D6X,25HHALFWIDTHS,CELL          ,2X,F4.2)       
      RETURN                                         
      END
      SUBROUTINE DCELL(CELPRE)
      DIMENSION CELPRE(6)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /GEOM/DEGRAD,RADDEG                                       
      COMMON /INPUT/NPOINT,MODE,LINO,READIN(6)
      EQUIVALENCE (VOL,V)  
      DO 10 I=1,3       
      DO 10 J=1,3
10    AL(I,J)=0.0
      READ(LCA,*)(READIN(I),I=1,6)
      DO 11 I=1,6
11    CELPRE(I)=READIN(I)
      IF(READIN(1)-1.0)20,60,60 
20    ICELL=1                   
      DO 50 I=1,3               
      AL(I,I)=READIN(I)      
      CALL PERM(I,J,K)          
      IF(J-K)30,40,40           
30    AL(J,K)=READIN(I+3)    
      GOTO 50                   
40    AL(K,J)=READIN(I+3)    
50    CONTINUE               
      GOTO 140               
60    ICELL=0                
      DO 70 I=1,6            
      CELLN(I)=READIN(I)  
70    CONTINUE               
      DO 100 I=1,3           
      L=I+3                  
      IF(CELLN(L)-90.0)90,80,90
80    CELLN(L)=0.0             
      GOTO 100                    
90    CELLN(L)=COS(DEGRAD*CELLN(L)) 
100   CONTINUE                            
      CALL TRCL(CELLN,RCELLN,V)        
      DO 130 I=1,3                        
      AL(I,I)=RCELLN(I)*RCELLN(I)
      CALL PERM(I,J,K)                    
      IF(J-K)110,120,120                  
110   AL(J,K)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
      GOTO 130                                               
120   AL(K,J)=2.0*RCELLN(J)*RCELLN(K)*RCELLN(I+3)
130   CONTINUE
      RETURN                        
140   CALL REPCEL(RCELLN,AL)     
      CALL TRCL(RCELLN,CELLN,V)  
      V=1.0/V               
      RETURN                        
      END                           
      SUBROUTINE ITER(DUMPA,XL,FLAG,LP,SMM,SM,T,LG,FILE,NCHR)
      character*20 file
      character*24 temp
      logical qex
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),SMM(2485)
      DIMENSION SM(24,3,3),T(24,3)
      DIMENSION DUMPA(500),DERSTO(20000,70)
      DIMENSION AOBS(3,1200),ACAL(3,1200)
      DIMENSION FNUC(20000),HW(20000),SOMEGA(20000),
     2HH(3,20000),ICODE(20000),SJJ(20000),THETA(20000),ICODD(20000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /MAXDIM/ MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     1MNEQPO,MNOVRF,MNPATS
      REWIND LT8 
      IDO=1
      MMM=0      
      NUM=0      
      IF(NCYCLE)30,20,30
20    CONTINUE
30    REWIND LPRE     
      LLL=499
      CALL FLEES(AA,DUMPA)
      X=AA
      NK=NN5          
40    IF(NK-500)60,50,50
50    LLL=499           
      CALL FLEES(AA,DUMPA)
      X=AA
10    FORMAT(10X,F10.3)  
      NK=NK-500    
      GOTO 40      
60    LLL=NK
      IPREV=1
      IOLD1=0
      NPP=0
      NT=0
      DO 290 JKK=1,NPAT
      CALL FLEES(AA,DUMPA)       
      IALFA(JKK)=AA+0.5
      CALL FLEES(AA,DUMPA)
      ISTAP(JKK)=AA+0.5
      CALL FLEES(AA,DUMPA)
      IOMEG(JKK)=AA+0.5
      IDO=IALFA(JKK)  
90    NSTAP=ISTAP(JKK) 
      NOMEG=IOMEG(JKK)
      ARG=SQRT(3.14159265359)/FLOAT(ISTAP(JKK))
      NO=0
      DO 270 IST=IDO,NOMEG,NSTAP
      CALL FLEES(AA,DUMPA)
      YOBS=AA      
      NO=NO+1                   
      IF(ABS(YOBS).GE.0.001)GOTO 190
      CALL FLEES(AA,DUMPA)
      ISS=AA+0.5
      YOBS=0.0                      
      YCALC=0.0
      GOTO 240                      
190   NUM=NUM+1
      CALL FLEES(AA,DUMPA)             
      W=AA
      SW=SW+W
      CALL FLEES(AA,DUMPA)
      IORD1=AA+0.5
      CALL FLEES(AA,DUMPA)
      IORD2=AA+0.5
      CALL FLEES(AA,DUMPA)
      ISS=AA+0.5
      IF(IPREV.GT.IORD2)GOTO 230
      IFIN=IORD1-1              
210   IOLD1=IORD1
      DO 220 J=IPREV,IORD2    
220   CALL CALCUL(J,XL,FLAG,LP,SM,T,DERSTO,FNUC,HW,SOMEGA,HH,ICODE,
     2SJJ,THETA,ICODD)
230   IPREV=IORD2+1
      CALL SUMMAT(SMM,LP,XL,LG,DERSTO,FNUC,HW,SOMEGA,HH,ICODE,SJJ,
     2THETA,ICODD)
      IF(LG.EQ.0)PRINT 235,YOBS,YCALC
235   FORMAT(2X,2F12.2)
240   IF(NCYCLE)260,250,260   
250   CALL PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)        
260   IF(ISS.GE.IOMEG(JKK))GOTO 290
270   CONTINUE                
290   CONTINUE
      IF(NCYCLE)310,300,310
300   MMM=1                   
      CALL PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)
C
C  SORTIE DES FICHIERS .PRF
C
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
      lfile=lfile-1
      enddo
      DO 309 NPP=1,NPAT
      LTT=14+NPP
      GOTO(301,302,303),NPP
301   temp=file(1:lfile)//'1.prf'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.)go to 3001
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(ltt,temp)
3001  call open_write1(ltt,temp)
      GO TO 304
302   temp=file(1:lfile)//'2.prf'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.)go to 3003
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(ltt,temp)
3003  call open_write1(ltt,temp)
      GO TO 304
303   temp=file(1:lfile)//'3.prf'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.)go to 3004
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(ltt,temp)
3004  call open_write1(ltt,temp)
304   THMAX=IOMEG(NPP)/100.
      TH0=IALFA(NPP)/100.
      STP=ISTAP(NPP)/100.
      WRITE(LTT,3421)THMAX,TH0,STP
3421  FORMAT(//,3F8.3)
      NPHASE=NPP
      ABMES=(THMAX-TH0)/STP+1.5
      NBMES=ABMES
      WRITE(LTT,3422)NPHASE,NBMES
3422  FORMAT(I3,I5)
      IC1=0
      IC2=0
      WRITE(LTT,3423)IC1,IC2
3423  FORMAT(2I5)
      WRITE(LTT,3424)(AOBS(NPP,J),J=1,NBMES)
      WRITE(LTT,3424)(ACAL(NPP,J),J=1,NBMES)
      WRITE(LTT,3425)
3424  FORMAT(8(F7.0,1X))
3425  FORMAT(///)
309   CONTINUE
310   CONTINUE
320   CONTINUE
330   FORMAT(3I6/)         
340   FORMAT(/)            
350   FORMAT(1H1)          
360   FORMAT(/I8)          
370   FORMAT(3I8)             
390   FORMAT(I8,F8.1)      
400   FORMAT('   -1000',/,'  -10000',/,I8)
	RETURN
      END                                     
      SUBROUTINE SUMMAT(SMM,LP,XL,LG,DERSTO,FNUC,HW,SOMEGA,HH,ICODE,SJJ,
     2THETA,ICODD)
      DIMENSION LP(110,14),SMM(2485),XL(110,14),DERSTO(20000,70)
      DIMENSION FNUC(20000),HW(20000),SOMEGA(20000),
     2HH(3,20000),ICODE(20000),SJJ(20000),THETA(20000),ICODD(20000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)          
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM, 
     2MNEQPO,MNOVRF,MNPATS
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      IF(NCYCLE)30,30,10     
10    DO 20 J=1,MATORD       
20    DERIV(J)=0.            
30    YCALC=0.               
      BCALC=0.               
      DO 190 I=IORD1,IORD2   
      J=MOD(I,MNOVRF)+1
      NP=ICODD(J)            
      N2=N7+1
      N3=N6+NP
      DELTA=FLOAT(ISS)-THETA(J)
      DELT=DELTA*DELTA
      BB=HW(J)*HW(J)
      OMEGA=SJJ(J)*EXP(-DELT/BB)/HW(J)
      OMEF=OMEGA*FNUC(J)
      BCALC=BCALC+OMEF               
      YCALC=YCALC+OMEF/SCALE(NP)  
      SOMEGA(J)=SOMEGA(J)+OMEGA    
      IF(NCYCLE.EQ.0)GOTO 190
      X=(2.0*DELT/BB)-1.0
      DO 180 K=1,MATORD 
      DER=1.
      DO 90 M=1,3
      IF(LP(N3,M)-K)90,80,90    
80    DER=X
      GOTO 170
90    CONTINUE
      DO 160 M=1,6                 
      IF(LP(N2,M)-K)160,150,160    
150   DER=DELTA            
      GOTO 170                  
160   CONTINUE                  
170   CONTINUE                  
      DERIV(K)=DERSTO(J,K)*DER*OMEGA+DERIV(K)
180   CONTINUE                                 
190   CONTINUE
260   DELTA=YOBS-YCALC                      
      SUMW=SUMW+W*DELTA*DELTA        
      SUMOBS(NP)=SUMOBS(NP)+ABS(YOBS)     
      SUMDIF(NP)=SUMDIF(NP)+ABS(DELTA)    
      IF(YCALC)300,310,300        
300   XX=DELTA*BCALC/YCALC        
      SUMAW=SUMAW+W*XX*XX       
310   IF(NCYCLE.EQ.0)GOTO 330     
      DELTA=XX        
      L=0
      DO 320 I=1,MATORD           
      X=W*DERIV(I)                
      V(I)=V(I)+DELTA*X           
      DO 320 J=I,MATORD         
      L=L+1                     
      SMM(L)=SMM(L)+X*DERIV(J)  
320   CONTINUE                  
330   RETURN                    
      END                       
      SUBROUTINE PROFOT(MMM,JKK,NPP,NT,AOBS,ACAL)
      DIMENSION KK(500),OBS(10),CALC(10),IOBS(10),ICALC(10)
      DIMENSION AOBS(3,1200),ACAL(3,1200)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,
     3ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      IF(MMM)190,30,190
30    MO=MOD(NO,10)       
      IF(MO)40,40,50      
40    MO=10               
50    NPP=NPP+1           
      IF(NPP-1)60,60,70   
60    IALFA(JKK)=ISS           
70    IF(MO-1)90,80,90               
80    NT=NT+1                        
      KK(NT)=ISS                     
90    IOBS(MO)=YOBS+CIGN(0.5,YOBS)   
      OBS(MO)=YOBS                   
      ICALC(MO)=YCALC+CIGN(0.5,YCALC)
      CALC(MO)=YCALC                 
      IF(MO-10)100,120,120        
100   IF(ISS-IOMEG(JKK))180,110,110    
110   CONTINUE
120   CONTINUE
130   WRITE(LT4,*)(OBS(J),J=1,10),(CALC(J),J=1,10)
      IF(JKK.NE.NPAT)GO TO 180
150   IF(ISS-IOMEG(JKK))180,160,160                                 
160   CONTINUE
      WRITE(LT4,*)(OBS(J),J=1,10),(CALC(J),J=1,10)               
170   FORMAT(20A4,/,'      10       0',F8.2,'       0       1',/,F8.2,/)
      REWIND LT4 
180   RETURN     
190   NT=1       
      REWIND LT4
      NL=LINES
      N0=0
200   K=MOD(NT,NL)-1
220   IF(NPP-10)230,240,240
230   K=NPP                
      IF(K)180,180,250     
240   K=10                 
250   READ(LT4,*)(OBS(J),J=1,10),(CALC(J),J=1,10)
      IF(KK(NT).EQ.0)N0=N0+1
      IF(KK(NT).EQ.0)L0=1
      IF(L0.EQ.1)WRITE(LPR,290)N0
      DO 260 J=1,K                             
      IOBS(J)=OBS(J)+CIGN(0.5,OBS(J))          
      ICALC(J)=CALC(J)+CIGN(0.5,CALC(J))       
      AOBS(N0,L0)=OBS(J)
      ACAL(N0,L0)=CALC(J)
      L0=L0+1
260   CONTINUE                                 
      WRITE(LPR,270)KK(NT),(IOBS(J),ICALC(J),J=1,K)
      NT=NT+1                                      
      NPP=NPP-10                                   
      GOTO 200                                     
270   FORMAT(1X,I6,2X,20I6)                
280   FORMAT(10I8)                                 
290   FORMAT(//10X,'INTERFERENCE FUNCTION NUMBER ',I2,
     A/9H1POSITION,10(12H  YOBS YCALC))       
      END   
C
C
C                                       
      SUBROUTINE CALCUL(JJ,XL,FLAG,LP,SM,T,DERSTO,FNUC,HW,SOMEGA,HH,
     2ICODE,SJJ,THETA,ICODD)
      DIMENSION HNN(3)
      DIMENSION COSAR(70,24),SINAR(70,24),XL(110,14),SM(24,3,3),T(24,3)
      DIMENSION FLAG(110,14),LP(110,14),DERSTO(20000,70)
      DIMENSION COSARI(24),SINARI(24),SNEX(70),TR(24)
      DIMENSION FNUC(20000),HW(20000),SOMEGA(20000),
     2HH(3,20000),ICODE(20000),SJJ(20000),THETA(20000),ICODD(20000)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /MAXDIM/MNCONF,MNCONT,MMATOR,MNEUTS,MNATOM,
     2MNEQPO,MNOVRF,MNPATS
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      NM=MOD(JJ,MNOVRF)+1
      READ(LT8,*)(HH(I,NM),I=1,3),ICODE(NM),ICODD(NM),SJJ(NM),FAC,
     2 (FF(I),I=1,KLOOP)
      SOMEGA(NM)=0.
      FNUC(NM)=0.
      IF(NCYCLE)4,4,2
2     DO 3 I=1,MAXS
3     DERIV(I)=0.
4     CONTINUE
      DO 6 I=1,3
6     HNN(I)=HH(I,NM)
      DO 10 I=1,MATORD                  
10    DERIV(I)=0.0
      NP=ICODD(NM)
      N2=N7+1
      N3=N6+NP
      DO 40 IR=1,IRLL
      TR(IR)=0.
      DO 30 I=1,3
      H(IR,I)=0.
      TR(IR)=TR(IR)+T(IR,I)*HNN(I)
      DO 20 J=1,3
20    H(IR,I)=SM(IR,J,I)*HNN(J)+H(IR,I)
30    CONTINUE
40    CONTINUE
      SLABDA=DLABDA(NP)
      SS=0.                     
      DO 50 I=1,3                    
      DO 50 J=I,3                    
50    SS=AL(I,J)*HNN(I)*HNN(J)+SS
      SSNN=0.25*SS
      SINTH=SLABDA*SS
      COSTH=1.-SINTH
      TANTH=SQRT(SINTH/COSTH)
      THETA(NM)=ATAN(TANTH)*PI
      HW(NM)=SQRT(AH(NP)*TANTH*TANTH+BH(NP)*TANTH+CH(NP))*SLOG
      BB=HW(NM)**2
      DO 130 I=1,N
      DO 120 IR=1,IRLL
      ARG=TR(IR)             
      DO 70 J=1,3               
70    ARG=ARG+H(IR,J)*XL(I,J)   
      ARG=6.28318530718*ARG
      COSAR(I,IR)=COS(ARG)
120   SINAR(I,IR)=SIN(ARG)
130   CONTINUE
      AV=0.                     
      BV=0.                     
      DO 170 I=1,N              
      IF(NTYP(I).EQ.0)GOTO 170
      SNXI=0.                   
      SAI=0.                    
      SBI=0.                    
      DO 140 IR=1,IRLL           
      SAI=SAI+COSAR(I,IR)         
      IF(ICENT.EQ.1)SBI=SINAR(I,IR)+SBI 
140   CONTINUE                          
      SAI=FLOAT(ICENT)*SAI    
      SA(I)=SAI            
      SB(I)=SBI            
      NI=NTYP(I)           
      BNI=B(NP,NI)            
      IF(KXR(NP).LT.4)GOTO 150 
      SNEXI=FF(NI)    
      SNXI=BNI*XL(I,4)
      GOTO 160                
150   SNEXI=BNI       
160   AV=SNEXI*SAI*XL(I,4)+AV 
      BV=SNEXI*SBI*XL(I,4)+BV
      SNEX(I)=2.*SNEXI
      IF(KXR(NP).LT.4)GOTO 170 
      AVI=AV-SNXI*SBI         
      AVJ=AV+SNXI*SBI         
      BVI=BV-SNXI*SAI         
      BVJ=BV+SNXI*SAI         
170   CONTINUE
190   IF(KXR(NP).LT.4)GOTO 200 
      FNN=(AVI*AVI+AVJ*AVJ+BVI*BVI+BVJ*BVJ)/2./FAC
      GOTO 210                 
200   FNN=(AV*AV+BV*BV)
210   FNUC(NM)=FNN
      IF(NCYCLE.EQ.0)GOTO 350 
      DO 340 I=1,N            
      IF(NTYP(I).EQ.0)GOTO 340
      SNEXI=SNEX(I)*XL(I,4)
      SAI=SA(I)               
      SBI=SB(I)               
      DO 220 IR=1,IRLL         
      SINARI(IR)=SINAR(I,IR)  
220   COSARI(IR)=COSAR(I,IR)  
      CALL PARS(I,NPAR)
      DO 330 J=1,NPAR
      IF(J.LT.9.AND.J.GT.5)GO TO 330         
      K=LP(I,J)                    
      IF(K.EQ.0)GOTO 330
230   GOTO(240,240,240,270),J  
240   SUMA=0.                      
      SUMB=0.                      
      DO 250 IR=1,IRLL              
      SUMA=H(IR,J)*SINARI(IR)+SUMA 
      IF(ICENT.EQ.1)SUMB=H(IR,J)*COSARI(IR)+SUMB
250   CONTINUE                                  
      DER=-(AV*SUMA-BV*SUMB)*SNEXI*FLOAT(ICENT)*6.28318530718  
      GOTO 320
270   DER=(SAI*AV+SBI*BV)*SNEX(I)   
320   DERIV(K)=FLAG(I,J)*DER+DERIV(K)              
330   CONTINUE                                     
340   CONTINUE                         
      CALL DOVER(FNN,SSNN,NP,LP,FLAG)    
350   CONTINUE
1000  FNN=FNUC(NM)            
      IF(NCYCLE.EQ.0)GOTO 1160
      SINTH=FNN*PI*SLABDA/(SQRT(SINTH*COSTH)*BB) 
      SS=FNN/(FLOG2*BB)
      X=TANTH*TANTH
      DO 1010 J=1,3
      K=LP(N3,J)
      IF(K.EQ.0)GOTO 1010          
      DERIV(K)=X*FLAG(N3,J)*SS+DERIV(K) 
1010  X=X/TANTH
      DO 1050 J=1,6             
      K=LP(N2,J)                
      IF(K.EQ.0)GOTO 1050       
      IF(J-3)1020,1020,1030     
1020  K1=J                   
      K2=J                   
      GOTO 1040              
1030  M=J-3                  
      CALL PERM(M,K1,K2)     
1040  DERIV(K)=DERIV(K)+HNN(K1)*HNN(K2)*SINTH*FLAG(N2,J) 
1050  CONTINUE                                       
      DO 1060 I=1,MATORD                                           
C      IF(ISW.NE.0)DERIV(I)=DERIV(I)/SCALE(NP)                    
1060  DERSTO(NM,I)=DERIV(I)                                        
1160  RETURN       
      END          
      SUBROUTINE DOVER(FNN,SSNN,NP,LP,FLAG)
      DIMENSION LP(110,14),FLAG(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      N1=N+NP               
      DO 70 J=1,5     
      K=LP(N1,J)      
      IF(K.EQ.0)GOTO 70     
      IF(K-MATORD)10,10,70  
10    GOTO(20,70,30,40,50),J
20    DER=0.         
      GOTO 60               
30    DER=SCALE(NP)*FNN   
      GOTO 60               
40    CONTINUE   
      GOTO 60               
50    DER=-2.0*SSNN*FNN     
60    DERIV(K)=DERIV(K)+FLAG(N1,J)*DER 
70    CONTINUE                         
      RETURN                           
      END                              
      SUBROUTINE MATRIX(SMM,STAND)
      DIMENSION STAND(70),SMM(2485)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LT9,LPUN                      
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      COMMON /MOVE/AH(3),BH(3),CH(3),B2(3),SCALE(3)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      NFAIL=0
      JJ=MATORD*(MATORD+1)/2
      CALL MATINV(NFAIL,SMM)
      DO 110 I=1,MATORD     
      DERIV(I)=0.0          
      II=I                  
      IID=MATORD-1          
      DO 100 J=1,MATORD     
      DERIV(I)=DERIV(I)+SMM(II)*V(J)                                   
      IF(J-I)80,90,90       
80    II=II+IID   
      IID=IID-1   
      GOTO 100    
90    II=II+1     
100   CONTINUE    
110   CONTINUE    
      SIGD=SQRT(SUMAW/FLOAT(NUM-MATORD))                               
      II=1        
      IID=MATORD  
      DO 130 I=1,MATORD                                                
      STAND(I)=SQRT(SMM(II))*SIGD                                      
      II=II+IID   
      IID=IID-1   
130   CONTINUE      
150   RETURN        
      END           
      SUBROUTINE MATINV(NFAIL,AM)                                         
      DOUBLEPRECISION TERM,DENOM,SUMA                                  
      DIMENSION AM(2485)                                               
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      EQUIVALENCE (MATORD,N)
      K=1            
      IF(N-1)10,20,30
10    NFAIL=1        
      GOTO 220       
20    AM(1)=1.0/AM(1)
      GOTO 210       
30    DO 120 M=1,N   
      IMAX=M-1       
      DO 110 L=M,N   
      SUMA=0.0D0     
      KLI=L          
      KMI=M          
      IF(IMAX)60,60,40
40    DO 50 I=1,IMAX  
      SUMA=SUMA+DBLE(AM(KLI)*AM(KMI))                                  
      J=N-I           
      KLI=KLI+J       
50    KMI=KMI+J       
60    TERM=DBLE(AM(K))-SUMA
      IF(L-M)70,70,100     
70    IF(TERM)90,90,80     
80    DENOM=DSQRT(TERM)    
      AM(K)=SNGL(DENOM)    
      GOTO 110             
90    NFAIL=K              
      GOTO 220             
100   AM(K)=SNGL(TERM/DENOM)
110   K=K+1            
120   CONTINUE         
130   AM(1)=1.0/AM(1)  
      KDM=1            
      DO 160 L=2,N     
      KDM=KDM+N-L+2    
      TERM=DBLE(1.0/AM(KDM))
      AM(KDM)=SNGL(TERM)
      KMI=0             
      KLI=L             
      IMAX=L-1          
      DO 150 M=1,IMAX   
      K=KLI             
      SUMA=0.0D0        
      DO 140 I=M,IMAX   
      II=KMI+I          
      SUMA=SUMA-DBLE(AM(KLI)*AM(II))                                   
140   KLI=KLI+N-I       
      AM(K)=SNGL(SUMA*TERM)                                            
      J=N-M            
      KLI=K+J          
150   KMI=KMI+J        
160   CONTINUE         
170   K=1              
      DO 200 M=1,N     
      KLI=K            
      DO 190 L=M,N     
      KMI=K            
      IMAX=N-L+1       
      SUMA=0.0D0       
      DO 180 I=1,IMAX  
      SUMA=SUMA+DBLE(AM(KLI)*AM(KMI))                                  
      KLI=KLI+1        
180   KMI=KMI+1        
      AM(K)=SNGL(SUMA) 
190   K=K+1            
200   CONTINUE         
210   NFAIL=0          
220   RETURN
      END
      SUBROUTINE OUTPUT(XL,FLAG,LP,SMM,STAND)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),STAND(70)
      DIMENSION SMM(2485)
      DIMENSION FMT(70)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT   
      IF(NCYCLE)90,90,10
10    CALL UPDATE(XL,FLAG,LP)
      CALL SHOUT(XL,FLAG,LP,STAND,FMT)
      CALL CELLSD(XL,FLAG,LP,SMM)
      IF(NCYCLE-ICYCLE)90,30,90
30    CONTINUE
90    CALL ROUT(NUM)        
120   CONTINUE
      RETURN
      END                                                     
      SUBROUTINE ROUT(NUM)                                    
      COMMON /RCEE/ RCE(3,6)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ,
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)                  
      COMMON /SUMS/SW,SUMAW,SUMW,SUMOBS(3),SUMDIF(3),SOM
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN    
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT   
      WRITE(LPR,160)ICYCLE
      PRINT 160,ICYCLE
C8001  FORMAT(6F11.6)
C      PRINT 8001,(RCE(1,I),I=1,6)
      DO 400 J=1,NPAT
      WRITE(LPR,260)J
      X=100.0*SUMDIF(J)/SUMOBS(J)   
      WRITE(LPR,180)X
      PRINT 180,X         
400   CONTINUE
160   FORMAT(1H ,17X,23HR FACTORS BEFORE CYCLE ,I3)
180   FORMAT(                                                          
     257H PROFILE INTENSITY R (100*SUM[ABS(Y<OBS>-Y<CALC>*SCALE)]/,   
     317HSUM[ABS(Y<OBS>)]),14X,F6.2)                                 
260   FORMAT(5X'  INTERFERENCE FUNCTION NUMBER  'I4)
      RETURN
      END        
      SUBROUTINE CELLSD(XL,FLAG,LP,SMM)
      DIMENSION COV(6,6),RCOV(6,6),D(6,6),P(6),DRSIN(3),
     2DRTAN(3),TCOV(6,6),RCSIN(3),SCOV(6,6),DVDP(6)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14),SMM(2485)    
      COMMON /RCEE/ RCE(3,6)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      COMMON /GEOM/DEGRAD,RADDEG   
      N2=N7+1                     
      DO 411 I=1,3
411   RCE(1,I)=CELLN(I)
      DO 412 I=4,6
412   RCE(1,I)=ACOS(CELLN(I))*RADDEG
      DO 20 I=1,6                  
      IF(LP(N2,I))20,20,10         
10    IF(LP(N2,I)-MATORD)30,30,20  
20    CONTINUE                     
      VOL=1.0/VOL  
      RETURN               
30    DO 40 I=1,6          
      P(I)=XL(N2,I)     
      DO 40 J=1,6          
      COV(I,J)=0.0      
      D(I,J)=0.0    
40    CONTINUE         
      G=1.0            
      DO 80 I=1,3      
      J=I+3            
      DRSIN(I)=SQRT(1.0-CELLN(J)*CELLN(J))
      IF(CELLN(J)-0.0000001)50,60,60
50    DRTAN(I)=1.0E15                           
      GOTO 70                                      
60    DRTAN(I)=DRSIN(I)/CELLN(J)          
70    RCSIN(I)=SQRT(1.0-RCELLN(J)*RCELLN(J))
      G=G*CELLN(I)*CELLN(I)*DRSIN(I)      
80    CONTINUE                    
      VS=2.0*VOL*VOL   
      G=G*VS             
      SD=SIGD*SIGD       
      DO 140 I=1,6       
      II=I               
      L1=LP(N2,II)       
      IF(L1)140,140,90   
90    IF(L1-MATORD)100,100,140  
100   DO 130 J=I,6           
      JJ=J                   
      L2=LP(N2,JJ)           
      IF(L2)130,130,110      
110   IF(L2-MATORD)120,120,130
120   CALL LOC(L1,L2,NU,MATORD) 
      COV(I,J)=SMM(NU)*FLAG(N2,II)*FLAG(N2,JJ)*SD
      COV(J,I)=COV(I,J)  
130   CONTINUE                 
140   CONTINUE                 
      CLIM=1.0E-6              
      DO 310 I=1,3             
      D(I,I)=-0.5*CELLN(I)/P(I) 
      L1=I+3               
      DO 300 J=1,3         
      L2=J+3               
      CALL PERM(J,K,L)     
      IF(J-I)170,150,170   
150   IF(ABS(CELLN(L2))-CLIM)200,160,160
160   D(L1,J)=2.0/DRTAN(J)           
170   IF(P(J)-CLIM)200,180,180          
180   IF(RCELLN(L1)-CLIM)200,190,190    
190   D(L1,J)=D(L1,J)+G*RCELLN(L1)
      D(L1,J)=1.0/(D(L1,J)*P(J)) 
200   IF(I-J)210,230,210                 
210   IF(ABS(P(L2))-CLIM)230,220,220  
220   D(I,L2)=-CELLN(I)/P(L2)   
230   IF(ABS(P(L2))-CLIM)250,240,240  
240   IF(ABS(RCELLN(L1))-CLIM)250,260,260
250   IF(I-J)300,260,300                       
260   D(L1,L2)=VS*CELLN(J)*CELLN(J)*CELLN(K)*CELLN(L) 
     2 *DRSIN(I)                                    
      IF(I-J)270,280,270                               
270   D(L1,L2)=-D(L1,L2)*CELLN(9-I-J)         
280   D(L1,L2)=D(L1,L2)+G*P(L2)*RCELLN(L1) 
290   D(L1,L2)=1.0/D(L1,L2)  
300   CONTINUE                   
310   CONTINUE                   
      CALL MATABT(RCOV,COV,D,NP) 
      CALL MATAB(TCOV,D,RCOV,NP) 
      DO 320 I=1,6   
      DO 320 J=1,6   
      D(I,J)=0.0  
320   CONTINUE       
      DO 380 I=1,3   
      D(I,I)=0.5/RCELLN(I) 
      L1=I+3                  
      DO 370 J=1,3            
      L2=J+3                  
      IF(J-I)330,350,330      
330   IF(RCELLN(L2)-CLIM)350,340,340  
340   D(I,L2)=2.0*(RCELLN(6-I-J)*RCELLN(L2))  
      GOTO 370                                         
350   CALL PERM(J,K,L)                                 
      D(L1,L2)=-2.0*(RCELLN(L)*RCELLN(K)*RCSIN(J))  
      IF(D(L1,L2))360,370,360     
360   D(L1,L2)=1.0/D(L1,L2)    
370   CONTINUE                       
380   CONTINUE                       
      CALL MATABT(RCOV,COV,D,NP)     
      CALL MATAB(SCOV,D,RCOV,NP)     
      VOL=1.0/VOL            
      G=0.5*G*VOL                
      CALL VESD(E1,G,VOL,CELLN,RCELLN,TCOV,DVDP,NP)  
      G=1.0                                          
      DO 390 I=1,3                                   
      G=G*RCELLN(I)*RCELLN(I)*RCSIN(I)      
390   CONTINUE                                   
      G=G*VOL                                
      VS=VOL                                 
      VOL=1.0/VOL                        
      CALL VESD(E2,G,VOL,RCELLN,CELLN,SCOV,DVDP,NP) 
      CALL CESD(TCOV,P,CELLN,NP)                    
      CALL CESD(SCOV,DVDP,RCELLN,NP)                
      WRITE(LPR,400)
      WRITE(LPR,410)                                
      WRITE(LPR,420)(CELLN(I),TCOV(I,I),I=1,3),(P(I),TCOV(
     2 I,I),I=4,6)                                                    
      WRITE(LPR,430)                                                  
      WRITE(LPR,440)(RCELLN(I),SCOV(I,I),I=1,3),(DVDP(I),    
     2 SCOV(I,I),I=4,6)              
      WRITE(LPR,450)                    
      WRITE(LPR,460)VS,E1,VOL,E2    
      VOL=1.0/VOL               
      RETURN                            
400   FORMAT(1H0,////10X,               
     2 'CELL PARAMETERS WITH ESTIMATED STANDARD DEVIATIONS')
410   FORMAT(1H0,5X,1HA,19X,1HB,19X,1HC,18X,5HALPHA,13X,4HBETA,15X,
     2 5HGAMMA)                                                    
420   FORMAT(1H ,3(F10.4,1H(,F8.4,1H)),3(F10.3,1H(,F6.3,1H)))      
430   FORMAT(1H0,5X,2HA*,18X,2HB*,18X,2HC*,17X,6HALPHA*,12X,5HBETA*,
     2 14X,6HGAMMA*)                                                
440   FORMAT(1H ,3(F10.6,1H(,F8.6,1H)),3(F10.3,1H(,F6.3,1H)))      
450   FORMAT(1H0,27X,4HREAL,16X,12HCELL VOLUMES,8X,10HRECIPROCAL)  
460   FORMAT(1H ,22X,F10.3,1H(,F6.3,1H),26X,F10.7,1H(,F10.7,1H))
      END                                                          
      SUBROUTINE CESD(TCOV,P,CELLN,NP)            
      DIMENSION TCOV(6,6),P(6)
      DIMENSION CELLN(6)     
      COMMON /GEOM/DEGRAD,RADDEG   
      DO 30 I=1,6                  
      IF(TCOV(I,I))10,30,20     
10    TCOV(I,I)=0.0             
      GOTO 30                      
20    TCOV(I,I)=SQRT(TCOV(I,I)) 
30    CONTINUE                        
      DO 40 I=4,6                     
      TCOV(I,I)=TCOV(I,I)*RADDEG
      P(I)=ACOS(CELLN(I))*RADDEG
40    CONTINUE                        
      RETURN                          
      END                             
      SUBROUTINE VESD(E,G,VOL,CELLN,RCELLN,TCOV,DVDP,NP) 
      DIMENSION CELLN(6),RCELLN(6)
      DIMENSION TCOV(6,6),DVDP(6)
      DO 10 I=1,3                        
      II=I+3                          
      DVDP(I)=VOL/CELLN(I)  
      DVDP(II)=-G*RCELLN(II)    
10    CONTINUE              
      E=0.0             
      DO 60 I=1,6       
      DO 50 J=I,6       
      IF(I-J)20,30,20   
20    TOO=2.0           
      GOTO 40           
30    TOO=1.0           
40    E=E+DVDP(I)*DVDP(J)*TCOV(I,J)*TOO 
50    CONTINUE        
60    CONTINUE        
      IF(E)70,90,80   
70    E=0.0           
      RETURN          
80    E=SQRT(E)       
90    RETURN          
      END             
      SUBROUTINE MATAB(RCOV,D,COV,NP) 
      DIMENSION RCOV(6,6),COV(6,6),D(6,6) 
      DO 30 I=1,6                           
      DO 20 J=1,6                           
      RCOV(I,J)=0.0       
      DO 10 M=1,6                           
      RCOV(I,J)=RCOV(I,J)+D(I,M)*COV(M,J) 
10    CONTINUE   
20    CONTINUE   
30    CONTINUE   
      RETURN     
      END        
      SUBROUTINE MATABT(RCOV,D,COV,NP) 
      DIMENSION RCOV(6,6),D(6,6),COV(6,6)
      DO 30 I=1,6                           
      DO 20 J=1,6                           
      RCOV(I,J)=0.0                      
      DO 10 M=1,6                           
      RCOV(I,J)=RCOV(I,J)+D(I,M)*COV(J,M)  
10    CONTINUE    
20    CONTINUE    
30    CONTINUE    
      RETURN      
      END         
      SUBROUTINE SHOUT(XL,FLAG,LP,STAND,FMT)
      DIMENSION STAND(70)
      DIMENSION FMT(70),DUM(70)
      DIMENSION XL(110,14),FLAG(110,14),LP(110,14)                      
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     2 6),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),HL(3,3),SA(70),SB(70),text(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2 ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3 ICYCLE,KLOOP,LINES
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT               
      DATA ONEH/4H(1H /,THRX/4H,3X /,AFOR/4H,A4 /,BLANK/4H    /
      WRITE(LPR,190)ICYCLE      
      FMT(1)=ONEH     
      FMT(2)=AFOR 
      FMT(3)=THRX 
      II=1        
      III=N       
      L=1         
      M=4         
      WRITE(LPR,200)
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      LGG=0
      ATEXT(N6)=BLANK
      DO 170 NP=1,NPAT
      N3=N6+NP          
      N2=N7+1          
      WRITE(LPR,260)NP,(PTEXT(NP,J),J=1,4) 
      N1=N+NP           
      WRITE(LPR,280)    
      ATEXT(N1)=BLANK   
      II=N1             
      III=N1            
      L=3
      M=3             
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      ATEXT(N3)=BLANK   
      II=N3             
      III=N3            
      L=1               
      M=3               
      WRITE(LPR,300)  
      WRITE(LPR,310)
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
170   CONTINUE
      ATEXT(N2)=BLANK
      II=N2          
      III=N2         
      L=1            
      M=3            
      WRITE(LPR,340) 
      WRITE(LPR,350) 
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      WRITE(LPR,360) 
      L=4            
      M=6            
      CALL PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
180   RETURN              
190   FORMAT(1H1,40X,37HSHIFTS AND NEW PARAMETERS AFTER CYCLE,I2)      
200   FORMAT(5H0ATOM,6X,1HX,8X,5HSHIFT,4X,3HESD,7X,1HY,8X,5HSHIFT,4X,  
     23HESD,7X,1HZ,8X,5HSHIFT,4X,3HESD,7X,5HOCCUP,4X,5HSHIFT,4X,3HESD/)
230   FORMAT(1H+,91X,2F9.5)                                            
240   FORMAT(5H0ATOM,6X,3HB11,6X,5HSHIFT,4X,3HESD,7X,3HB22,6X,5HSHIFT, 
     24X,3HESD,7X,3HB33,6X,5HSHIFT,4X,3HESD/)                         
260   FORMAT(////,40X,18(1H*),/,40X,1H*,3X,7HPATTERN,1X,I2,3X,1H*,/,   
     240X,1H*,4A4,1H*,/,40X,18(1H*),/)                                
280   FORMAT(1H ,5X,6HSCALE ,3X,5HSHIFT,4X,3HESD,7X,6H      ,/)
300   FORMAT(1H0,13X,20H   UVW    PARAMETERS)                          
310   FORMAT(1H ,10X,1HU,9X,5HSHIFT,5X,3HESD,5X,1HV,9X,5HSHIFT,5X,     
     23HESD,5X,1HW,9X,5HSHIFT,5X,3HESD,3X)                            
330   FORMAT(2X,8H*PATTERN,I2,1H*)                                     
340   FORMAT(1H0,53X,15HCELL PARAMETERS)                               
350   FORMAT(1H ,10X,1HA,11X,5HSHIFT,7X,3HESD,10X,1HB,11X,5HSHIFT,7X,  
     23HESD,10X,1HC,11X,5HSHIFT,7X,3HESD/)                            
360   FORMAT(1H0,10X,1HD,11X,5HSHIFT,7X,3HESD,10X,1HE,11X,5HSHIFT,7X,  
     23HESD,10X,1HF,11X,5HSHIFT,7X,3HESD/)                            
      END                                                              
      FUNCTION FREL(I,J)                                               
      COMMON /RELX/RELAXB,RELAXC,RELAXS,RELAXH            
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT  
      NX=N+1
      IF(I-NX)10,20,20   
10    IF(J-4)60,70,30    
20    IF(I-N6)40,50,50   
30    IF(J-9)80,70,70    
40    GOTO(70,50,80,80,70),J 
50    FREL=RELAXH            
      RETURN           
60    FREL=RELAXC      
      RETURN           
70    FREL=RELAXB      
      RETURN        
80    FREL=RELAXS   
      RETURN        
      END           
      SUBROUTINE UPDATE(XL,FLAG,LP)  
      DIMENSION FLAG(110,14),XL(110,14),LP(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /CONTRL/NCYCLE,MAXS,KXR(3),KKZ, 
     2ICELL,ICENT,IRL,IRLL,KL,KLL,KM,KMN,   
     3ICYCLE,KLOOP,LINES
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN        
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      DO 40 I=1,N4          
      CALL PARS(I,NPAR)     
      DO 30 J=1,NPAR        
      IF(LP(I,J))10,30,10   
10    IF(LP(I,J)-MATORD)20,20,30 
20    K=LP(I,J)                  
      REL=FREL(I,J)              
      XL(I,J)=XL(I,J)+FLAG(I,J)*DERIV(K)*REL
30    CONTINUE             
40    CONTINUE             
60    CALL SHIFT(XL)
      CALL REPCEL(RCELLN,AL)
      CALL TRCL(RCELLN,CELLN,VOL)
      RETURN               
      END                  
      SUBROUTINE PRNT(STAND,FMT,DUM,XL,LP,FLAG,II,III,L,M)
      DIMENSION STAND(70)
      DIMENSION DUM(70),FMT(70)
      DIMENSION XL(110,14),LP(110,14),FLAG(110,14)
      COMMON /REFLN/ARG,DELTA,DLABDA(3),SLOG,FLOG2,
     2 OMEGA,PI,SKEW,SLABDA,W,XN,YCALC,YOBS                       
      COMMON /PREF/IALFA(3),IOMEG(3),IORD1,IORD2,IPREV,ISTAP(3),
     2ISS,LIMO,LLL,NKEY,NO,NTEXT,NUM,NTYP(70)         
      COMMON /SYMCEL/ALL(3,3),AL(3,3),ATEXT(110),B(3,8),CELL(6),CELLN(
     26),FF(4),RCELL(6),RCELLN(6),VOLUME,VOL,PTEXT(3,4)    
      COMMON /MINIM/DERIV(70),H(24,3),SA(70),SB(70),text(20)
      COMMON /MATR/MATSIZ,MATORD,SIGD,V(70)
      COMMON /INOUT/LCA,LPR,LPRE,LT4,LT8,LFOR,LPUN                     
      COMMON /NUMB/N,N1,N2,N3,N4,N6,N7,NN,NN5,NA,NPAT
      DATA ONEX/4H,1X /,THR/4H,3  /,FONE/4H,F9 /,FONEB/                
     24HF9  /,FTWO/4H,F12/,FTWOB/4HF12 /,PONE/4H.5  /,PTWO/4H.8  /,   
     3PTHR/4H.0  /,XONE/4H,18X/,XTWO/4H,24X/,                         
     4END/4H)   /,BLANK/4H    /    
      DO 5 IBL=4,70   
    5 FMT(IBL)=BLANK  
      FTEN=FONE    
      FTENB=FONEB  
      PT5=PONE     
      ATEENX=XONE  
      IF(III-N3)40,10,30
10    IF(M-3)20,20,40 
20    PT5=PTHR
      GOTO 40       
30    FTEN=FTWO
      FTENB=FTWOB
      PT5=PTWO   
      ATEENX=XTWO
40    DO 100 I=II,III 
      INDEX=3         
      KK=0            
      CHAR=ATEXT(I)   
      CALL XCOPY(KK,CHAR,DUM) 
      DO 90 J=L,M             
      CHAR=XL(I,J)            
      CALL XCOPY(KK,CHAR,DUM) 
      K=LP(I,J)             
      IF(K)70,70,50         
50    IF(K-MATORD)60,60,70  
60    REL=FREL(I,J)         
      CHAR=DERIV(K)*FLAG(I,J)*REL
      CALL XCOPY(KK,CHAR,DUM)    
      CHAR=STAND(K)*ABS(FLAG(I,J)) 
      CALL XCOPY(KK,CHAR,DUM)      
      CALL XCOPY(INDEX,THR,FMT)    
      CALL XCOPY(INDEX,FTENB,FMT)  
      CALL XCOPY(INDEX,PT5,FMT)    
      GOTO 80                      
70    CALL XCOPY(INDEX,FTEN,FMT)   
      CALL XCOPY(INDEX,PT5,FMT)    
      CALL XCOPY(INDEX,ATEENX,FMT) 
80    CALL XCOPY(INDEX,ONEX,FMT)   
90    CONTINUE                     
      CALL XCOPY(INDEX,END,FMT)    
      WRITE(LPR,FMT)(DUM(K),K=1,KK)
100   CONTINUE                     
      RETURN
      END
C
C
C
	SUBROUTINE JAZY1(FILE)
C       
C       Special Lazy version for creating hkl files
C
C
      character*20 file
      character*24 temp
      logical qex
	REAL N3,ISYMWL
	CHARACTER*1 LBJ,IP,LJC,LJA,NORM,IANO,CEN
      DIMENSION CAR(9),IPOS(45),TSS(24,3),SS(24,3,3),
     1 RN(3), RD(3), S1(3), S2(3), S3(3), XYZ(3), COMPND(19), ELEMT(8),
     2 FNEUT(8), NA(8), DELFR(8), DELFI(8), IGR(45)
      DIMENSION FA(4,8),FB(4,8),FC(8),TS(3,24),FS(3,3,24),X(50,8),Y(50,
     * 8),Z(50,8),FOCCU(50,8),FMULT(50,8),IDE(50,8),BTEMP(50,8)
      INTEGER CAR,SS,SYMBR
      COMMON/BURC/TSS,SS
      COMMON /INPUT2/ COMPND,ELEMT,FNEUT,A,B,C,ALPHA,BETA,
     1GAMMA,SYMSY,SYMBR,ISYMCE,NCOMPO,NA,SYMWL,WL,TL,TH,IMAGE,SYMLP,
     2AGUIN,BGUIN,DELFR,DELFI,NS,IBRAVL,NORM,IANO
      COMMON /UNITS/ ICR,IPR,ILU
      COMMON /POSIT/ RN,RD,S1,S2,S3,IGR
      COMMON /ANOMAL/ DEL1,DEL2
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,LAUE,ITRIG
      COMMON /SLAS/ IP(8,3)
      COMMON /ND/ N3(20)
      COMMON /LAZY/ ASS(24,3,3),ATS(24,3),IASYM,IABRA,NAG
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
      DATA CAR(1)/2HTI/,CAR(2)/2HAT/,CAR(3)/2HCE/,CAR(4)/2HLA/,CAR(5)/2H
     1SY/,CAR(6)/2HCO/,CAR(7)/2HSP/,CAR(8)/2HEN/,CAR(9)/2HFI/
      DATA BLNK/4HBBBB/,LBJ/1H /,LJC/'C'/,LJA/'A'/,LBB/'  '/
C-----SET LOGICAL UNIT NUMBERS
      ICR=28
      IPR=31
      ILU=29
      ILV=30
	IUN=33
      REWIND 28
	IDEUX=34
      lfile=len(file)
      do while (file(lfile:lfile).eq.' ')
         lfile=lfile-1
      enddo
      temp=file(1:lfile)//'.imp'
      inquire(file=temp,exist=qex)
      if(qex.eq..FALSE.)go to 100
      print *,'Warning, this old file will be deleted : ',temp
      call filedel(31,temp)
100   if(if5.eq.0)call open_write2(31,temp)
      if(if5.eq.1)call open_write1(31,temp)
      inquire(file='LAZY.LAZ',exist=qex)
      if(qex.eq..FALSE.)go to 101
      print *,'Warning, this old file will be deleted : ','LAZY.LAZ'
      call filedel(21,'LAZY.LAZ')
101   OPEN(UNIT=29,FILE='LAZY.LAZ',STATUS='SCRATCH',FORM='UNFORMATTED')
      inquire(file='LAZY.JAZ',exist=qex)
      if(qex.eq..FALSE.)go to 102
      print *,'Warning, this old file will be deleted : ','LAZY.JAZ'
      call filedel(30,'LAZY.JAZ')
102   OPEN(UNIT=30,FILE='LAZY.JAZ',STATUS='SCRATCH')
C-----SET PROGRAM LIMITS
      LIMIT2=8
      LIMIT3=50
      LIMIT4=24
C-----
C-----READ INPUT FOR SEVERAL JOBS
C-----
      NJOB=0
      WRITE (IPR,38)SDAT,STIM
C-----READ FIRST CARD OF EACH SET
 1    READ (ICR,39) (IPOS(I),I=1,40)
C-----CHECK FOR FINISH CARD
      IF (IPOS(1).EQ.CAR(9)) GO TO 4
C-----COUNT NUMBER OF JOBS
      NJOB=NJOB+1
      WRITE (IPR,40) NJOB
      GO TO 3
C-----READ REMAINING DATA CARDS
 2    READ (ICR,39) (IPOS(I),I=1,40)
 3    WRITE (IPR,41) (IPOS(I),I=1,35)
C-----WRITE DATA CARDS TWICE ON DISK
      WRITE (ILV,391) (IPOS(I),I=1,40)
      WRITE (ILV,391) (IPOS(I),I=1,40)
C-----CHECK FOR END OF JOB
      IF (IPOS(1).NE.CAR(8)) GO TO 2
      WRITE (IPR,42)
      GO TO 1
 4    REWIND ILV
C       CALL CLOSE(ICR)
C-----
C-----START CALCULATION FOR NJOB JOBS
C-----
	WRITE(ILU)LFILE,FILE
      WRITE (ILU) NJOB
      DO 37 IJOB=1,NJOB
C-----
C-----SET DEFAULT VALUES
C-----
      ISYMWL=N3(14)
      SYMBR=N3(13)
      CEN=LJA
      NORM=LBJ
      WL=1.5418
      TL1=0.
      TH1=89.
      THG=45.
      IMAGE=2
      IANO=LBJ
C-----
C-----SET PARAMETERS BACK TO ORIGINAL VALUE
C-----
      LAUE=0
      ITRIG=3
      IHOO=1
      IOKO=1
      IOOL=1
      IHHL=1
      IHOL=1
      IOKL=1
      IHKO=1
      NCOMPO=1
      TH=TH1
      TL=TL1
      SYMWL=ISYMWL
      NS=0
      IGROUP=0
      ISYST=0
      ISYMCE=0
      A=0.
C-----SET ARRAYS BACK ZERO
      DO 5 I=1,36
 5    IGR(I)=LBB
      DO 6 I=1,LIMIT2
      ELEMT(I)=BLNK
      FNEUT(I)=0.
      DELFR(I)=0.
      DELFI(I)=0.
      FC(I)=0.
      DO 6 J=1,4
      FA(J,I)=0.
      FB(J,I)=0.
 6    NA(I)=0
      DO 7 I=1,3
      DO 7 J=1,3
      DO 7 K=1,LIMIT4
      TS(I,K)=0.
      FS(I,J,K)=0.
 7    CONTINUE
C-----TRIVIAL POSITION X,Y,Z
      FS(1,1,1)=1.
      FS(2,2,1)=1.
      FS(3,3,1)=1.
C-----LOOP OVER ALL DATA CARDS ON FILE ILV FOR ONE SET
 8    READ (ILV,43) INDF
C-----READ FIRST RECORD TO IDENTIFY FORMAT
      DO 9 J=1,8
      IF (INDF.NE.CAR(J)) GO TO 9
      M=J
      GO TO 10
 9    CONTINUE
      WRITE (IPR,44) INDF
      GO TO 35
C-----READ SECOND RECORD WITH CORRECT FORMAT
 10   GO TO (11,12,16,18,19,23,24,26), M
C-----T I T L E  CARD
 11   READ (ILV,45) (COMPND(I),I=1,19)
      GO TO 8
C-----A T O M  CARD
 12   READ (ILV,46) ELEMT1,IDE1,((IP(I,J),I=1,8),J=1,3),B1,FOCCU1
      CALL SLASH (XYZ(1),XYZ(2),XYZ(3))
      IF (FOCCU1.EQ.0.)FOCCU1=1.
      DO 13 I=1,NCOMPO
      NC=I
C-----ADD ATOM TO SAME ATOM KIND
      IF (ELEMT1.EQ.ELEMT(NC)) GO TO 14
 13   CONTINUE
C-----STORE ATOM AS NEW ATOMKIND
      IF (NA(1).EQ.0) GO TO 14
      NCOMPO=NCOMPO+1
      NC=NCOMPO
      IF (NCOMPO.LE.LIMIT2) GO TO 14
      WRITE (IPR,47) LIMIT2
      GO TO 35
 14   NA(NC)=NA(NC)+1
      I=NA(NC)
      IF (NA(NC).LE.LIMIT3) GO TO 15
      WRITE (IPR,48) NA(NC),ELEMT1,LIMIT3
      GO TO 35
 15   X(I,NC)=XYZ(1)
      Y(I,NC)=XYZ(2)
      Z(I,NC)=XYZ(3)
      ELEMT(NC)=ELEMT1
      IDE(I,NC)=IDE1
      FOCCU(I,NC)=FOCCU1
      BTEMP(I,NC)=B1
      GO TO 8
C-----C E L L  CARD
 16   READ (ILV,49) A,B,C,ALPHA,BETA,GAMMA
C-----CRYSTAL SYSTEM
      ISYSTM=2
      IF (B.NE.0.)GO TO 17
      IF (GAMMA.EQ.0.)ISYSTM=4
      IF (GAMMA.EQ.120.) ISYSTM=6
      IF (C.EQ.0.)ISYSTM=5
 17   IF (BETA.NE.0.)ISYSTM=1
      IF ((BETA.NE.0.).AND.(ALPHA.NE.0.)) ISYSTM=7
      GO TO 8
C-----L A T I C E  CARD
 18   READ (ILV,50) CEN,SYMBR
      IF (CEN.EQ.LJC) ISYMCE=1
      GO TO 8
C-----S Y M T R Y  CARD
 19   READ (ILV,51) (IGR(J),J=1,45)
      CALL EQVP
      IF (RN(1).EQ.999.9) GO TO 35
      NS=NS+1
      IF (NS.LE.LIMIT4) GO TO 20
      WRITE (IPR,52) LIMIT4
      GO TO 35
 20   DO 22 J=1,3
      IF (RD(J).EQ.0.) GO TO 21
      RD(J)=RN(J)/RD(J)
 21   TS(J,NS)=RD(J)
      FS(1,J,NS)=S1(J)
      FS(2,J,NS)=S2(J)
      FS(3,J,NS)=S3(J)
 22   CONTINUE
      GO TO 8
C-----C O N D I T  CARD
 23   READ (ILV,53) SYMWL,WL,TL,TH,NORM,IMAGE,SYMLP,IANO
C-----REPLACE BLANKS BY DEFAULT SYMBOLS
      IF (SYMWL.EQ.N3(19)) SYMWL=ISYMWL
      IF(TH.EQ.0.) TH=TH1
      IF(TH.GT.TH1) TH=TH1
      IF(TH.LT.TL)  TH=TL
      GO TO 8
C-----S P C G R P  CARD
 24   READ (ILV,54) (IGR(I),I=1,36)
      ISYST=0
      IGROUP=1
      CALL BURZ (ISYST,ISY,ISYB,NG)
      NS=NG
      NAG=NS
      SYMBR=ISYB
      ISYMCE=ISY
C-----MAKE ARRAY FROM BURZ COMPATIBLE WITH P U L V E R I X
      DO 25 I=1,3
      DO 25 IJ=1,3
      DO 25 IK=1,NS
      FS(I,IJ,IK)=SS(IK,IJ,I)
      TS(IJ,IK)=TSS(IK,IJ)
      ASS(IK,IJ,I)=SS(IK,IJ,I)
      ATS(IK,IJ)=TSS(IK,IJ)
 25   CONTINUE
      GO TO 8
C-----END OF FORMAT INTERPRETATION
 26   READ (ILV,43) INDF
261   IKF=1
	JKF=1
C-----CHECK FOR CELL AND ATOM CARD
      IF (NA(1).NE.0) GO TO 27
      WRITE (IPR,55)
      GO TO 36
 27   IF (A.NE.0.)GO TO 28
      WRITE (IPR,56)
      GO TO 36
C-----LORENTZ POLARISATION FACTOR
 28   KODLP=LP(SYMLP)
C-----CENTER OF SYMMETRY AT ORIGIN
      IF (CEN.EQ.LJC) ISYMCE=1
      IASYM=ISYMCE
C-----WAVELENGTH
      IF (WL.LT.0.02) WL=WAVE(SYMWL)
C-----LIMIT UPPER SIN**2 THETA VALUE FOR GUINIER CAMERA
      IF ((KODLP.GT.2).AND.(TH.GT.45.)) TH=THG
C-----TABULAR OUTPUT FEATURE
      IF (NORM.EQ.LBJ) INORM=0
      IF ((IANO.EQ.LBJ).AND.(ISYMCE.EQ.0).AND.(KODLP.NE.2)) INORM=2
      IF (NORM.EQ.LJA) INORM=1
C-----DEFAULT SYMMETRY OPERATOR
      IF (NS.EQ.0) NS=1
C-----DERIVE BRAVAIS LATTICE INDICATOR
      IBRAVL=BRA(SYMBR)
      IABRA=IBRAVL
C-----CALCULATE MULTIPLICITIES OF SPECIAL ATOM POSITIONS
      CALL MULTF(TS,FS,X,Y,Z,FOCCU,FMULT,BTEMP)
C-----ANOMALOUS  DISPERSION INDICATOR
      DANO=0.
      IF ((IANO.EQ.LBJ).AND.(KODLP.NE.2)) ANO=1.
C-----CHECK CRYSTAL SYSTEM
      IF (ISYST.EQ.0) GO TO 29
      IF (ISYST.EQ.ISYSTM) GO TO 29
      WRITE (IPR,57)
C-----TAKE CRYSTAL SYSTEM FROM GROUP CARD
      ISYSTM=ISYST
C-----CALCULATE EXTINCTIONS,LAUE GROUP AND TRIGONAL SYMMETRY INDICATOR
 29   CALL EXTINC (ISYMCE,NS,TS,FS)
      IF (ISYSTM.EQ.6) ISYSTM=ITRIG
C-----RETRIEVE SCATTERING FACTORS FOR X RAY,NEUTRON AND ANOM.DISP.
      DO 33 I=1,NCOMPO
      FNEU=0.
      NC=I
      DELFR(I)=0.
      ASYMB=ELEMT(NC)
      DELFI(I)=0.
      IF (KODLP.NE.2) GO TO 31
C-----RETRIEVE NEUTRON SCATTERING LENGTH
      CALL ANOMA (SYMWL,ELEMT(NC),KODLP,IDEUX,JKF,FNEU)
      IF (FNEU.NE.0.) GO TO 30
      WRITE (IPR,58) ELEMT(NC)
      GO TO 36
 30   FNEUT(NC)=FNEU
      GO TO 33
 31   IF ( ANO .EQ.0.) GO TO 32
C-----RETRIEVE ANOMALOUS DISPERSION COEFFICIENTS
      CALL ANOMA (SYMWL,ASYMB,KODLP,IDEUX,JKF,FNEU)
      DELFR(NC)=DEL1
      DELFI(NC)=DEL2
C-----RETRIEVE CROMER-MANN COEFFICIENTS
32    CALL SYMBF(ASYMB,IKF)
	IF(IKF.NE.0)GO TO 321
	WRITE(IPR,322)ASYMB
322   FORMAT(1X,'Pas de table de facteur de forme pour : ',A4/)
	GO TO 36
321   CONTINUE !!READ(IUN'IKF)(FA(J,NC),FB(J,NC),J=1,4),FC(NC)                
 33   CONTINUE
C-----WRITE DATA FOR FOLLOWING PROGRAM PULVR2 ON UNIT ILU
      WRITE (ILU) (COMPND(I),I=1,19),A,B,C,ALPHA,BETA,GAMMA,WL,(IGR(I),I
     1=1,36),IGROUP, SYMWL, SYMLP
      WRITE (ILU) ISYSTM,ISYMCE,IBRAVL,NS,TL,TH,INORM,IMAGE,ANO,KODLP,NC
     1OMPO,(NA(I),I=1,8),IHOO,IOKO,IOOL,IHHL,IHOL,IHKO,IOKL,LAUE
      WRITE (ILU) ((TS(I,II),(FS(K,I,II),K=1,3),I=1,3),II=1,NS)
      DO 34 M=1,NCOMPO
      NL=NA(M)
      WRITE (ILU) DELFR(M),DELFI(M)
      WRITE (ILU) ELEMT(M),(FA(I,M),FB(I,M),I=1,4),FC(M),FNEUT(M)
      WRITE (ILU) (ELEMT(M),IDE(I,M),X(I,M),Y(I,M),Z(I,M),FMULT(I,M),FOC
     1CU(I,M),BTEMP(I,M),I=1,NL)
 34   CONTINUE
      WRITE (IPR,59) IJOB
      GO TO 37
C-----SKIP RECORDS UNTIL END CARD
 35   READ (ILV,43) INDF
      IF (INDF.NE.CAR(8)) GO TO 35
      READ(ILV,43) INDF
 36   WRITE (IPR,60) IJOB
C-----WRITE ONE DUMMY RECORD FOR BAD JOB
      A=-1.
      WRITE (ILU) (COMPND(I),I=1,19),A,B,C,ALPHA,BETA,GAMMA,WL,(IGR(I),I
     1=1,36),IGROUP
 37   CONTINUE
C-----END OF DATA PREPARATION
      REWIND ILU
      WRITE (IPR,61)
 38   FORMAT (/2X,'Date : ',9A1,5X,'Heure : ',8A1,
     *5X,'START *** LAZY ***'/)
 39   FORMAT (40A2)
391   FORMAT(40A2)
 40   FORMAT (//12H INPUT CARDS//4H JOB,I6//3H *.,7(10H*********.),1H*)
 41   FORMAT (3H * ,35A2,1H*)
 42   FORMAT (3H *.,7(10H*********.),1H*)
 43   FORMAT (A2)
 44   FORMAT (16H FORMAT LETTERS ,A2,15H NOT RECOGNIZED)
 45   FORMAT (6X,18A4,A2)
 46   FORMAT (7X,A4,A2,3(8A1),F6.2,F5.2)
 47   FORMAT (6H ONLY ,I5,19H ATOM KINDS ALLOWED)
 48   FORMAT (I5,9H ATOMS OF,A4,15H NUMBER ALLOWED,I5)
 49   FORMAT (13X,3F8.0,3F9.0)
 50   FORMAT (8X,A1,2X,A1)
 51   FORMAT (6X,45A1)
 52   FORMAT (10H MORE THAN,I5,13H SYMTRY CARDS)
 53   FORMAT (10X,A4,F6.0,2F5.0,1X,A1,I2,A4,1X,A1)
 54   FORMAT (6X,36A1)
 55   FORMAT (23H NO ATOM CARD WAS FOUND)
 56   FORMAT (23H NO CELL CARD WAS FOUND  )
 57   FORMAT (/12H * WARNING */,76H CRYSTAL SYSTEM SPECIFIED ON CELL CAR
     1D AND ON GROUP CARD ARE NOT CONSISTENT  )
 58   FORMAT (37H NEUTRON SCATTERING LENGTH FOR SYMBOL,2X,A4,19H HAS NOT
     1 BEEN FOUND)
 59   FORMAT (/2X,'Job ',I3,'   O K ',5X,'Fin d execution : ',8A1/)
 60   FORMAT (/5H JOB ,I5,7H FAILED//)
 61   FORMAT (/16H END OF  L A Z Y)
      RETURN
      END
      FUNCTION WAVE (SYML)
C-----DERIVES WAVELENGTH FOR RADIATION SYMBOL SYML
      COMMON/WAVEL/ CT
      DIMENSION CT(20), W(20)
      DATA W(1)/2.28970/,W(2)/2.29361/,W(3)/2.0848/,W(4)/2.2909/,W(5)/1.
     193604/,W(6)/1.93998/,W(7)/1.75653/,W(8)/1.9373/,W(9)/1.54056/,W(10
     2)/1.54439/,W(11)/1.39217/,W(12)/1.5418/,W(13)/0.70930/,W(14)/0.713
     359/,W(15)/0.63225/,W(16)/0.7107/,W(17)/0.55941/,W(18)/0.56380/,W(1
     49)/0.49701/,W(20)/0.5608/
      DO 1 I=1,20
      IF (SYML-CT(I)) 1,2,1
 1    CONTINUE
      WAVE=W(12)
      RETURN
 2    WAVE=W(I)
      RETURN
      END
      FUNCTION LP (SYMLP)
C-----ASSIGNS SEQUENCE NUMBER LP TO EACH LOR.POL. SYMBOL SYMLP
      COMMON /FLOR/ LPF,CS
      DIMENSION LPF(6), CS(6)
      DO 1 I=1,6
      IF (SYMLP-CS(I)) 1,2,1
 1    CONTINUE
      LP=LPF(1)
      RETURN
 2    LP=LPF(I)
      RETURN
      END
      FUNCTION BRA (SYMBR)
C-----ASSIGNS SEQUENCE NUMBER BRA TO BRAVAIS LATTICE SYMBOL SYMBR
      COMMON /BRAF/ IB,CU
      INTEGER CU,SYMBR
      DIMENSION IB(8), CU(8)
      DO 1 I=1,8
      IF (SYMBR-CU(I)) 1,2,1
 1    CONTINUE
      BRA=IB(1)
      RETURN
 2    BRA=IB(I)
      RETURN
      END
	SUBROUTINE SLASH(X,Y,Z)
C-----INTERPRETS COORDINATES GIVEN IN FRACTIONAL FORM
	CHARACTER*1 IP,ID
      COMMON /SLAS/ IP(8,3)
      DIMENSION ID(13), FDE(2), IK(2), XYZ(3)
      DATA ID(1)/1H0/,ID(2)/1H1/,ID(3)/1H2/,ID(4)/1H3/,ID(5)/1H4/,ID(6)/
     11H5/,ID(7)/1H6/,ID(8)/1H7/,ID(9)/1H8/,ID(10)/1H9/,ID(11)/1H./,
     2ID(12)/1H-/,ID(13)/1H /
C-----NUMBER OF COLUMNS IN FORMAT FIELD OF ATOM CARD
      NFIELD=8
      DO 5 L=1,3
      IK(1)=1
      IK(2)=1
      FDE(1)=0
      FDE(2)=0
      NPOI=1
      X=1.
      IJ=1
      K=1
C-----LOOP OVER NUMBER OF FIELDS
      DO 3 I=1,NFIELD
      K=NFIELD+1-I
      DO 1 II=1,10
      IF (IP(K,L).EQ.ID(11)) NPOI=-1
      IF (IP(K,L).EQ.ID(12)) X=-1.
      IF (IP(K,L).EQ.ID(13)) GO TO 3
      IF (IP(K,L).EQ.ID(II)) GO TO 2
 1    CONTINUE
      IJ=2
      GO TO 3
 2    FDE(IJ)=FDE(IJ)+10**(IK(IJ)-1)*(II-1)
      IK(IJ)=IK(IJ)+1
 3    CONTINUE
      IF (FDE(1).NE.0.)GO TO 4
      XYZ(L)=0.
      GO TO 5
 4    IF (NPOI.NE.-1) X=X*FDE(2)/FDE(1)
      EX=-IK(1)+1
      IF (NPOI.EQ.-1) X=FDE(2)*X+X*FDE(1)*10.**EX
C-----MAKE COORDINATE POSITIVE
      IF (X.LT.-1.) X=X+1.
      XYZ(L)=X
 5    CONTINUE
      RETURN
      END
      SUBROUTINE EQVP
C-----DECODES EQUIVALENT POSITION CARD
      COMMON /UNITS/ ICR,IPR,ILU
      COMMON /POSIT/ RNN,RDD,S1N,SZN,S3N,IPOS
      DIMENSION IPOS(45), IC(18)
      DIMENSION RNN(3), RDD(3), S1N(3), SZN(3), S3N(3)
      DATA IC(1)/1HX/,IC(2)/1HY/,IC(3)/1HZ/,IC(4)/1H-/,IC(5)/1H,/,IC(6)/
     11H /,IC(7)/1H+/,IC(8)/1H//,IC(9)/1H0/,IC(10)/1H1/,IC(11)/1H2/,IC(1
     22)/1H3/,IC(13)/1H4/,IC(14)/1H5/,IC(15)/1H6/,IC(16)/1H7/,IC(17)/1H8
     3/,IC(18)/1H9/
      DO 1 J=1,3
      RDD(J)=0
      RNN(J)=0
      S1N(J)=0
      SZN(J)=0
      S3N(J)=0
 1    CONTINUE
      K=1
      J=1
      VZ=1.
C-----LOOP OVER ALL FIELDS
      DO 13 N=1,45
      DO 2 II=1,18
      IF (IPOS(N).NE.IC(II)) GO TO 2
      M=II
      IPOS(N)=IC(6)
      GO TO 3
 2    CONTINUE
      WRITE (IPR,15) IPOS(N)
      RNN(1)=999.9
      RETURN
 3    GO TO (7,8,9,10,11,13,13,13,4,4,4,4,4,4,4,4,4,4), M
 4    GO TO (5,6), K
 5    RNN(J)=M-9
      K=2
      GO TO 13
 6    RDD(J)=M-9
      K=1
      GO TO 13
 7    S1N(J)=VZ
      GO TO 12
 8    SZN(J)=VZ
      GO TO 12
 9    S3N(J)=VZ
      GO TO 12
 10   VZ=-1.
      GO TO 13
 11   J=J+1
      GO TO 13
 12   VZ=1.
 13   CONTINUE
      IF (J.EQ.3) GO TO 14
      WRITE (IPR,16)
      RNN(1)=999.9
 14   RETURN
C
 15   FORMAT (25H0WRONG CODE OF EQUIPOINT=,A1)
 16   FORMAT (22H0EQUIPOINT INCOMPLETE )
      END
C
C
C
      SUBROUTINE BURZ (ISYSTM,ISYMCE,IBRAVL,NG)
C-----ROUTINE TO INTERPRET HERMANN MAUGUIN SYMBOL FOR SPACE GROUP
C-----THIS ROUTINE HAS BEEN ADAPTED FROM A PROGRAM SUPPLIED BY
C-----PROF. BURZLAFF, UNIVERSITY OF ERLANGEN, GERMANY
      INTEGER E(3,3),ZEI(3,4),SYS,SS
      COMMON/BURC/TS,SS
      COMMON /POSIT/ RN,RD,S1,S2,S3,NT
      COMMON /UNITS/ NRD,NPT,ILU
      DIMENSION NT(45), IBRA(7), NMA(3), SH(3),TE(3)
      DIMENSION RN(3), RD(3), S1(3), S2(3), S3(3),ISYS(7)
      DIMENSION SS(24,3,3),TS(24,3)
      INTEGER N3(20)
      DATA ISYS/7,1,2,4,6,5,3/
      DATA IBRA/'P','A','B','C','F','I','R'/,NMA/3*0/,SH/3*0.25/
      DATA N3/'1','2','3','4',' ','6','A','B','C','D','M','N','P',
     1        ' ','/','-',4*' '/
C     WRITE (6,6020) NT
C6020 FORMAT(1X,76A1)
 1    NBL=-1
      NG=1
      NS=1
      DO 2 I=1,24
      DO 2 J=1,3
      TS(I,J)=0.0
      DO 2 K=1,3
      E(J,K)=0
      SS(I,J,K)=0
 2    CONTINUE
      SS(1,1,1)=1
      SS(1,2,2)=1
      SS(1,3,3)=1
      DO 3 I=1,3
      TE(I)=0.0
      DO 3 J=1,4
 3    ZEI(I,J)=0
      DO 8 I=1,36
      KXK=NT(I)
      IF (KXK.NE.N3(5)) GO TO 4
      NLQ=0
      IC=0
      GO TO 8
 4    IF (NBL.GE.0) GO TO 7
      DO 5 J=1,7
      NBR=J
C     WRITE(6,6004) KXK
C6004 FORMAT(1X,'BRAVAIS=',1X,A1)
      IF (KXK.EQ.IBRA(J)) GO TO 6
 5    CONTINUE
      NBR=8
 6    NBL=0
      IBRAVL=KXK
C     WRITE(6,6003) IBRAVL
C6003 FORMAT(1X,'BRAVAIS =',I3)
      GO TO 8
 7    IF (NLQ.EQ.0) NBL=NBL+1
      IC=IC+1
      ZEI(NBL,IC)=KXK
      NLQ=1
      IF (KXK.EQ.N3(15)) NS=0
 8    CONTINUE
      DO 9 I=1,4
      IF (ZEI(2,I).NE.N3(3)) GO TO 9
      SYS=6
      GO TO 15
 9    CONTINUE
      DO 11 I=1,4
      IF (ZEI(1,I).NE.N3(3).AND.ZEI(1,I).NE.N3(6)) GO TO 10
      SYS=5
      GO TO 15
 10   IF (ZEI(1,I).NE.N3(4)) GO TO 11
      SYS=4
      GO TO 15
 11   CONTINUE
      IF (NBL.GT.1) GO TO 14
      IF (ZEI(1,1).NE.N3(1).AND.ZEI(1,1).NE.N3(16)) GO TO 12
      SYS=1
      GO TO 15
 12   SYS=2
      DO 13 I=1,4
 13   ZEI(2,I)=ZEI(1,I)
      ZEI(1,1)=N3(1)
      ZEI(3,1)=N3(1)
 14   SYS=3
      IF (ZEI(1,1).EQ.N3(1).OR.ZEI(2,1).EQ.N3(1)) SYS=2
 15   GO TO (16,17,22,46,58,68), SYS
C-----TRICLINIC
 16   IF (ZEI(1,1).EQ.N3(16)) NS=0
      GO TO 76
C-----MONOCLINIC
 17   NG=2
      DO 18 I=1,3
 18   IF (ZEI(I,1).NE.N3(1)) IND=I
      ID=1
      IF (ZEI(IND,1).EQ.N3(2)) ID=-1
C     WRITE(6,6000) ID,IND
C6000 FORMAT(1X,'ID= ',I3,' IND= ',I3)
      DO 19 I=1,3
 19   SS(2,I,I)=SS(1,I,I)*ID
C     WRITE(6,6001) SS(2,3,3)
C6001 FORMAT(1X,'SS(2,3,3)=',F10.1)
      SS(2,IND,IND)=-SS(2,IND,IND)
C     WRITE(6,6001) SS(2,IND,IND)
      DO 21 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(2,I)=0.5
      DO 21 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(2,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(2,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(2,3)=0.5
      IF (ZEI(I,J).EQ.N3(12)) GO TO 20
      GO TO 21
 20   K=I+1
      IF (K.GT.3) K=K-3
      TS(2,K)=0.5
      TS(2,6-K-I)=0.5
 21   CONTINUE
      GO TO 76
C-----ORTHORHOMBIC
 22   NG=4
      IC=0
      IND=1
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(2,1).NE.N3(2).AND.ZEI(3,1).NE.N3(2))
     1IND=-1
      IF (IND.EQ.-1) NS=0
      DO 24 I=1,3
      ID=1
      IF (ZEI(I,1).EQ.N3(2)) ID=-1
      DO 23 J=1,3
 23   SS(1+I,J,J)=SS(1,J,J)*ID*IND
 24   SS(1+I,I,I)=-SS(1+I,I,I)
      DO 28 I=1,3
      IF (ZEI(I,1).EQ.N3(2).AND.ZEI(I,2).EQ.N3(1)) TS(1+I,I)=0.5
      DO 28 J=1,4
      IF (ZEI(I,J).EQ.N3(7)) TS(1+I,1)=0.5
      IF (ZEI(I,J).EQ.N3(8)) TS(1+I,2)=0.5
      IF (ZEI(I,J).EQ.N3(9)) TS(1+I,3)=0.5
      IF (ZEI(I,J).EQ.N3(12).OR.ZEI(I,J).EQ.N3(10)) GO TO 25
      GO TO 28
 25   K=I+1
      IF (K.GT.3) K=K-3
      IF (ZEI(I,J).EQ.N3(10)) GO TO 26
      TS(1+I,K)=0.5
      TS(1+I,6-K-I)=0.5
      GO TO 28
 26   IC=1
      IF (NS.EQ.1) GO TO 27
      TS(1+I,K)=0.25
      TS(1+I,6-K-I)=0.25
      GO TO 28
 27   TS(1+I,1)=0.25
      TS(1+I,2)=0.25
      TS(1+I,3)=0.25
 28   CONTINUE
      IF (IC.EQ.1) GO TO 76
      IF (NS.EQ.1) GO TO 36
      DO 29 I=1,3
      K=1+I
      IF (K.GT.3) K=K-3
      TC=TS(1+K,I)+TS(1+6-I-K,I)
      IF (TC.EQ.1.0) TC=0.0
 29   TS(1+I,I)=TC
C-----SPECIAL TREATMENT OF C M M A, C M C A, I M M A
      IF (NBR.EQ.1.OR.NBR.EQ.5) GO TO 76
      MA=0
      DO 31 I=1,3
      DO 30 J=1,4
 30   IF (ZEI(I,J).EQ.N3(11)) NMA(I)=1
 31   MA=MA+NMA(I)
      IF (NBR.EQ.6.AND.MA.EQ.2) GO TO 33
      IF (MA.EQ.0.OR.MA.EQ.3.OR.NBR.EQ.6) GO TO 76
      DO 32 I=1,3
      IF (NMA(NBR-1).EQ.1) GO TO 76
 32   SH(NBR-1)=0.
C-----ORIGIN SHIFT
 33   DO 35 I=1,NG
      DO 35 J=1,3
      DO 34 K=1,3
      ID=1
      IF (J.NE.K) ID=0
 34   TS(I,J)=TS(I,J)+(ID-SS(I,J,K))*SH(K)
      IF (TS(I,J).GT.1.) TS(I,J)=TS(I,J)-1.
 35   IF (TS(I,J).LT.1.0) TS(I,J)=TS(I,J)+1.
      GO TO 76
 36   IC=0
      DO 37 I=1,3
 37   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.-1) IC=1
      IF (IC.EQ.1) GO TO 41
      TC=TS(2,1)+TS(3,2)+TS(4,3)
      IF (TC.EQ.0.0) GO TO 76
      DO 40 I=1,3
      K=I+1
      IF (K.GT.3) K=K-3
      IF (TC.GT.0.5) GO TO 38
      IF (TS(1+I,I).EQ.0.0) GO TO 40
      M=I-1
      IF (M.EQ.0) M=M+3
      TS(1+M,I)=0.5
      GO TO 40
 38   IF (TC.GT.1.0) GO TO 39
      IF (TS(1+I,I).NE.0.0) GO TO 40
      L=K+1
      IF (L.GT.3) L=L-3
      TS(1+K,L)=0.5
      TS(1+L,K)=0.5
      GO TO 40
 39   TS(1+I,K)=0.5
 40   CONTINUE
      GO TO 76
 41   DO 42 I=1,3
 42   IF (SS(1+I,1,1)*SS(1+I,2,2)*SS(1+I,3,3).EQ.1) ID=I
      DO 45 I=1,3
      TC=TS(2,I)+TS(3,I)+TS(4,I)
      IF (TC.EQ.0.0.OR.TC.EQ.1.0) GO TO 45
      IF (ZEI(1,1).EQ.N3(11).AND.ZEI(2,1).EQ.N3(12).OR.ZEI(2,1).EQ.
     1N3(11).AND.ZEI(3,1).EQ.N3(12).OR.ZEI(3,1).EQ.N3(11).AND.ZEI(1,1)
     2.EQ.N3(12)) GO TO 44
      DO 43 J=1,3
      IF (ID.EQ.J) GO TO 43
      IF (TS(1+J,I).EQ.0.5) GO TO 43
      TS(1+J,I)=0.5
 43   CONTINUE
      GO TO 45
 44   K=I-1
      IF (K.EQ.0) K=K+3
      TS(1+K,I)=0.5
 45   CONTINUE
      GO TO 76
C-----TETRAGONAL
 46   NG=4
      IF (NBL.EQ.3) NG=8
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      M=ZEI(1,1)
      N=ZEI(1,2)
      DO 47 I=1,3
      DO 47 J=1,3
 47   IF (M.EQ.N3(16)) SS(2,I,J)=-SS(2,I,J)
      IF (M.EQ.N3(16)) GO TO 50
      IF (N.EQ.N3(1)) TS(2,3)=0.25
      IF (N.EQ.N3(2)) TS(2,3)=0.5
      IF (N.EQ.N3(3)) TS(2,3)=0.75
      IF (ZEI(1,3).EQ.N3(12).OR.(ZEI(1,4).EQ.N3(12).AND.NBL.EQ.3))
     1TS(2,1)=0.5
      IF ((ZEI(1,4).EQ.N3(12).AND.NBL.EQ.1).OR.(N.EQ.N3(1).AND.NS.EQ.1.
     1AND.NBR.EQ.6)) TS(2,2)=0.5
      IF (N.EQ.N3(1).AND.NS.EQ.0.AND.NBR.EQ.6) GO TO 48
      IF (ZEI(2,2).EQ.N3(1).OR.(ZEI(1,4).NE.N3(12).AND.ZEI(2,1).EQ.
     1N3(12).AND.ZEI(3,1).EQ.N3(11))) GO TO 49
      GO TO 50
 48   TS(2,1)=0.25
      TS(2,2)=0.75
      IF (NBL.EQ.1) TS(2,1)=0.75
      IF (NBL.EQ.1) TS(2,2)=0.25
      GO TO 50
 49   TS(2,1)=0.5
      TS(2,2)=0.5
 50   SS(3,1,1)=-1
      SS(3,2,2)=-1
      SS(3,3,3)=1
      TS(3,1)=SS(2,1,2)*TS(2,2)+TS(2,1)
      TS(3,2)=SS(2,2,1)*TS(2,1)+TS(2,2)
      TS(3,3)=SS(2,3,3)*TS(2,3)+TS(2,3)
      DO 51 I=1,3
 51   IF (NBR.EQ.6.AND.TS(3,1).EQ.0.5.AND.TS(3,2).EQ.0.5.AND.TS(3,3).EQ.
     10.5) TS(3,I)=0.0
      DO 52 I=1,3
      TS(4,I)=TS(2,I)
      DO 52 J=1,3
      TS(4,I)=TS(4,I)+SS(2,I,J)*TS(3,J)
      DO 52 K=1,3
 52   SS(4,I,J)=SS(4,I,J)+SS(2,I,K)*SS(3,K,J)
      IF (NBL.EQ.1) GO TO 76
      IF (NS.EQ.0) GO TO 56
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.NE.N3(2).AND.N.NE.N3(2)) GO TO 55
      IF (M.EQ.N3(2).AND.N.EQ.N3(2)) GO TO 54
      IF (M.EQ.N3(2)) GO TO 53
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.NE.N3(12).AND.M.NE.N3(8)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 53   E(1,1)=1
      E(2,2)=-1
      E(3,3)=-1
      IF (N.EQ.N3(9)) TE(3)=0.5
      IF (N.EQ.N3(10)) TE(3)=0.25
      IF (N.EQ.N3(10)) TE(2)=0.5
      IF (ZEI(2,2).NE.N3(1)) GO TO 57
      TE(1)=0.5
      TE(2)=0.5
      GO TO 57
 54   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      IF (ZEI(2,2).NE.0.OR.NBR.EQ.6.OR.ZEI(1,2).EQ.0) GO TO 57
      IF (ZEI(1,2).EQ.N3(1)) TE(3)=0.75
      IF (ZEI(1,2).EQ.N3(2)) TE(3)=0.5
      IF (ZEI(1,2).EQ.N3(3)) TE(3)=0.25
      GO TO 57
 55   M=ZEI(2,1)
      E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (M.EQ.N3(9).OR.M.EQ.N3(12)) TE(3)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(1)=0.5
      IF (M.EQ.N3(12).OR.M.EQ.N3(8)) TE(2)=0.5
      GO TO 57
 56   E(1,1)=-1
      E(2,2)=1
      E(3,3)=1
      IF (ZEI(2,1).EQ.N3(9).OR.ZEI(2,1).EQ.N3(12)) TE(3)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(2)=0.5
      IF (ZEI(2,1).EQ.N3(8).OR.ZEI(2,1).EQ.N3(12)) TE(1)=0.5
      IF (ZEI(1,3).EQ.N3(12).OR.ZEI(1,4).EQ.N3(12)) TE(1)=TE(1)+0.5
 57   NE=4
      GO TO 74
C-----HEXAGONAL
 58   NG=3
      M=ZEI(1,1)
      N=ZEI(1,2)
      IF (M.EQ.N3(16).AND.N.EQ.N3(3)) NS=0
      IF (M.EQ.N3(6)) GO TO 61
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,2,2)=-1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/3.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/3.0
      SS(3,1,1)=-1
      SS(3,2,1)=-1
      SS(3,1,2)=1
      SS(3,3,3)=1
      TS(3,3)=2.0*TS(2,3)
      IF (TS(3,3).GE.1.0) TS(3,3)=TS(3,3)-1.0
      IF (NBL.EQ.1.AND.N.NE.N3(6)) GO TO 76
      IF (N.NE.N3(6)) GO TO 60
      NG=NG+NG
      DO 59 I=1,3
      DO 59 J=1,3
      DO 59 K=1,3
      SS(3+I,J,K)=SS(I,J,K)
 59   SS(3+I,3,3)=-1
 60   IF (NBL.EQ.1) GO TO 76
      IF (ZEI(2,1).NE.N3(9).AND.ZEI(3,1).NE.N3(9)) GO TO 63
      TS(4,3)=0.5
      TS(5,3)=0.5
      TS(6,3)=0.5
      GO TO 63
 61   NG=NG+NG
      SS(2,1,1)=1
      SS(2,1,2)=-1
      SS(2,2,1)=1
      SS(2,3,3)=1
      IF (N.EQ.N3(1)) TS(2,3)=1.0/6.0
      IF (N.EQ.N3(2)) TS(2,3)=2.0/6.0
      IF (N.EQ.N3(3)) TS(2,3)=3.0/6.0
      IF (N.EQ.N3(4)) TS(2,3)=4.0/6.0
      IF (N.EQ.N3(5)) TS(2,3)=5.0/6.0
      DO 62 I=1,4
      DO 62 J=1,3
      TS(2+I,J)=TS(2,J)
      DO 62 K=1,3
      TS(2+I,J)=TS(2+I,J)+SS(2,J,K)*TS(1+I,K)
      IF (TS(2+I,J).GT.1.0) TS(2+I,J)=TS(2+I,J)-1.0
      DO 62 L=1,3
 62   SS(2+I,J,K)=SS(2+I,J,K)+SS(2,J,L)*SS(1+I,L,K)
      IF (NBL.EQ.1) GO TO 76
 63   NG=NG+NG
      M=ZEI(2,1)
      N=ZEI(3,1)
      IF (M.EQ.N3(1)) GO TO 65
      IF (M.EQ.N3(2)) GO TO 64
      E(1,2)=-1
      E(2,1)=-1
      E(3,3)=1
      IF (M.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 64   E(1,2)=1
      E(2,1)=1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
C-----GROUP P 31 I 2 AND P 32 I 2
      IF (ZEI(1,1).EQ.N3(3).AND.(ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.
     1N3(2))) TE(3)=0.
      GO TO 67
 65   IF (N.EQ.N3(2)) GO TO 66
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (N.EQ.N3(9)) TE(3)=0.5
      GO TO 67
 66   E(1,2)=-1
      E(2,1)=-1
      E(3,3)=-1
      TE(3)=2.0*TS(2,3)
      IF (TE(3).GT.1.0) TE(3)=TE(3)-1.0
 67   NE=6
      IF (ZEI(1,1).EQ.N3(3).OR.(ZEI(1,2).EQ.N3(3).AND.ZEI(1,1).EQ.
     1N3(16))) NE=3
      GO TO 74
C-----CUBIC
 68   NG=12
      IF (NBL.EQ.3) NG=24
      IF (ZEI(1,1).NE.N3(2).AND.ZEI(1,1).NE.N3(4).AND.ZEI(1,1).NE.
     1N3(16)) NS=0
      DO 69 I=1,3
      DO 69 J=1,3
      SS(1+I,J,J)=1
      IF (I.EQ.J) GO TO 69
      SS(1+I,J,J)=-1
      IF (ZEI(1,1).EQ.N3(12)) TS(1+I,J)=0.5
      IF (ZEI(1,1).EQ.N3(10)) TS(1+I,J)=0.25
 69   CONTINUE
      IF (ZEI(1,1).NE.N3(7).AND.ZEI(3,1).NE.N3(10).AND.ZEI(1,2).NE.N3(3)
     1.AND.ZEI(1,2).NE.N3(1).OR.NBR.EQ.5) GO TO 71
      DO 70 I=1,3
      TS(1+I,I)=0.5
      K=I+1
      IF (K.EQ.4) K=1
 70   TS(1+I,K)=0.5
 71   DO 72 I=1,4
      DO 72 J=1,3
      DO 72 K=1,3
      L=J+1
      IF (L.EQ.4) L=1
      M=J-1
      IF (M.EQ.0) M=3
      SS(4+I,J,K)=SS(I,L,K)
      SS(8+I,J,K)=SS(I,M,K)
      TS(4+I,J)=TS(I,L)
 72   TS(8+I,J)=TS(I,M)
      IF (NG.EQ.12) GO TO 76
      NE=12
      E(1,2)=1
      E(2,1)=1
      E(3,3)=1
      IF (ZEI(3,1).EQ.N3(2)) E(3,3)=-1
      IF (ZEI(3,1).EQ.N3(9)) TE(3)=0.5
      DO 73 I=1,3
      IF (ZEI(3,1).EQ.N3(12).OR.ZEI(1,2).EQ.N3(2)) TE(I)=0.5
 73   IF (ZEI(3,1).EQ.N3(10).OR.ZEI(1,2).EQ.N3(1).OR.ZEI(1,2).EQ.N3(3))
     1TE(I)=0.25
      IF (ZEI(1,2).EQ.N3(1).AND.NBR.EQ.1) TE(1)=0.75
      IF ((ZEI(1,2).NE.N3(1).OR.NBR.NE.6).AND.(ZEI(1,2).NE.N3(3).OR.NBR
     1.NE.1)) GO TO 74
      TE(2)=0.75
      TE(3)=0.75
 74   DO 75 I=1,NE
      DO 75 J=1,3
      TS(NE+I,J)=TE(J)
      DO 75 K=1,3
      TS(NE+I,J)=TS(NE+I,J)+E(J,K)*TS(I,K)
      DO 75 L=1,3
 75   SS(NE+I,J,K)=SS(NE+I,J,K)+E(J,L)*SS(I,L,K)
 76   DO 81 I=1,NG
      DO 81 J=1,3
 77   IF (TS(I,J).GE.1.0) GO TO 78
      GO TO 79
 78   TS(I,J)=TS(I,J)-1.0
      GO TO 77
 79   IF (TS(I,J).LT.0.0) GO TO 80
      GO TO 81
 80   TS(I,J)=TS(I,J)+1.0
      GO TO 79
 81   CONTINUE
      ISYSTM=ISYS(SYS)
      ISYMCE=1-NS
C     WRITE(6,6010) ISYMCE,NG
C6010 FORMAT(' ISYMCE=',I3,' NG=',I3)
      RETURN
      END
      SUBROUTINE EXTINC (ISYMCE,NS,TS,FS)
C-----FINDS EXTINCTIONS, LAUE GROUP AND HEXAGONAL SYMMETRY INDICATOR
      COMMON /EXTI/ IHOO,IOKO,IOOL,IHKO,IHOL,IOKL,IHHL,ILAU,ITRIG
      COMMON /UNITS/ NRD,NPT,ILU
      DIMENSION TS(3,24), FS(3,3,24)
      ILAU=1
      Q1=1./3.
      Q2=1./6.
      Q3=2./3.
      Q4=5./6.
      DO 2 I=1,NS
      POIN=0.
      R=TS(1,I)
      S=TS(2,I)
      T=TS(3,I)
      X=FS(1,1,I)*10.+FS(2,1,I)*50.+FS(3,1,I)*100.
      Y=FS(1,2,I)*10.+FS(2,2,I)*50.+FS(3,2,I)*100.
      Z=FS(1,3,I)*10.+FS(2,3,I)*50.+FS(3,3,I)*100.
      XO=ABS(X)
      YO=ABS(Y)
      ZO=ABS(Z)
      IF ((R.EQ..5).AND.(XO.EQ.10.)) IHOO=2
      IF ((S.EQ..5).AND.(YO.EQ.50.)) IOKO=2
      IF (IOOL.GT.3) GO TO 1
      IF ((T.EQ..5).AND.(ZO.EQ.100.)) IOOL=2
      IF ((T.EQ.Q2).OR.(T.EQ.Q4)) IOOL=6
      IF ((T.EQ.Q1).OR.(T.EQ.Q3)) IOOL=3
      IF ((T.EQ..25).OR.(T.EQ..75)) IOOL=4
 1    IF ((X.EQ.50.).AND.(Y.EQ.10.)) ILAU=2
      IF ((X.EQ.-50.00).AND.(Y.EQ.-10.00)) ILAU=2
      IF ((X.EQ.-40.).AND.(Y.EQ.10.).AND.(Z.EQ.100.)) ITRIG=6
      IF ((X.EQ.40.00).AND.(Y.EQ.-10.00).AND.(Z.EQ.-100.00)) ITRIG=6
      IF (((S.EQ..25).OR.(S.EQ..75)).AND.(YO.EQ.50.)) IOKO=4
      IF (((R.EQ..25).OR.(R.EQ..75)).AND.(XO.EQ.10.)) IHOO=4
      X=X+R
      Y=Y+S
      Z=Z+T
      IF ((X.EQ.10.5).AND.(Y.EQ.50.5)) IHKO=2
      IF ((X.EQ.10.0).AND.(Y.EQ.50.5)) IHKO=3
      IF ((X.EQ.10.25).AND.(Y.EQ.50.25)) IHKO=4
      IF ((X.EQ.10.75).AND.(Y.EQ.50.75)) IHKO=4
      IF ((X.EQ.10.50).AND.(Y.EQ.50.00)) IHKO=5
      IF ((Y.EQ.50.50).AND.(Z.EQ.100.50)) IOKL=2
      IF ((Y.EQ.50.00).AND.(Z.EQ.100.50)) IOKL=3
      IF ((Y.EQ.50.25).AND.(Z.EQ.100.25)) IOKL=4
      IF ((Y.EQ.50.75).AND.(Z.EQ.100.75)) IOKL=4
      IF ((Y.EQ.50.50).AND.(Z.EQ.100.00)) IOKL=5
      IF ((X.EQ.10.5).AND.(Z.EQ.100.50)) IHOL=2
      IF ((X.EQ.10.0).AND.(Z.EQ.100.50)) IHOL=3
      IF ((X.EQ.10.25).AND.(Z.EQ.100.25)) IHOL=4
      IF ((X.EQ.10.75).AND.(Z.EQ.100.75)) IHOL=4
      IF ((X.EQ.10.5).AND.(Z.EQ.100.0)) IHOL=5
      IF ((X.EQ.50.50).AND.(Y.EQ.10.5).AND.(Z.EQ.100.50)) IHHL=2
      IF ((X.EQ.50.00).AND.(Y.EQ.10.0).AND.(Z.EQ.100.50)) IHHL=2
      IF ((X.EQ.50.00).AND.(Y.EQ.10.00).AND.(Z.EQ.100.50)) IHHL=2
      IF ((X.EQ.50.00).AND.(Y.EQ.10.5).AND.(Z.EQ.100.25)) IHHL=3
      IF ((X.EQ.50.00).AND.(Y.EQ.10.5).AND.(Z.EQ.100.75)) IHHL=3
      IF ((X.EQ.50.75).AND.(Y.EQ.10.75).AND.(Z.EQ.100.75)) IHHL=3
      IF ((X.EQ.50.75).AND.(Y.EQ.10.75).AND.(Z.EQ.100.25)) IHHL=3
      IF ((X.EQ.50.25).AND.(Y.EQ.10.25).AND.(Z.EQ.100.25)) IHHL=3
C-----CHECK CENTROSYMMETRIC POSITION
      IF (ISYMCE.EQ.0) GO TO 2
      IF (POIN.EQ.-1.) GO TO 2
      POIN=-1.
      X=-X+R
      Y=-Y+S
      Z=-Z+T
      IF (R.NE.0.) R=1.-R
      IF (S.NE.0.) S=1.-S
      IF (T.NE.0.) T=1.-T
      GO TO 1
 2    CONTINUE
      RETURN
      END
      SUBROUTINE MULTF(TS,FS,X,Y,Z,FOCCU,FMULT,BTEMP)
C-----CALCULATES MULTIPLICITIES OF SPECIAL POSITIONS
	CHARACTER*1 NORM,IANO
	REAL IELMT
      INTEGER SYMBR
      DIMENSION X(50,8),Y(50,8),Z(50,8),FOCCU(50,8),FMULT(50,8),
     *BTEMP(50,8),TS(3,24),FS(3,3,24)
      DIMENSION COMPND(19), IELMT(8),FNEUT(8), NA(8), DELFR(8), DELFI(8)
     *, B1(3,9), TSB(3), XYZ(3), XYZ1(3)
      COMMON /INPUT2/ COMPND,IELMT,FNEUT,A,B,C,ALPHA,BE
     1TA,GAMMA,SYMSY,SYMBR,ISYMCE,NCOMPO,NA,SYMWL,WL,SL,SH,IMAGE,SYMLP,
     2AGUIN,BGUIN,DELFR,DELFI,NS,IBRAVL,NORM,IANO
      COMMON /UNITS/ ICR,IPR,ILU
      DATA B1(1,1)/0./,B1(2,1)/0./,B1(3,1)/0./,B1(1,2)/0.5/,B1(2,2)/0.5/
     1,B1(3,2)/0.5/,B1(1,3)/0.66667/,B1(2,3)/0.33333/,B1(3,3)/0.33333/,B
     21(1,4)/0.5/,B1(2,4)/0.5/,B1(3,4)/0./,B1(1,5)/0./,B1(2,5)/0.5/,B1(3
     3,5)/0.5/,B1(1,6)/0.5/,B1(2,6)/0./,B1(3,6)/0.5/,B1(1,7)/0.5/,B1(2,7
     4)/0.5/,B1(3,7)/0.0/,B1(1,8)/0.33333/,B1(2,8)/0.66667/,B1(3,8)/0.66
     5667/
      NBRA=1
      IF (IBRAVL.GT.1) NBRA=2
      IF (IBRAVL.EQ.3) NBRA=3
      IF (IBRAVL.EQ.4) NBRA=4
C-----LOOP OVER ATOMKINDS
      DO 7 IC=1,NCOMPO
      NATOM=NA(IC)
C-----LOOP OVER ATOMS OF ONE KIND
      DO 6 IA=1,NATOM
      XYZ1(1)=X(IA,IC)
      XYZ1(2)=Y(IA,IC)
      XYZ1(3)=Z(IA,IC)
C-----MAKE COORDINATES POSITIVE
      DO 1 I=1,3
 1    IF (XYZ1(I).LT.0.) XYZ1(I)=XYZ1(I)+1.
      FMULT(IA,IC)=0.
C-----LOOP OVER EQUIVALENT POSITIONS
      DO 4 J=1,NS
C-----LOOP OVER BRAVAIS LATTICE POINTS
      DO 4 NB=1,NBRA
      ANTI=1.
 2    DIF=0.
C-----CALCULATE ATOM COORDINATES
      DO 3 I=1,3
      XYZ(I)=ANTI*(TS(I,J)+FS(1,I,J)*XYZ1(1)+FS(2,I,J)*XYZ1(2)+FS(3,I,J)
     1*XYZ1(3)) +0.00001
      IF (NB.EQ.1) TSB(I)=B1(I,1)
      IF (NB.EQ.2) TSB(I)=B1(I,IBRAVL)
      IF (NB.EQ.4) TSB(I)=B1(I,6)
      IF ((NB.EQ.3).AND.(IBRAVL.EQ.3)) TSB(I)=B1(I,8)
      IF ((NB.EQ.3).AND.(IBRAVL.EQ.4)) TSB(I)=B1(I,5)
C-----ADD BRAVAIS LATTICE VECTORS
      XYZ(I)=XYZ(I)+TSB(I)
C-----MAKE COORDINATES POSITIVE AND LESS THAN 1.
      IF (XYZ(I).GE.1.) XYZ(I)=XYZ(I)-1.
      IF (XYZ(I).LT.-1.) XYZ(I)=XYZ(I)+1.
      IF (XYZ(I).LT.0.) XYZ(I)=XYZ(I)+1.
C-----CALCULATE NUMBER FMULT OF COINCIDING ATOMS
 3    CONTINUE
      DIF=XYZ(1)-XYZ1(1)
      DIF=ABS(DIF)
      DIF1=XYZ(2)-XYZ1(2)
      DIF1=ABS(DIF1)
      DIF=DIF+DIF1
      DIF1=XYZ(3)-XYZ1(3)
      DIF1=ABS(DIF1)
      DIF=DIF+DIF1
      IF (DIF.LT..001) FMULT(IA,IC)=FMULT(IA,IC)+1.
C-----CHECK CENTROSYMMETRICALLY RELATED ATOMS
      IF (ISYMCE.NE.1) GO TO 4
      IF (ANTI.EQ.-1.) GO TO 4
      ANTI=-1.
      GO TO 2
 4    CONTINUE
      IF (FMULT(IA,IC).NE.0.) GO TO 5
      A=-1.
      WRITE (IPR,8) IA,IC
 5    FMULT(IA,IC)=1./FMULT(IA,IC)
 6    CONTINUE
 7    CONTINUE
      RETURN
C
 8    FORMAT (22H WRONG MULTIPLICITY OF,I5,16H TH ATOM OF TYPE,I5,43H CH
     1ECK COORDINATES AND EQUIVALENT POSITIONS)
      END
      SUBROUTINE SYMBF (ASYMB,IELMT)
C-----FINDS THE SEQUENCE NUMBER IELMT OF ELEMENT ASYMB AMONG ELEMENTS
C-----FOR WHICH SCATTERING CURVES EXIST IN ROUTINE CONFS
      DIMENSION S(214)
      DATA S(1)/4HH   /,S(2)/4HH.  /,S(3)/4HH1- /,S(4)/4HHE  /,S(5)/4HLI
     1  /,S(6)/4HLI1+/,S(7)/4HBE  /,S(8)/4HBE2+/,S(9)/4HB   /,S(10)/4HC 
     2  /,S(11)/4HC.  /,S(12)/4HN   /,S(13)/4HO   /,S(14)/4HO1- /,S(15)/
     34HF   /,S(16)/4HF1- /,S(17)/4HNE  /,S(18)/4HNA  /,S(19)/4HNA1+/,S(
     420)/4HMG  /,S(21)/4HMG2+/,S(22)/4HAL  /,S(23)/4HAL3+/,S(24)/4HSI  
     5/,S(25)/4HSI. /,S(26)/4HSI4+/,S(27)/4HS   /,S(28)/4HP   /,S(29)/4H
     6CL  /,S(30)/4HCL1-/,S(31)/4HAR  /,S(32)/4HK   /,S(33)/4HK1+ /,S(34
     7)/4HCA  /,S(35)/4HCA2+/,S(36)/4HSC  /,S(37)/4HSC3+/,S(38)/4HTI  /,
     8S(39)/4HTI2+/,S(40)/4HTI3+/
      DATA S(41)/4HTI4+/,S(42)/4HV   /,S(43)/4HV2+ /,S(44)/4HV3+ /,S(45)
     1/4HV5+ /,S(46)/4HCR  /,S(47)/4HCR2+/,S(48)/4HCR3+/,S(49)/4HMN  /,S
     2(50)/4HMN2+/,S(51)/4HMN3+/,S(52)/4HMN4+/,S(53)/4HFE  /,S(54)/4HFE+
     32/,S(55)/4HFE3+/,S(56)/4HCO  /,S(57)/4HCO2+/,S(58)/4HCO3+/,S(59)/4
     4HNI  /,S(60)/4HNI2+/,S(61)/4HNI3+/,S(62)/4HCU  /,S(63)/4HCU1+/,S(6
     54)/4HCU2+/,S(65)/4HZN  /,S(66)/4HZN2+/,S(67)/4HGA  /,S(68)/4HGA3+/
     6,S(69)/4HGE  /,S(70)/4HGE4+/,S(71)/4HAS  /,S(72)/4HSE  /,S(73)/4HB
     7R  /,S(74)/4HBR1-/,S(75)/4HKR  /,S(76)/4HRB  /,S(77)/4HRB1+/,S(78)
     8/4HSR  /,S(79)/4HSR2+/,S(80)/4HY   /
      DATA S(81)/4HY3+ /,S(82)/4HZR  /,S(83)/4HZR4+/,S(84)/4HNB  /,S(85)
     1/4HNB3+/,S(86)/4HNB5+/,S(87)/4HMO  /,S(88)/4HMO3+/,S(89)/4HMO5+/,S
     2(90)/4HMO6+/,S(91)/4HTC  /,S(92)/4HRU  /,S(93)/4HRU3+/,S(94)/4HRU+
     34/,S(95)/4HRH  /,S(96)/4HRH3+/,S(97)/4HRH4+/,S(98)/4HPD  /,S(99)/4
     4HPD2+/,S(100)/4HPD4+/,S(101)/4HAG  /,S(102)/4HAG1+/,S(103)/4HAG2+/
     5,S(104)/4HCD  /,S(105)/4HCD2+/,S(106)/4HIN  /,S(107)/4HIN3+/,S(108
     6)/4HSN  /,S(109)/4HSN2+/,S(110)/4HSN4+/,S(111)/4HSB  /,S(112)/4HSB
     73+/,S(113)/4HSB5+/,S(114)/4HTE  /,S(115)/4HI   /,S(116)/4HI1- /,S(
     8117)/4HXE  /,S(118)/4HCS  /,S(119)/4HCS1+/,S(120)/4HBA  /
      DATA S(121)/4HBA2+/,S(122)/4HLA  /,S(123)/4HLA3+/,S(124)/4HCE  /,S
     1(125)/4HCE3+/,S(126)/4HCE4+/,S(127)/4HPR  /,S(128)/4HPR3+/,S(129)/
     24HPR4+/,S(130)/4HND  /,S(131)/4HND3+/,S(132)/4HPM  /,S(133)/4HPM3+
     3/,S(134)/4HSM  /,S(135)/4HSM3+/,S(136)/4HEU  /,S(137)/4HEU2+/,S(13
     48)/4HEU3+/,S(139)/4HGD  /,S(140)/4HGD3+/,S(141)/4HTB  /,S(142)/4HT
     5B3+/,S(143)/4HDY  /,S(144)/4HDY3+/,S(145)/4HHO  /,S(146)/4HHO3+/,S
     6(147)/4HER  /,S(148)/4HER3+/,S(149)/4HTM  /,S(150)/4HTM3+/,S(151)/
     74HYB  /,S(152)/4HYB2+/,S(153)/4HYB3+/,S(154)/4HLU  /,S(155)/4HLU3+
     8/,S(156)/4HHF  /,S(157)/4HHF4+/,S(158)/4HTA  /,S(159)/4HTA5+/,S(16
     90)/4HW   /
      DATA S(161)/4HW6+ /,S(162)/4HRE  /,S(163)/4HOS  /,S(164)/4HOS4+/,S
     1(165)/4HIR  /,S(166)/4HIR3+/,S(167)/4HIR4+/,S(168)/4HPT  /,S(169)/
     24HPT2+/,S(170)/4HPT4+/,S(171)/4HAU  /,S(172)/4HAU1+/,S(173)/4HAU3+
     3/,S(174)/4HHG  /,S(175)/4HHG1+/,S(176)/4HHG2+/,S(177)/4HTL  /,S(17
     48)/4HTL1+/,S(179)/4HTL3+/,S(180)/4HPB  /,S(181)/4HPB2+/,S(182)/4HP
     5B4+/,S(183)/4HBI  /,S(184)/4HBI3+/,S(185)/4HBI5+/,S(186)/4HPO  /,S
     6(187)/4HAT  /,S(188)/4HRN  /,S(189)/4HFR  /,S(190)/4HRA  /,S(191)/
     74HRA2+/,S(192)/4HAC  /,S(193)/4HAC3+/,S(194)/4HTH  /,S(195)/4HTH4+
     8/,S(196)/4HPA  /,S(197)/4HU   /,S(198)/4HU3+ /,S(199)/4HU4+ /,S(20
     90)/4HU6+ /
      DATA S(201)/4HNP  /,S(202)/4HNP3+/,S(203)/4HNP4+/,S(204)/4HNP6+/,S
     1(205)/4HPU  /,S(206)/4HPU3+/,S(207)/4HPU4+/,S(208)/4HPU6+/,S(209)/
     24HAM  /,S(210)/4HCM  /,S(211)/4HBK  /,S(212)/4HCF  /,
     3S(213)/4HO2-./,S(214)/4H    /
      DO 1 I=1,214
      IF (ASYMB-S(I)) 1,2,1
 1    CONTINUE
      I=0
 2    IELMT=I
      RETURN
      END
      SUBROUTINE ANOMA (ANODE,ELEMEN,KODLP,ID,IN,FNEU)
C-----CALCULATE ANOM DISPERSION COEFFICIENTS AND NEUTRON SCATT.LENGTH
      REAL M,N
      COMMON /ANOMAL/ DELFR,DELFI
      COMMON /UNITS/ ICR,IPR,ILU
      COMMON /WAVEL/ M
      DIMENSION N(98), M(20)
      DATA N(1)/4HLI  /,N(2)/4HBE  /,N(3)/4HB   /,N(4)/4HC   /,N(5)/4HN 
     1  /,N(6)/4HO   /,N(7)/4HF   /,N(8)/4HNE  /,N(9)/4HNA  /,N(10)/4HMG
     2  /,N(11)/4HAL  /,N(12)/4HSI  /,N(13)/4HP   /,N(14)/4HS   /,N(15)/
     34HCL  /,N(16)/4HAR  /,N(17)/4HK   /,N(18)/4HCA  /,N(19)/4HSC  /,N(
     420)/4HTI  /,N(21)/4HV   /,N(22)/4HCR  /,N(23)/4HMN  /,N(24)/4HFE  
     5/,N(25)/4HCO  /,N(26)/4HNI  /,N(27)/4HCU  /,N(28)/4HZN  /,N(29)/4H
     6GA  /,N(30)/4HGE  /,N(31)/4HAS  /,N(32)/4HSE  /,N(33)/4HBR  /,N(34
     7)/4HKR  /,N(35)/4HRB  /,N(36)/4HSR  /,N(37)/4HY   /,N(38)/4HZR  /,
     8N(39)/4HNB  /,N(40)/4HMO  /
      DATA N(41)/4HTC  /,N(42)/4HRU  /,N(43)/4HRH  /,N(44)/4HPD  /,N(45)
     1/4HAG  /,N(46)/4HCD  /,N(47)/4HIN  /,N(48)/4HSN  /,N(49)/4HSB  /,N
     2(50)/4HTE  /,N(51)/4HI   /,N(52)/4HXE  /,N(53)/4HCS  /,N(54)/4HBA 
     3 /,N(55)/4HLA  /,N(56)/4HCE  /,N(57)/4HPR  /,N(58)/4HND  /,N(59)/4
     4HPM  /,N(60)/4HSM  /,N(61)/4HEU  /,N(62)/4HGD  /,N(63)/4HTB  /,N(6
     54)/4HDY  /,N(65)/4HHO  /,N(66)/4HER  /,N(67)/4HTM  /,N(68)/4HYB  /
     6,N(69)/4HLU  /,N(70)/4HHF  /,N(71)/4HTA  /,N(72)/4HW   /,N(73)/4HR
     7E  /,N(74)/4HOS  /,N(75)/4HIR  /,N(76)/4HPT  /,N(77)/4HAU  /,N(78)
     8/4HHG  /,N(79)/4HTL  /,N(80)/4HPB  /
      DATA N(81)/4HBI  /,N(82)/4HPO  /,N(83)/4HAT  /,N(84)/4HRN  /,N(85)
     1/4HFR  /,N(86)/4HRA  /,N(87)/4HAC  /,N(88)/4HTH  /,N(89)/4HPA  /,N
     2(90)/4HU   /,N(91)/4HNP  /,N(92)/4HPU  /,N(93)/4HAM  /,N(94)/4HCM 
     3 /,N(95)/4HBK  /,N(96)/4HCF  /,N(97)/4HH   /,N(98)/4HD.  /
C-----IDENTIFY ELEMEN  FOR RETRIEVING NEUTRON SCATTERING LENGTH
      IF (KODLP.EQ.2) GO TO 3
C-----IDENTIFY WAVELENGTH
      DO 1 I=1,20
      IF (ANODE.EQ.M(I)) GO TO 2
 1    CONTINUE
      WRITE (IPR,14) ANODE
      GO TO 5
 2    IN=(FLOAT(I)-1.)/4.
C-----IDENTIFY ELEMENT SYMBOL
 3    DO 4 I=1,98
      IF (ELEMEN.EQ.N(I)) GO TO 6
 4    CONTINUE
      IF (KODLP.NE.2) WRITE (IPR,15) ELEMEN
 5    DELFR=0.
      DELFI=0.
      RETURN
 6    IF (KODLP.NE.2) GO TO 7
      CALL NEUTF (I,FNEU)
      RETURN
 7    IN=I+IN*96
	CONTINUE  !! READ(ID'IN)DELFR,DELFI
 13   RETURN
C
 14   FORMAT (13H THE ANODE **,A4,21H**  IS NOT RECOGNIZED /
     152H NO CORRECTION FOR ANOMALOUS DISPERSION WILL BE MADE)
 15   FORMAT (11H SYMBOL ***,A4,43H*** IS NOT ALLOWED FOR ANOMALOUS DISP
     1ERSION,/44H NO CORRECTION FOR THIS ELEMENT WILL BE MADE )
      END
      SUBROUTINE NEUTF (I,FNEU)
C-----CONTAINS THE NUCLEAR SCATTERING LENGTHS FOR THERMAL NEUTRONS
C-----COMPILED BY L. KOESTER IN "SPRINGER TRACTS IN MODERN PHYSICS NO 80
C----- NEUTRON PHYSICS, P 36 (1977) "
      DIMENSION A(98)
      DATA A(1)/-.203/,A(2)/.780/,A(3)/.535/,A(4)/.665/,A(5)/.936/,A(6)/
     1.580/,A(7)/.566/,A(8)/.460/,A(9)/.363/,A(10)/.538/,A(11)/.345/,A(1
     22)/.415/,A(13)/.513/,A(14)/.285/,A(15)/.958/,A(16)/.180/,A(17)/.37
     31/,A(18)/.490/,A(19)/1.215/,A(20)/-.337/,A(21)/-.041/,A(22)/.353/,
     4A(23)/-.373/,A(24)/.954/,A(25)/.278/,A(26)/1.030/,A(27)/.769/,A(28
     5)/.570/,A(29)/.720/,A(30)/.819/,A(31)/.673/,A(32)/.795/,A(33)/.677
     6/,A(34)/.791/,A(35)/.708/,A(36)/.688/,A(37)/.775/,A(38)/.700/,A(39
     7)/.711/,A(40)/.695/,A(41)/.680/,A(42)/.721/,A(43)/.588/,A(44)/.600
     8/,A(45)/.602/,A(46)/.380/,A(47)/.408/,A(48)/.622/,A(49)/.564/,A(50
     9)/.543/
      DATA A(51)/.528/,A(52)/.488/,A(53)/.542/,A(54)/.528/,A(55)/.827/,A
     1(56)/.483/,A(57)/.445/,A(58)/.780/,A(59)/.000/,A(60)/-.500/,A(61)/
     2.550/,A(62)/1.500/,A(63)/.738/,A(64)/1.710/,A(65)/.850/,A(66)/.803
     3/,A(67)/.705/,A(68)/1.262/,A(69)/.730/,A(70)/.777/,A(71)/.691/,A(7
     42)/.477/,A(73)/.920/,A(74)/1.080/,A(75)/1.060/,A(76)/.950/,A(77)/.
     5763/,A(78)/1.266/,A(79)/.889/,A(80)/.940/,A(81)/.853/,A(82)/.000/,
     6A(83)/.000/,A(84)/.000/,A(85)/.000/,A(86)/.000/,A(87)/.000/,A(88)/
     71.008/,A(89)/1.300/,A(90)/.861/,A(91)/1.060/,A(92)/.750/,A(93)/.76
     80/,A(94)/.700/,A(95)/.000/,A(96)/.000/,A(97)/-.374/,A(98)/.667/
      FNEU=A(I)
      RETURN
      END
C
C
      subroutine AHKL
C-----******************************************************************
C             100000 hkl max
C-----******************************************************************
      DOUBLE PRECISION PI2
      character*20 file
      character*24 tmp
      logical qex
	INTEGER NORM
	INTEGER *4 LIMIT1,N,J1,JJ,JJ1,NN,NNN,M
      REAL ITIT,JB,IDL,IWL,ILP
      DIMENSION  Q(100000), IYH(100000), IYK(100000), IYL(100000),NA(8),
     1COMPND(19),NT(36),IY(100000),IORD(100000)
      DIMENSION ITIT(13),JB(21),IDL(25),IPH(5),IPK(5),IPL(5),
     *MIT(5)
      COMMON /UNITS/ IPR
      COMMON /EQUO/ TS(3,24),FS(3,3,24),NS,ISYMCE,IBRAVL
      COMMON /OUT/LPT,IF1,IF2,IF3,IF4,IF5,IF6
      DATA ITIT(1)/4H FOL/,ITIT(2)/4HLOWS/,ITIT(3)/4H OMI/,ITIT(4)/4HTTE
     1D/,ITIT(5)/3H MM/,ITIT(6)/3H   /,ITIT(7)/3H2TH/,ITIT(8)/3HETA/,ITI
     2T(9)/4H NOT/,ITIT(10)/4HLOW /,ITIT(11)/4HHIGH/,ITIT(12)/2HNO/,ITIT
     3(13)/2H A/
      DATA JB(1)/4HPRIM/,JB(2)/4HITIV/,JB(3)/4HE   /,JB(4)/4HBODY/,JB(5)
     1/4H CEN/,JB(6)/4HTRED/,JB(7)/4HRHOM/,JB(8)/4HBOHE/,JB(9)/4HDRAL/,J
     2B(10)/4HFACE/,JB(11)/4H CEN/,JB(12)/4HTRED/,JB(13)/4HA -C/,JB(14)/
     34HENTR/,JB(15)/4HED  /,JB(16)/4HB -C/,JB(17)/4HENTR/,JB(18)/4HED  
     4/,JB(19)/4HC -C/,JB(20)/4HENTR/,JB(21)/4HED  /
      DATA IDL(1)/4H DEB/,IDL(2)/4HYE S/,IDL(3)/4HCHER/,IDL(4)/4HRER /,I
     1DL(5)/4H    /,IDL(6)/4HSPEC/,IDL(7)/4HIAL /,IDL(8)/4HWITH/,IDL(9)/
     24H LP=/,IDL(10)/4H1   /,IDL(11)/4H NEU/,IDL(12)/4HTRON/,IDL(13)/4H
     3 DIF/,IDL(14)/4HFRAC/,IDL(15)/4HTION/,IDL(16)/4H    /,IDL(17)/4H G
     4UI/,IDL(18)/4HNIER/,IDL(19)/4H CAM/,IDL(20)/4HERA /,IDL(21)/4H GUI
     5/,IDL(22)/4HNIER/,IDL(23)/4H CAM/,IDL(24)/4HERA /,IDL(25)/4H    /
C-----
C-----CHANGE THE FOLLOWING PARAMETERS IF NECESSARY
C-----
      GO TO 499
501   TH=TH-5.
      close(35,status='delete')
      close(36,status='delete')
499   CONTINUE
      IPR=35
      ILU=29
      LIMIT1=100000
      LIMIT2=1
      LIMIT3=1
      LIMIT4=24
      DG1=3.343
      DG2=3.343
      DM1=114.59156
      DM2=100.
      BG1=30.
      BG2=30.
	ITP=1
      REWIND 29
	READ(ILU)NCHR,FILE
        lfile=len(FILE)
        do while (FILE(lfile:lfile).eq.' ')
        lfile=lfile-1
        enddo
      tmp=FILE(1:lfile)//'2.imp'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.)go to 800
      print *,'Warning, this old file will be deleted : ',tmp
      call filedel(IPR,tmp)
800   if(IF4.EQ.0)call open_write2(IPR,tmp)
      if(IF4.EQ.1)call open_write1(IPR,tmp)
      tmp=FILE(1:lfile)//'.hkl'
      inquire(file=tmp,exist=qex)
      if(qex.eq..FALSE.)go to 801
      print *,'Warning, this old file will be deleted : ',tmp
      call filedel(36,tmp)
801   if(IF2.EQ.0)call open_write2(36,tmp)
      if(IF2.EQ.1)call open_write1(36,tmp)
C-----
C-----END OF PARAMETERS
C-----
	WRITE(IPR,1711)FICHE
1711	FORMAT(1X,A20)
      NFI=0
      PI2=6.283185307179586D0
      E=2.7182818
      FRTD=4./3.
C-----READ INPUT FROM BINARY DATA FILE ILU
C-----READ NUMBER OF FILES ON ILU
      READ (ILU) NFIL
 1    NFI=NFI+1
      WRITE (IPR,141)
      IF (NFI.LE.NFIL) GO TO 2
      WRITE (IPR,139)
      GO TO 137
 2    READ (ILU) (COMPND(I),I=1,19),A,B,C,ALPHA,BETA,GAMMA,WL,(NT(I),I=1
     1,36),IGROUP, IWL, ILP
      IF (A.GT.0.) GO TO 3
      WRITE (IPR,140) NFI
      GO TO 1
 3    READ (ILU) ISYSTM,ISYMCE,IBRAVL,NS,TL,TH,NORM,IMAGE,ANO,KODLP,NCOM
     1PO,(NA(I),I=1,8),IHOO,IOKO,IOOL,IHHL,IHOL,IHKO,IOKL,LAUE
      IF (NS.GT.LIMIT4) GO TO 136
	IF(NCOMPO.GT.LIMIT2)GOTO 134
      READ (ILU) ((TS(I,II),(FS(K,I,II),K=1,3),I=1,3),II=1,NS)
C-----SET VARIABLES BACK TO ORIGINAL VALUE
C-----PRINT FIRST LINE OF TITLE
      VMXINT=0
      NLINE=0
	J1=1
      N=0
      ICON=0
      DUM=1.
      FBRA=IBRAVL
      IF (FBRA.GT.4.) FBRA=2.
C-----MULTIPLIER IF CENTER OF SYMMETRY AT ORIGIN
      IF (ISYMCE.NE.0) DUM=2.
C-----CALCULATE SIN**2 THETA LIMITS
      SH=TH*PI2/360.
      SL=TL*PI2/360.
      SH=(SIN(SH))**2
      SL=(SIN(SL))**2
	SHR=SH
C	PRINT 500
C500     FORMAT('  DELTA THETA ??',$)
C	READ *,DTH
C      DTH=5.
C	TH=TL+DTH
	SH=(SIN(TH*PI2/360.))**2
C-----PRINT TITLE
      WRITE (IPR,165) COMPND
      WLSQ4=WL**2/4.
      ASTAR=WLSQ4/A**2
      IF ((ISYSTM.EQ.1).OR.(ISYSTM.EQ.2).OR.(ISYSTM.EQ.7)) BSTAR=WLSQ4/B
     1**2
      IF (ISYSTM.NE.5) CSTAR=WLSQ4/C**2
      BET=BETA*PI2/360.
      SINB2=(SIN(BET))**2
      COSB=COS(BET)
C-----TRICLINIC CASE
      IF (ISYSTM.NE.7) GO TO 8
      ALPH=ALPHA*PI2/360.
      GAMM=GAMMA*PI2/360.
      SV=(ALPH+BET+GAMM)/2.
      VOL=2.*A*B*C*SQRT(SIN(SV)*SIN(SV-ALPH)*SIN(SV-BET)*SIN(SV-GAMM))
      AST=(B*C*SIN(ALPH))/VOL
      BST=(A*C*SIN(BET))/VOL
      CST=(A*B*SIN(GAMM))/VOL
      COAST=(COSB*COS(GAMM)-COS(ALPH))/(SIN(BET)*SIN(GAMM))
      COBST=(COS(GAMM)*COS(ALPH)-COSB)/(SIN(GAMM)*SIN(ALPH))
      COGST=(COS(ALPH)*COSB-COS(GAMM))/(SIN(ALPH)*SIN(BET))
C-----START LOOP TO FIND HKL LIMITS FOR GIVEN SL AND SH LIMITS
C520     ICON=0
      ICON=0
 8    ZH=0.
      ZK=0.
      ZL=0.
 9    ZH=ZH+1.
      GO TO (10,15,16,21,22,23,24), ISYSTM
C-----MONOCLINIC
 10   ZHTEST=(2.0*A*SQRT(SH))/WL
      IF (ZH.LE.ZHTEST) GO TO 13
      ZH=0.
      ZK=ZK+1.
      ZKTEST=(2.0*B*SQRT(SH))/WL
      IF (ZK.LE.ZKTEST) GO TO 10
      ZK=0.
      IF (ICON.EQ.0) GO TO 11
      ZL=ZL-1.
      GO TO 12
 11   ZL=ZL+1.
 12   ZLTEST=(2.0*C*SQRT(SH))/WL
      IF (ABS(ZL).LE.ZLTEST) GO TO 10
      IF (ICON.EQ.1) GO TO 14
      ICON=1
      GO TO 8
 13   ATEST=ASTAR*ZH**2/SINB2+BSTAR*ZK**2+CSTAR*ZL**2/SINB2-WLSQ4*2.*ZH*
     1ZL*COSB/(A*C*SINB2)
      IF (ATEST.GT.SH) GO TO 9
      IF ((ICON.EQ.0).OR.((ZH.GT.0.9).AND.(ZL.LT.(-0.9)))) GO TO 31
      GO TO 9
 14   IF(ITP.EQ.0)GO TO 521
	WRITE (IPR,187)
      WRITE (IPR,168) A,B,C,BETA,WL
521      GO TO 73
C-----ORTHORHOMBIC
 15   ATEST=ASTAR*ZH**2+BSTAR*ZK**2+CSTAR*ZL**2
      IF (ATEST.LE.SH) GO TO 31
      ZH=0.
      ZK=ZK+1.
      BTEST=BSTAR*ZK**2+CSTAR*ZL**2
      IF (BTEST.LE.SH) GO TO 15
      ZK=0.
      ZL=ZL+1.
      CTEST=CSTAR*ZL**2
      IF (CTEST.LE.SH) GO TO 15
	IF(ITP.EQ.0)GO TO 522
      WRITE (IPR,189)
      WRITE (IPR,169) A,B,C,WL
522      GO TO 73
C-----TRIGONAL
 16   ATEST=FRTD*ASTAR*(ZH**2+ZH*ZK+ZK**2)+CSTAR*ZL**2
      IF ((ZH.EQ.0.).AND.(ZL.EQ.0.)) GO TO 9
      IF (ATEST.LE.SH) GO TO 19
      ZH=0.
      ZK=ZK+1.
      BTEST=FRTD*ASTAR*ZK**2+CSTAR*ZL**2
      IF (BTEST.LE.SH) GO TO 16
      ZK=0.
      IF (ICON.EQ.0) GO TO 17
      ZL=ZL-1.
      GO TO 18
 17   ZL=ZL+1.
 18   CTEST=CSTAR*ZL**2
      IF (CTEST.LE.SH) GO TO 16
      IF (ICON.EQ.1) GO TO 20
      ICON=1
      GO TO 8
 19   IF ((ICON.EQ.0).OR.((ZL.LT.(-0.9)).AND.((ZH.NE.0.).AND.(ZK.NE.0.))
     1)) GO TO 31
      GO TO 9
 20   IF(ITP.EQ.0)GO TO 523
	WRITE (IPR,190)
523      GO TO 72
C-----TETRAGONAL
 21   ATEST=ASTAR*(ZH**2+ZK**2)+CSTAR*ZL**2
      IF (ATEST.LE.SH) GO TO 31
      ZH=ZK+1.
      ZK=ZH
      BTEST=ASTAR*2.*ZH**2+CSTAR*ZL**2
      IF (BTEST.LE.SH) GO TO 21
      ZH=0.
      ZK=0.
      ZL=ZL+1.
      CTEST=CSTAR*ZL**2
      IF (CTEST.LE.SH) GO TO 21
	IF(ITP.EQ.0)GO TO 524
      WRITE (IPR,191)
524      GO TO 72
C-----CUBIC
 22   ATEST=ASTAR*(ZH**2+ZK**2+ZL**2)
      IF (ATEST.LE.SH) GO TO 31
      ZH=ZK+1.
      ZK=ZH
      BTEST=ASTAR*(2.*ZH**2+ZL**2)
      IF (BTEST.LE.SH) GO TO 22
      ZH=ZL+1.
      ZK=ZH
      ZL=ZH
      CTEST=ASTAR*3.*ZH**2
      IF (CTEST.LE.SH) GO TO 22
	IF(ITP.EQ.0)GO TO 525
      WRITE (IPR,192)
      WRITE (IPR,171) A,WL
525      GO TO 73
C-----HEXAGONAL
 23   ATEST=FRTD*ASTAR*(ZH**2+ZH*ZK+ZK**2)+CSTAR*ZL**2
      IF (ATEST.LE.SH) GO TO 31
      ZH=ZK+1.
      ZK=ZH
      BTEST=FRTD*ASTAR*3.*ZH**2+CSTAR*ZL**2
      IF (BTEST.LE.SH) GO TO 23
      ZH=0.
      ZK=0.
      ZL=ZL+1.
      CTEST=CSTAR*ZL**2
      IF (CTEST.LE.SH) GO TO 23
	IF(ITP.EQ.0)GO TO 526
      WRITE (IPR,193)
526      GO TO 72
C-----TRICLINIC
 24   ZHTEST=(2.0*A*SQRT(SH))/WL
      IF (ZH.LE.ZHTEST) GO TO 29
      ZH=0.
      IF (ICON.LT.2) GO TO 25
      ZK=ZK-1.
      GO TO 26
 25   ZK=ZK+1.
 26   ZKTEST=(2.0*B*SQRT(SH))/WL
      IF (ABS(ZK).LE.ZKTEST) GO TO 24
      ZK=0.
      IF ((ICON.EQ.0).OR.(ICON.EQ.2)) GO TO 27
      ZL=ZL-1.
      GO TO 28
 27   ZL=ZL+1.
 28   ZLTEST=(2.0*C*SQRT(SH))/WL
      IF (ABS(ZL).LE.ZLTEST) GO TO 24
      ICON=ICON+1
      GO TO (8,8,8,30), ICON
 29   ATEST=WLSQ4*((ZH*AST)**2+(ZK*BST)**2+(ZL*CST)**2+2.*ZK*ZL*BST*CST*
     1COAST+2.*ZH*ZL*AST*CST*COBST+2.*ZH*ZK*AST*BST*COGST)
      IF (ATEST.GT.SH) GO TO 9
      IF (ICON.EQ.0) GO TO 31
      IF (((ZH.EQ.0.).AND.(ZK.EQ.0.)).OR.((ZK.EQ.0.).AND.(ZL.EQ.0.)).OR.
     1((ZH.EQ.0.).AND.(ZL.EQ.0.))) GO TO 9
      IF ((ICON.EQ.1).AND.(ZL.LT.(-0.9))) GO TO 31
      IF (((ICON.EQ.2).AND.(ZK.LT.(-0.9))).AND.(ZH.GT.0.9)) GO TO 31
      IF ((ICON.EQ.3).AND.((ZH*ZK*ZL).NE.0.)) GO TO 31
      GO TO 9
C-----PRINT TRICLINIC LATTICE CONSTANTS
 30   IF(ITP.EQ.0)GO TO 527
	WRITE (IPR,188)
      WRITE (IPR,172) A,B,C,ALPHA,BETA,GAMMA,WL
527      GO TO 73
 31   IF (ATEST.LE.SL) GO TO 9
      XH=ZH
      XK=ZK
      XL=ZL
C-----OMIT HKL VALUES CORRESPONDING TO BRAVAIS LATTICE EXTINCTIONS
 32   GO TO (40,33,34,35,36,37,38), IBRAVL
 33   TESTBR=(XH+XK+XL)/2.
      GO TO 39
 34   TESTBR=(-XH+XK+XL)/3.
      GO TO 39
 35   FACEHK=(XH+XK)/2.
      IF ((AINT(FACEHK)-FACEHK).NE.0.) GO TO 9
 36   TESTBR=(XK+XL)/2.
      GO TO 39
 37   TESTBR=(XH+XL)/2.
      GO TO 39
 38   TESTBR=(XH+XK)/2.
 39   IF ((AINT(TESTBR)-TESTBR).NE.0.) GO TO 68
C-----OMIT HKL VALUES CORRESPONDING TO EXTINCTIONS
 40   IF (XL.EQ.0.) GO TO (41,50,49,50,47), IHKO
 41   IF (XH.EQ.0.) GO TO (42,54,53,54,51), IOKL
 42   IF (XK.EQ.0.) GO TO (43,58,57,58,55), IHOL
 43   IF (XH.EQ.XK) GO TO (44,59,61), IHHL
      IF ((XK.EQ.XL).AND.(ISYSTM.EQ.5)) GO TO (44,62,44,63), IHHL
 44   IF (XK.EQ.0..AND.XL.EQ.0.) GO TO (45,64,133,64), IHOO
 45   IF (XH.EQ.0..AND.XL.EQ.0.) GO TO (46,65,133,65), IOKO
 46   IF (XH.EQ.0..AND.XK.EQ.0.) GO TO (67,66,66,66,133,66), IOOL
      GO TO 67
 47   FIHKO=XH/2.
 48   IF (AINT(FIHKO)-FIHKO) 68,41,68
 49   FIHKO=XK/2.
      GO TO 48
 50   HKO=IHKO
      FIHKO=(XH+XK)/HKO
      GO TO 48
 51   FIOKL=XK/2.
 52   IF (AINT(FIOKL)-FIOKL) 68,42,68
 53   FIOKL=XL/2.
      GO TO 52
 54   OKL=IOKL
      FIOKL=(XK+XL)/OKL
      GO TO 52
 55   FIHOL=XH/2.
 56   IF (AINT(FIHOL)-FIHOL) 68,43,68
 57   FIHOL=XL/2.
      GO TO 56
 58   HOL=IHOL
      FIHOL=(XH+XL)/HOL
      GO TO 56
 59   FIHHL=XL/2.
 60   IF (AINT(FIHHL)-FIHHL) 68,44,68
 61   FIHHL=(2.*XH+XL)/4.
      GO TO 60
 62   FIHHL=XH/2.
      GO TO 60
 63   FIHHL=(2.*XL+XH)/4.
      GO TO 60
 64   HOO=IHOO
      FIHOO=XH/HOO
      IF (AINT(FIHOO)-FIHOO) 68,45,68
 65   FIOKO=XK/2.
      IF (AINT(FIOKO)-FIOKO) 68,46,68
 66   OOL=IOOL
      FIOOL=XL/OOL
      IF ((AINT(FIOOL)-FIOOL).NE.0.) GO TO 68
C-----STORE HKL AND SIN2THETA VALUES OF F VALUES  TO BE CALCULATED
 67   N=N+1
C-----CHECK IF NUMBER OF REFLECTIONS TOO LARGE
      IF (N.GT.LIMIT1)PRINT *,'  Too much reflections : ',N
      IF (N.GT.LIMIT1) GO TO 501
      Q(N)=ATEST
      IF(XH.GE.0.)IYH(N)=XH+0.5
      IF(XK.GE.0.)IYK(N)=XK+0.5
      IF(XL.GE.0.)IYL(N)=XL+0.5
	IF(XH.LT.0.)IYH(N)=XH-0.5
	IF(XK.LT.0.)IYK(N)=XK-0.5
	IF(XL.LT.0.)IYL(N)=XL-0.5
      JJ=N
      J=JJ-1
C-----SKIP REFLECTIONS RELATED BY LAUE SYMMETRY
 68   IF ((LAUE.EQ.2).OR.(ZH.EQ.XK)) GO TO 9
      GO TO (9,9,9,69,70,69,9), ISYSTM
 69   IF ((ZH.GT.ZK).AND.(ZK.GT.0.)) GO TO 71
      GO TO 9
 70   IF ((ZH.GT.ZK).AND.(ZK.GT.ZL)) GO TO 71
      GO TO 9
 71   TEMP=XH
      XH=XK
      XK=TEMP
      GO TO 32
C-----PRINT HEX AND TETRAG LATTICE CONSTANTS, END OF HKL GENER.LOOP
 72   IF(ITP.EQ.0)GO TO 73
	WRITE (IPR,170) A,C,WL
 73   MP=KODLP*5+1
      KK=MP+4
      WRITE (IPR,173) TL,TH,(IDL(I),I=MP,KK)
C-----CHECK IF NUMBER OF REFLECTIONS TOO LARGE
      IF(N.GT.LIMIT1) GO TO 501
C-----PRINT SPACE GROUP AND EQUIVALENT POSITIONS
      NN=6
      IF (IGROUP.EQ.0) NN=9
	IF(ITP.EQ.0)GO TO 528
      WRITE (IPR,144) ITIT(NN),(NT(I),I=1,36)
      CALL EQUI
C-----PRINT LAUE SYMMETRY
528      IF (ISYSTM.LT.3) GO TO 74
      NN=10
      IF (LAUE.EQ.2) NN=11
	IF(ITP.EQ.0)GO TO 74
      WRITE (IPR,145) ITIT(NN)
 74   NN=12
C-----PRINT SYMMETRY CENTER
      IF (ISYMCE.EQ.1) NN=13
	IF(ITP.EQ.0)GO TO 529
      WRITE (IPR,146) ITIT(NN)
C-----PRINT BRAVAIS LATTICE AND EXTINCTIONS
      NN=IBRAVL*3-2
      WRITE (IPR,147) JB(NN),JB(NN+1),JB(NN+2)
      WRITE (IPR,148)
      IF(IBRAVL.EQ.1) WRITE(IPR,208)
      IF(IBRAVL.EQ.2) WRITE(IPR,213)
      IF(IBRAVL.EQ.3) WRITE(IPR,214)
      IF(IBRAVL.EQ.4) WRITE(IPR,212)
      IF(IBRAVL.EQ.5) WRITE(IPR,209)
      IF(IBRAVL.EQ.6) WRITE(IPR,215)
      IF(IBRAVL.EQ.7) WRITE(IPR,211)
      IF ((IHKO.EQ.2).OR.(IHKO.EQ.4)) WRITE (IPR,176) IHKO
      IF (IHKO.EQ.3) WRITE (IPR,175)
      IF (IHKO.EQ.5) WRITE (IPR,174)
      IF ((IOKL.EQ.2).OR.(IOKL.EQ.4)) WRITE (IPR,178) IOKL
      IF (IOKL.EQ.3) WRITE (IPR,210)
      IF (IOKL.EQ.5) WRITE (IPR,177)
      IF ((IHOL.EQ.2).OR.(IHOL.EQ.4)) WRITE (IPR,181) IHOL
      IF (IHOL.EQ.3) WRITE (IPR,180)
      IF (IHOL.EQ.5) WRITE (IPR,179)
      IF (IHHL.EQ.2) WRITE (IPR,182)
      IF (IHHL.EQ.3) WRITE (IPR,183)
      IF (IHOO.GT.1) WRITE (IPR,184) IHOO
      IF (IOKO.GT.1) WRITE (IPR,185) IOKO
      IF (IOOL.GT.1) WRITE (IPR,186) IOOL
C-----EXIT IF NUMBER OF REFLECTIONS LESS THAN TWO
529      IF(J.LE.1) GO TO 206
C-----START ORDERING REFLEXIONS
	DO 406 NN=J1,JJ
406     IORD(NN)=NN
      DO 81 NN=J1,J
      NNN=NN+1
      DO 81 M=NNN,JJ
      IF ((Q(NN)-Q(M)).LE.0.) GO TO 81
	TEMP=Q(NN)
	Q(NN)=Q(M)
	Q(M)=TEMP
	ITEMP=IORD(NN)
	IORD(NN)=IORD(M)
	IORD(M)=ITEMP
81      CONTINUE
	DO 400 NN=J1,JJ
400     IY(NN)=IYH(IORD(NN))
	DO 401 NN=J1,JJ
401     IYH(NN)=IY(NN)
	DO 402 NN=J1,JJ
402     IY(NN)=IYK(IORD(NN))
	DO 403 NN=J1,JJ
403     IYK(NN)=IY(NN)
	DO 404 NN=J1,JJ
404     IY(NN)=IYL(IORD(NN))
	DO 405 NN=J1,JJ
405     IYL(NN)=IY(NN)
C	PRINT 503,JJ
C503     FORMAT('  NBRE HKL =',I5)
	J1=JJ+1
	JJ1=JJ
C	SL=SH
C	TH=TH+DTH
C	SH=(SIN(TH*PI2/360.))**2
 	ITP=0
C	IF(SH.GT.SHR)GO TO 501
C	GO TO 520
C501     CONTINUE
C-----END OF ORDERING
C-----START LOOP TO CALCULATE F FOR ALL STORED REFLEXIONS
	WRITE(36,*)JJ1
	IP1=0
      DO 107 N=1,JJ1
C-----CALCULATE MULTIPLICITY FOR POWDERLINE
      GO TO (82,84,87,89,91,93,96), ISYSTM
 82   IF ((IYK(N).EQ.0).OR.((IYH(N).EQ.0).AND.(IYL(N).EQ.0))) GO TO 96
 83   FMULTI=4.0
      GO TO 98
 84   IF (IYH(N).EQ.0) IF (IYK(N)) 133,96,86
      IF (IYK(N).EQ.0) GO TO 86
      IF (IYL(N).EQ.0) GO TO 83
 85   FMULTI=8.0
      GO TO 98
 86   IF (IYL(N)) 133,96,83
 87   IF ((IYH(N).EQ.0).AND.(IYK(N).EQ.0)) GO TO 96
 88   FMULTI=6.0
      GO TO 98
 89   IF ((IYH(N)-IYK(N)).EQ.0) IF (IYH(N)) 133,96,90
      IF (IYK(N).EQ.0) GO TO 90
      IF (IYL(N).EQ.0) IF (LAUE-1) 133,83,85
      IF (LAUE.EQ.1) GO TO 85
      FMULTI=16.
      GO TO 98
 90   IF (IYL(N)) 133,83,85
 91   IF ((IYH(N)-IYK(N)).EQ.0) IF (IYL(N)) 133,97,92
      IF ((IYL(N).EQ.0).AND.(LAUE.EQ.2)) IF (IYK(N)) 133,88,94
      IF ((IYL(N).EQ.0).AND.(LAUE.EQ.1)) IF (IYK(N)) 133,88,97
      IF (((IYK(N)-IYL(N)).EQ.0).OR.(LAUE.EQ.1)) GO TO 94
      FMULTI=48.
      GO TO 98
 92   IF (IYH(N)-IYL(N)) 133,85,94
 93   IF ((IYH(N)-IYK(N)).EQ.0) IF (IYH(N)) 133,96,95
      IF (IYK(N).EQ.0) GO TO 95
      IF ((IYL(N).EQ.0).AND.(LAUE.EQ.1)) GO TO 88
      IF ((IYL(N).EQ.0).OR.(LAUE.EQ.1)) GO TO 97
 94   FMULTI=24.0
      GO TO 98
 95   IF (IYL(N)) 133,88,97
 96   FMULTI=2.0
      GO TO 98
 97   FMULTI=12.0
98      IP1=IP1+1
	IPH(IP1)=IYH(N)
	IPK(IP1)=IYK(N)
	IPL(IP1)=IYL(N)
	MIT(IP1)=FMULTI
	IF(IP1.NE.5)GOTO 107
	WRITE(36,1212)(IPH(IP2),IPK(IP2),IPL(IP2),MIT(IP2),IP2=1,5)
	IP1=0
1212    FORMAT(1X,20I4)
C-----END OF LOOP TO CALCULATE F FOR ALL STORED AND ORDERED HKL VALUES
 107  CONTINUE
	IF(MOD(JJ1,5).EQ.0)GOTO 1071
	WRITE(36,1212)(IPH(IP2),IPK(IP2),IPL(IP2),MIT(IP2),IP2=1,IP1)
1071    CONTINUE
1631    FORMAT(//1X,'Fin d execution : ',8A1)
      GO TO 1
 133  WRITE (IPR,194)
      GO TO 1
134     WRITE(IPR,162)
	GOTO 1
  136  WRITE (IPR,164) NS
      GO TO 1
206     WRITE(IPR,207)
	GOTO 1
 137  RETURN
C-----
 139  FORMAT (/39H B Y E  B Y E  L A Z Y  P U L V E R I X  )
 140  FORMAT (4H JOB  ,I5,40H IS BAD DUE TO ERROR IN PREVIOUS PROGRAM,/1
     16H GO TO NEXT JOB ,//)
 141  FORMAT (2X,'Date : ',9A1,5X,'Heure : ',8A1,5X,'*** PULVERIX ***'/)
 144  FORMAT ( /12H SPACE GROUP,A4,22H GIVEN ON SPCGRP-CARD ,36A1)
 145  FORMAT (/1X,A4,14H LAUE SYMMETRY)
 146  FORMAT (/10H THERE IS ,A2,30H SYMMETRY CENTRE AT THE ORIGIN)
 147  FORMAT (/1X,3A4,16H BRAVAIS LATTICE)
 148  FORMAT ( /41H CONDITIONS LIMITING POSSIBLE REFLECTIONS  /)
 156  FORMAT (/// 1X,50(1H-),//41H - T A B U L A R  L I S T  OF INTENSIT
     1IES,2A4,2H -//1X,50(1H-))
 162  FORMAT(1X,'NOMBRE DE SORTES D ATOMES TROP GRAND'//)
 164  FORMAT(1X,'NOMBRE D EQUIVALENTS SYMETRIQUES TROP GRAND '///)
 165  FORMAT (/27H INTENSITY CALCULATION FOR ,19A4/)
 168  FORMAT(3H A=,F9.5/3H B=,F9.5/3H C=,F9.5/6H BETA=,F9.5/4H WL=,F8.5)
 169  FORMAT (3H A=,F9.5/3H B=,F9.5/3H C=,F9.5/4H WL=,F8.5/)
 170  FORMAT (3H A=,F9.5/3H C=,F9.5/4H WL=,F8.5)
 171  FORMAT (3H A=,F9.5/4H WL=,F8.5)
 172  FORMAT (3H A=,F9.5/3H B=,F9.5/3H C=,F9.5/7H ALPHA=,F9.5/6H BETA=,
     1F9.5/7H GAMMA=,F9.5/4H WL=,F8.5)
 173  FORMAT(/26H CALCULATION BETWEEN TL = ,F4.1,9H AND TH =,F6.1,
     116H DEGREES THETA  ,//23H DIFFRACTION GEOMETRY =,5A4)
 174  FORMAT (19H HKO WITH H=2N ONLY)
 175  FORMAT (19H HKO WITH K=2N ONLY)
 176  FORMAT (14H HKO WITH H+K=,I1,6HN ONLY)
 177  FORMAT (19H OKL WITH K=2N ONLY)
 210  FORMAT (19H OKL WITH L=2N ONLY)
 178  FORMAT (14H OKL WITH K+L=,I1,6HN ONLY)
 179  FORMAT (19H HOL WITH H=2N ONLY)
 180  FORMAT (19H HOL WITH L=2N ONLY)
 181  FORMAT (14H HOL WITH H+L=,I1,6HN ONLY)
 182  FORMAT (19H HHL WITH L=2N ONLY)
 183  FORMAT (22H HHL WITH 2H+L=4N ONLY)
 184  FORMAT (12H HOO WITH H=,I1,6HN ONLY)
 185  FORMAT (12H OKO WITH K=,I1,6HN ONLY)
 186  FORMAT (12H OOL WITH L=,I1,6HN ONLY)
 187  FORMAT (/21H MONOCLINIC STRUCTURE)
 188  FORMAT (/20H TRICLINIC STRUCTURE)
 189  FORMAT (/23H ORTHORHOMBIC STRUCTURE)
 190  FORMAT (/19H TRIGONAL STRUCTURE)
 191  FORMAT (/21H TETRAGONAL STRUCTURE)
 192  FORMAT (/16H CUBIC STRUCTURE)
 193  FORMAT (/20H HEXAGONAL STRUCTURE)
 194  FORMAT(/53H SOMETHING VERY BAD HAPPENED. CALL THE AUTHORS PLEASE)
 195  FORMAT (/11H *OVERFLOW*,/38H NUMBER OF REFLECTIONS IS GREATER THAN
     1,I5,/42H *** UPPER THETA LIMIT *** IS REDUCED FROM,F6.2,4H TO ,   
     XF5.2/)
  200  FORMAT (1H1,131H H  K  L THETA  MM     D     SIN2   H  K  L INTENS
     1    F+(HKL)    F-(HKL)  A+(HKL)  A-(HKL)  B+(HKL)  B-(HKL) PHA+  P
     2HA- MULT   LPG /)
 201  FORMAT(/130H1 H  K  L    THETA  SIN2*1000 INT.SCALED   INTENSITY U
     1NSCALED           /F(HKL)/        A(HKL)        B(HKL) PHA.ANG. MU
     2LT    LPG   /)
 202  FORMAT(/18H1 H  K  L  THETA  ,2A3,107H D VALUE  1/D**2 SIN2*1000  
     1H  K  L INTENSITY         /F(HKL)/       A(HKL)      B(HKL) PHA.AN
     2G. MULT   LPG  /)
 207  FORMAT(1X,'MOINS DE DEUX REFLECTIONS DANS L ESPACE DEFINI !!!!'//)
  208  FORMAT(10H HKL  NONE)
 209  FORMAT(21H HKL WITH K+L=2N ONLY)
 215  FORMAT(21H HKL WITH H+L=2N ONLY)
 211  FORMAT(21H HKL WITH H+K=2N ONLY)
 212  FORMAT(40H HKL WITH H,K,L ALL EVEN OR ALL ODD ONLY )
 213  FORMAT(23H HKL WITH H+K+L=2N ONLY)
 214  FORMAT(24H HKL WITH -H+K+L=3N ONLY)
      END
      SUBROUTINE EQUI
C-----PRINTS EQUIPOINTS STORED IN TS,FS,ISYMCE AND IBRAVL
	REAL IB,N3
      COMMON /EQUO/ TS,FS,NG,ISYMCE,IBRAVL
      COMMON /UNITS/ NPT
      DIMENSION TS(3,24), FS(3,3,24), CON1(7), SYMB1(8), SYMB2(9), DIG(1
     13), IB(24), IP(12), N3(9)
      DATA IB(1)/4H1/2 /,IB(2)/4H2/3 /,IB(3)/4H1/2 /,IB(4)/4H 0  /,IB(5)
     1/4H1/2 /,IB(6)/4H1/2 /,IB(7)/4H1/2 /,IB(8)/4H1/3 /,IB(9)/4H1/2 /,I
     2B(10)/4H1/2 /,IB(11)/4H 0  /,IB(12)/4H1/2 /,IB(13)/4H1/2)/,IB(14)/
     34H1/3 /,IB(15)/4H 0, /,IB(16)/4H1/2)/,IB(17)/4H1/2)/,IB(18)/4H 0 )
     4/,IB(19)/4H1/3 /,IB(20)/4H1/2 /,IB(21)/4H2/3 /,IB(22)/4H 0  /,IB(2
     53)/4H2/3)/,IB(24)/4H1/2,/
      DATA CON1(1)/0.75/,CON1(2)/0.6667/,CON1(3)/0.5/,CON1(4)/0.3333/,CO
     1N1(5)/0.25/,CON1(6)/0.16667/,CON1(7)/0.83333/
      DATA SYMB1(1)/3H3/4/,SYMB1(2)/3H2/3/,SYMB1(3)/3H1/2/,SYMB1(4)/3H1/
     13/,SYMB1(5)/3H1/4/,SYMB1(6)/3H1/6/,SYMB1(7)/3H5/6/,SYMB1(8)/3H   /
      DATA SYMB2(1)/3H +X/,SYMB2(2)/3H  X/,SYMB2(3)/3H -X/,SYMB2(4)/3H +
     1Y/,SYMB2(5)/3H  Y/,SYMB2(6)/3H -Y/,SYMB2(7)/3H +Z/,SYMB2(8)/3H  Z/
     2,SYMB2(9)/3H -Z/
      DATA N3(1)/1H /,N3(2)/3H   /,N3(3)/4H    /,N3(4)/1H,/,N3(5)/4H+(0 
     1/,N3(6)/4H0 0,/,N3(7)/4H 0  /,N3(8)/4H1/2 /,N3(9)/4H1/2)/
      WRITE (NPT,15)
      DIG(13)=N3(1)
      IF (ISYMCE.EQ.1) DIG(13)=N3(4)
C-----FILL OUTPUT STRING WITH BLANKS
      DO 1 NN=1,12
      IP(NN)=N3(3)
 1    DIG(NN)=SYMB1(8)
C-----FILL OUTPUT STRING IP WITH BRAVAIS LATTICE VECTORS
      IF (IBRAVL.LT.2) GO TO 4
C-----FIRST VECTOR
      IP(1)=N3(5)
      IP(2)=N3(6)
C-----SECOND VECTOR
      DO 2 I=1,3
      I1=I+2
      I2=IBRAVL-1
      I3=I*6-6
 2    IP(I1)=IB(I2+I3)
      IF ((IBRAVL.LT.3).OR.(IBRAVL.GT.4)) GO TO 4
C-----THIRD VECTOR
      I2=16+IBRAVL
      DO 3 I=1,3
      I1=I+5
      I3=I*2-2
 3    IP(I1)=IB(I2+I3)
C-----FORTH VECTOR
      IF (IBRAVL.EQ.3) GO TO 4
      IP(9)=N3(7)
      IP(10)=N3(8)
      IP(11)=N3(9)
C-----LOOP OVER NUMBER OF EQUIPOINTS
 4    DO 14 I=1,NG
C-----FILL OUTPUT STRING WITH BLANKS
      DO 5 NN=1,12
 5    DIG(NN)=N3(2)
      ANTI=1.
      NN=1
C-----LOOP OVER X Y Z  COORDINATES
 6    DO 12 J=1,3
      TS1=ANTI*TS(J,I)
      IF (TS1.LT.0.) TS1=1.+TS1
      N1=1
      IF (TS1.EQ.0.) GO TO 9
      DO 7 II=1,7
      DIF=TS1-CON1(II)
      DIF=ABS(DIF)
      IF (DIF.LT..010) GO TO 8
 7    CONTINUE
      WRITE (NPT,16)
      RETURN
 8    DIG(NN)=SYMB1(II)
      NN=NN+1
      N1=2
 9    L=1
C-----LOOP OVER ROWS IN MATRIX
      DO 11 M1=1,3
      FS1=ANTI*FS(M1,J,I)
      IF (FS1.EQ.0.) GO TO 10
      IF (FS1.EQ.1.) L=L-N1+2
      IF (FS1.EQ.-1.) L=L+2
      N1=N1+1
      DIG(NN)=SYMB2(L)
      NN=NN+1
 10   L=M1*3+1
 11   CONTINUE
      NN=NN-N1+3
 12   CONTINUE
      IF (ANTI.EQ.-1.) GO TO 13
      ANTI=-1.
      IF (ISYMCE.EQ.1) GO TO 6
 13   WRITE (NPT,17) (DIG(I1),I1=1,6),DIG(7),DIG(8),DIG(13),DIG(9),DIG(1
     10),DIG(13),DIG(11),DIG(12),(IP(I1),I1=1,12)
 14   CONTINUE
      RETURN
C
 15   FORMAT (/27H EQUIVALENT POINT POSITIONS/)
 16   FORMAT (33H EQUIPOINT CODE BADLY INTERPRETED)
 17   FORMAT (1X,2(2A3,1H,),2A3,5X,2(2A3,A1),2A3,2X,12A4)
      END
      BLOCK DATA                                                       
      CHARACTER*4 TABNC(128),TBXC(256)
      REAL M,NM
      INTEGER CT
      COMMON/TABCHR/TABNC,TBXC
      COMMON/TABLES/TBX(256,10),TBD(128,10),TABN(128)
      COMMON /ND/ NM/WAVEL/ M/BRAF/IB,CT /FLOR/ LPF,CV               
      DIMENSION NM(20),M(20),IB(8),CV(6),LPF(6),CT(8)                  
C-----LITERAL DATA FOR LAZY                                 
      DATA  NM(1)/1H1/, NM(2)/1H2/, NM(3)/1H3/, NM(4)/1H4/, NM(5)/1H5/,
     1NM(6)/1H6/,NM(7)/1HA/,NM(8)/1HB/,NM(9)/1HC/,NM(10)/1HD/,NM(11)/1HM
     2/,NM(12)/1HN/,NM(13)/1HP/,NM(14)/4HCU  /,NM(15)/1H//,NM(16)/1H-/,
     3NM(17)/1H /, NM(18)/2H  /,NM(19)/4H    /,NM(20)/2HSP/
      DATA LPF(1)/0/,LPF(2)/1/,LPF(3)/2/,LPF(4)/3/,LPF(5)/4/,LPF(6)/0/
      DATA CV(1)/2HDS/,CV(2)/2H 1/,CV(3)/2HNE/,CV(4)/2HGN/,CV(5)/2HGH/,C
     1V(6)/2H  /                                                        
      DATA IB(1)/1/,IB(2)/1/,IB(3)/2/,IB(4)/3/,IB(5)/4/,IB(6)/5/,IB(7)/6
     1/,IB(8)/7/                                                        
      DATA CT(1)/1H /,CT(2)/1HP/,CT(3)/1HI/,CT(4)/1HR/,CT(5)/1HF/,CT(6)/
     11HA/,CT(7)/1HB/,CT(8)/1HC/                                        
      DATA M(1)/4HCRA1/,M(2)/4HCRA2/,M(3)/4HCRB /,M(4)/4HCR  /,M(5)/4HFE
     1A1/,M(6)/4HFEA2/,M(7)/4HFEB /,M(8)/4HFE  /,M(9)/4HCUA1/,M(10)/4HCU
     2A2/,M(11)/4HCUB /,M(12)/4HCU  /,M(13)/4HMOA1/,M(14)/4HMOA2/,M(15)/
     34HMOB /,M(16)/4HMO  /,M(17)/4HAGA1/,M(18)/4HAGA2/,M(19)/4HAGB /,M(
     420)/4HAG  /                                                       
C  Scattering factor tables
C     V. F. Sears, Neutron News 3, 26 (1992)
      DATA TABNC(1),TABN(1)/'H',-0.3739/
      DATA TABNC(2),TABN(2)/'HE',0.326/
      DATA TABNC(3),TABN(3)/'LI',-0.190/
      DATA TABNC(4),TABN(4)/'BE',0.779/
      DATA TABNC(5),TABN(5)/'B',0.665/
      DATA TABNC(6),TABN(6)/'C',0.6646/
      DATA TABNC(7),TABN(7)/'N',0.936/
      DATA TABNC(8),TABN(8)/'O',0.5803/
      DATA TABNC(9),TABN(9)/'F',0.565/
      DATA TABNC(10),TABN(10)/'NE',0.4566/
      DATA TABNC(11),TABN(11)/'NA',0.363/
      DATA TABNC(12),TABN(12)/'MG',0.5375/
      DATA TABNC(13),TABN(13)/'AL',0.3449/
      DATA TABNC(14),TABN(14)/'SI',0.4149/
      DATA TABNC(15),TABN(15)/'P',0.513/
      DATA TABNC(16),TABN(16)/'S',0.2847/
      DATA TABNC(17),TABN(17)/'CL',0.95770/
      DATA TABNC(18),TABN(18)/'AR',0.1909/
      DATA TABNC(19),TABN(19)/'K',0.367/
      DATA TABNC(20),TABN(20)/'CA',0.470/
      DATA TABNC(21),TABN(21)/'SC',1.23/
      DATA TABNC(22),TABN(22)/'TI',-0.3438/
      DATA TABNC(23),TABN(23)/'V',-0.0382/
      DATA TABNC(24),TABN(24)/'CR',0.3635/
      DATA TABNC(25),TABN(25)/'MN',-0.373/
      DATA TABNC(26),TABN(26)/'FE',0.945/
      DATA TABNC(27),TABN(27)/'CO',0.249/
      DATA TABNC(28),TABN(28)/'NI',1.03/
      DATA TABNC(29),TABN(29)/'CU',0.7718/
      DATA TABNC(30),TABN(30)/'ZN',0.5680/
      DATA TABNC(31),TABN(31)/'GA',0.7288/
      DATA TABNC(32),TABN(32)/'GE',0.819/
      DATA TABNC(33),TABN(33)/'AS',0.658/
      DATA TABNC(34),TABN(34)/'SE',0.7970/
      DATA TABNC(35),TABN(35)/'BR',0.680/
      DATA TABNC(36),TABN(36)/'KR',0.781/
      DATA TABNC(37),TABN(37)/'RB',0.709/
      DATA TABNC(38),TABN(38)/'SR',0.702/
      DATA TABNC(39),TABN(39)/'Y',0.775/
      DATA TABNC(40),TABN(40)/'ZR',0.716/
      DATA TABNC(41),TABN(41)/'NB',0.7054/
      DATA TABNC(42),TABN(42)/'MO',0.672/
      DATA TABNC(43),TABN(43)/'TC',0.68/
      DATA TABNC(44),TABN(44)/'RU',0.703/
      DATA TABNC(45),TABN(45)/'RH',0.588/
      DATA TABNC(46),TABN(46)/'PD',0.591/
      DATA TABNC(47),TABN(47)/'AG',0.5922/
      DATA TABNC(48),TABN(48)/'CD',0.487/
      DATA TABNC(49),TABN(49)/'IN',0.407/
      DATA TABNC(50),TABN(50)/'SN',0.6225/
      DATA TABNC(51),TABN(51)/'SB',0.557/
      DATA TABNC(52),TABN(52)/'TE',0.580/
      DATA TABNC(53),TABN(53)/'I',0.528/
      DATA TABNC(54),TABN(54)/'XE',0.492/
      DATA TABNC(55),TABN(55)/'CS',0.542/
      DATA TABNC(56),TABN(56)/'BA',0.507/
      DATA TABNC(57),TABN(57)/'LA',0.824/
      DATA TABNC(58),TABN(58)/'CE',0.484/
      DATA TABNC(59),TABN(59)/'PR',0.458/
      DATA TABNC(60),TABN(60)/'ND',0.769/
      DATA TABNC(61),TABN(61)/'EU',0.722/
      DATA TABNC(62),TABN(62)/'GD',0.65/
      DATA TABNC(63),TABN(63)/'TB',0.738/
      DATA TABNC(64),TABN(64)/'DY',1.69/
      DATA TABNC(65),TABN(65)/'HO',0.801/
      DATA TABNC(66),TABN(66)/'ER',0.779/
      DATA TABNC(67),TABN(67)/'TM',0.707/
      DATA TABNC(68),TABN(68)/'YB',1.243/
      DATA TABNC(69),TABN(69)/'LU',0.721/
      DATA TABNC(70),TABN(70)/'HF',0.78/
      DATA TABNC(71),TABN(71)/'TA',0.691/
      DATA TABNC(72),TABN(72)/'W',0.486/
      DATA TABNC(73),TABN(73)/'RE',0.92/
      DATA TABNC(74),TABN(74)/'OS',1.07/
      DATA TABNC(75),TABN(75)/'IR',1.06/
      DATA TABNC(76),TABN(76)/'PT',0.960/
      DATA TABNC(77),TABN(77)/'AU',0.763/
      DATA TABNC(78),TABN(78)/'HG',1.269/
      DATA TABNC(79),TABN(79)/'TL',0.8776/
      DATA TABNC(80),TABN(80)/'PB',0.9405/
      DATA TABNC(81),TABN(81)/'BI',0.8532/
      DATA TABNC(82),TABN(82)/'TH',1.031/
      DATA TABNC(83),TABN(83)/'U',0.8417/
      DATA TABNC(84),TABN(84)/'NP',1.06/
      DATA TABNC(85),TABN(85)/'PU',0.77/
      DATA TABNC(86),TABN(86)/'D',0.6671/
      DATA TABNC(87),TABN(87)/'PM',1.26/
      DATA TABNC(88),TABN(88)/'SM',0.80/
      DATA TABNC(89),TABN(89)/'RA',1.0/
      DATA TABNC(90),TABN(90)/'PA',0.91/
      DATA TABNC(91),TABN(91)/'AM',0.83/
      DATA TABNC(92),TABN(92)/'CM',0.95/
      DATA TBD(  2, 1),TBD(  2, 2),TBD(  2, 3),TBD(  2, 4),TBD(  2, 5)
     *    /   .002    ,   .002    ,   .001    ,  -.000    ,  -.000    /
      DATA TBD(  2, 6),TBD(  2, 7),TBD(  2, 8),TBD(  2, 9),TBD(  2,10)
     *    /   .001    ,   .001    ,   .000    ,   .000    ,   .000    /
      DATA TBD(  3, 1),TBD(  3, 2),TBD(  3, 3),TBD(  3, 4),TBD(  3, 5)
     *    /   .008    ,   .005    ,   .003    ,  -.000    ,  -.001    /
      DATA TBD(  3, 6),TBD(  3, 7),TBD(  3, 8),TBD(  3, 9),TBD(  3,10)
     *    /   .003    ,   .002    ,   .001    ,   .000    ,   .000    /
      DATA TBD(  4, 1),TBD(  4, 2),TBD(  4, 3),TBD(  4, 4),TBD(  4, 5)
     *    /   .018    ,   .013    ,   .008    ,   .000    ,  -.000    /
      DATA TBD(  4, 6),TBD(  4, 7),TBD(  4, 8),TBD(  4, 9),TBD(  4,10)
     *    /   .009    ,   .007    ,   .004    ,   .001    ,   .000    /
      DATA TBD(  5, 1),TBD(  5, 2),TBD(  5, 3),TBD(  5, 4),TBD(  5, 5)
     *    /   .035    ,   .026    ,   .017    ,   .002    ,   .000    /
      DATA TBD(  5, 6),TBD(  5, 7),TBD(  5, 8),TBD(  5, 9),TBD(  5,10)
     *    /   .021    ,   .015    ,   .009    ,   .002    ,   .001    /
      DATA TBD(  6, 1),TBD(  6, 2),TBD(  6, 3),TBD(  6, 4),TBD(  6, 5)
     *    /   .059    ,   .044    ,   .029    ,   .004    ,   .001    /
      DATA TBD(  6, 6),TBD(  6, 7),TBD(  6, 8),TBD(  6, 9),TBD(  6,10)
     *    /   .042    ,   .029    ,   .018    ,   .003    ,   .002    /
      DATA TBD(  7, 1),TBD(  7, 2),TBD(  7, 3),TBD(  7, 4),TBD(  7, 5)
     *    /   .090    ,   .069    ,   .047    ,   .008    ,   .003    /
      DATA TBD(  7, 6),TBD(  7, 7),TBD(  7, 8),TBD(  7, 9),TBD(  7,10)
     *    /   .073    ,   .052    ,   .032    ,   .006    ,   .004    /
      DATA TBD(  8, 1),TBD(  8, 2),TBD(  8, 3),TBD(  8, 4),TBD(  8, 5)
     *    /   .129    ,   .100    ,   .069    ,   .014    ,   .006    /
      DATA TBD(  8, 6),TBD(  8, 7),TBD(  8, 8),TBD(  8, 9),TBD(  8,10)
     *    /   .119    ,   .085    ,   .053    ,   .010    ,   .006    /
      DATA TBD(  9, 1),TBD(  9, 2),TBD(  9, 3),TBD(  9, 4),TBD(  9, 5)
     *    /   .174    ,   .138    ,   .097    ,   .021    ,   .011    /
      DATA TBD(  9, 6),TBD(  9, 7),TBD(  9, 8),TBD(  9, 9),TBD(  9,10)
     *    /   .184    ,   .132    ,   .083    ,   .016    ,   .010    /
      DATA TBD( 10, 1),TBD( 10, 2),TBD( 10, 3),TBD( 10, 4),TBD( 10, 5)
     *    /   .223    ,   .180    ,   .129    ,   .030    ,   .016    /
      DATA TBD( 10, 6),TBD( 10, 7),TBD( 10, 8),TBD( 10, 9),TBD( 10,10)
     *    /   .270    ,   .195    ,   .124    ,   .025    ,   .015    /
      DATA TBD( 11, 1),TBD( 11, 2),TBD( 11, 3),TBD( 11, 4),TBD( 11, 5)
     *    /   .272    ,   .224    ,   .165    ,   .042    ,   .023    /
      DATA TBD( 11, 6),TBD( 11, 7),TBD( 11, 8),TBD( 11, 9),TBD( 11,10)
     *    /   .381    ,   .277    ,   .177    ,   .036    ,   .022    /
      DATA TBD( 12, 1),TBD( 12, 2),TBD( 12, 3),TBD( 12, 4),TBD( 12, 5)
     *    /   .318    ,   .269    ,   .204    ,   .056    ,   .032    /
      DATA TBD( 12, 6),TBD( 12, 7),TBD( 12, 8),TBD( 12, 9),TBD( 12,10)
     *    /   .522    ,   .381    ,   .246    ,   .052    ,   .031    /
      DATA TBD( 13, 1),TBD( 13, 2),TBD( 13, 3),TBD( 13, 4),TBD( 13, 5)
     *    /   .355    ,   .311    ,   .244    ,   .072    ,   .042    /
      DATA TBD( 13, 6),TBD( 13, 7),TBD( 13, 8),TBD( 13, 9),TBD( 13,10)
     *    /   .693    ,   .509    ,   .330    ,   .071    ,   .043    /
      DATA TBD( 14, 1),TBD( 14, 2),TBD( 14, 3),TBD( 14, 4),TBD( 14, 5)
     *    /   .377    ,   .347    ,   .283    ,   .090    ,   .055    /
      DATA TBD( 14, 6),TBD( 14, 7),TBD( 14, 8),TBD( 14, 9),TBD( 14,10)
     *    /   .900    ,   .664    ,   .434    ,   .095    ,   .058    /
      DATA TBD( 15, 1),TBD( 15, 2),TBD( 15, 3),TBD( 15, 4),TBD( 15, 5)
     *    /   .374    ,   .370    ,   .319    ,   .110    ,   .068    /
      DATA TBD( 15, 6),TBD( 15, 7),TBD( 15, 8),TBD( 15, 9),TBD( 15,10)
     *    /  1.142    ,   .847    ,   .557    ,   .124    ,   .076    /
      DATA TBD( 16, 1),TBD( 16, 2),TBD( 16, 3),TBD( 16, 4),TBD( 16, 5)
     *    /   .335    ,   .375    ,   .348    ,   .132    ,   .084    /
      DATA TBD( 16, 6),TBD( 16, 7),TBD( 16, 8),TBD( 16, 9),TBD( 16,10)
     *    /  1.423    ,  1.061    ,   .702    ,   .159    ,   .099    /
      DATA TBD( 17, 1),TBD( 17, 2),TBD( 17, 3),TBD( 17, 4),TBD( 17, 5)
     *    /   .243    ,   .352    ,   .366    ,   .155    ,   .101    /
      DATA TBD( 17, 6),TBD( 17, 7),TBD( 17, 8),TBD( 17, 9),TBD( 17,10)
     *    /  1.747    ,  1.309    ,   .872    ,   .201    ,   .125    /
      DATA TBD( 18, 1),TBD( 18, 2),TBD( 18, 3),TBD( 18, 4),TBD( 18, 5)
     *    /   .070    ,   .286    ,   .365    ,   .179    ,   .118    /
      DATA TBD( 18, 6),TBD( 18, 7),TBD( 18, 8),TBD( 18, 9),TBD( 18,10)
     *    /  2.110    ,  1.589    ,  1.066    ,   .250    ,   .156    /
      DATA TBD( 19, 1),TBD( 19, 2),TBD( 19, 3),TBD( 19, 4),TBD( 19, 5)
     *    /  -.221    ,   .163    ,   .341    ,   .203    ,   .137    /
      DATA TBD( 19, 6),TBD( 19, 7),TBD( 19, 8),TBD( 19, 9),TBD( 19,10)
     *    /  2.514    ,  1.904    ,  1.286    ,   .306    ,   .193    /
      DATA TBD( 20, 1),TBD( 20, 2),TBD( 20, 3),TBD( 20, 4),TBD( 20, 5)
     *    /  -.717    ,  -.038    ,   .285    ,   .226    ,   .156    /
      DATA TBD( 20, 6),TBD( 20, 7),TBD( 20, 8),TBD( 20, 9),TBD( 20,10)
     *    /  2.968    ,  2.256    ,  1.533    ,   .372    ,   .235    /
      DATA TBD( 21, 1),TBD( 21, 2),TBD( 21, 3),TBD( 21, 4),TBD( 21, 5)
     *    / -1.683    ,  -.357    ,   .189    ,   .248    ,   .175    /
      DATA TBD( 21, 6),TBD( 21, 7),TBD( 21, 8),TBD( 21, 9),TBD( 21,10)
     *    /  3.470    ,  2.643    ,  1.807    ,   .446    ,   .283    /
      DATA TBD( 22, 1),TBD( 22, 2),TBD( 22, 3),TBD( 22, 4),TBD( 22, 5)
     *    / -3.841    ,  -.896    ,   .035    ,   .267    ,   .194    /
      DATA TBD( 22, 6),TBD( 22, 7),TBD( 22, 8),TBD( 22, 9),TBD( 22,10)
     *    /   .459    ,  3.070    ,  2.110    ,   .530    ,   .338    /
      DATA TBD( 23, 1),TBD( 23, 2),TBD( 23, 3),TBD( 23, 4),TBD( 23, 5)
     *    / -2.161    , -1.973    ,  -.198    ,   .284    ,   .213    /
      DATA TBD( 23, 6),TBD( 23, 7),TBD( 23, 8),TBD( 23, 9),TBD( 23,10)
     *    /   .548    ,  3.533    ,  2.443    ,   .624    ,   .399    /
      DATA TBD( 24, 1),TBD( 24, 2),TBD( 24, 3),TBD( 24, 4),TBD( 24, 5)
     *    / -1.639    , -3.367    ,  -.568    ,   .295    ,   .229    /
      DATA TBD( 24, 6),TBD( 24, 7),TBD( 24, 8),TBD( 24, 9),TBD( 24,10)
     *    /   .650    ,   .481    ,  2.808    ,   .729    ,   .468    /

      DATA TBD( 25, 1),TBD( 25, 2),TBD( 25, 3),TBD( 25, 4),TBD( 25, 5)
     *    / -1.339    , -2.095    , -1.179    ,   .301    ,   .244    /
      DATA TBD( 25, 6),TBD( 25, 7),TBD( 25, 8),TBD( 25, 9),TBD( 25,10)
     *    /   .764    ,   .566    ,  3.204    ,   .845    ,   .545    /
      DATA TBD( 26, 1),TBD( 26, 2),TBD( 26, 3),TBD( 26, 4),TBD( 26, 5)
     *    / -1.124    , -1.623    , -2.464    ,   .299    ,   .256    /
      DATA TBD( 26, 6),TBD( 26, 7),TBD( 26, 8),TBD( 26, 9),TBD( 26,10)
     *    /   .893    ,   .662    ,  3.608    ,   .973    ,   .630    /
      DATA TBD( 27, 1),TBD( 27, 2),TBD( 27, 3),TBD( 27, 4),TBD( 27, 5)
     *    /  -.956    , -1.343    , -2.956    ,   .285    ,   .261    /
      DATA TBD( 27, 6),TBD( 27, 7),TBD( 27, 8),TBD( 27, 9),TBD( 27,10)
     *    /  1.036    ,   .769    ,   .509    ,  1.113    ,   .724    /
      DATA TBD( 28, 1),TBD( 28, 2),TBD( 28, 3),TBD( 28, 4),TBD( 28, 5)
     *    /  -.795    , -1.129    , -2.019    ,   .263    ,   .265    /
      DATA TBD( 28, 6),TBD( 28, 7),TBD( 28, 8),TBD( 28, 9),TBD( 28,10)
     *    /  1.196    ,   .888    ,   .589    ,  1.266    ,   .826    /
      DATA TBD( 29, 1),TBD( 29, 2),TBD( 29, 3),TBD( 29, 4),TBD( 29, 5)
     *    /  -.684    ,  -.978    , -1.612    ,   .222    ,   .260    /
      DATA TBD( 29, 6),TBD( 29, 7),TBD( 29, 8),TBD( 29, 9),TBD( 29,10)
     *    /  1.373    ,  1.021    ,   .678    ,  1.431    ,   .938    /
      DATA TBD( 30, 1),TBD( 30, 2),TBD( 30, 3),TBD( 30, 4),TBD( 30, 5)
     *    /  -.570    ,  -.841    , -1.354    ,   .163    ,   .249    /
      DATA TBD( 30, 6),TBD( 30, 7),TBD( 30, 8),TBD( 30, 9),TBD( 30,10)
     *    /  1.569    ,  1.168    ,   .777    ,  1.609    ,  1.059    /
      DATA TBD( 31, 1),TBD( 31, 2),TBD( 31, 3),TBD( 31, 4),TBD( 31, 5)
     *    /  -.462    ,  -.717    , -1.163    ,   .081    ,   .228    /
      DATA TBD( 31, 6),TBD( 31, 7),TBD( 31, 8),TBD( 31, 9),TBD( 31,10)
     *    /  1.786    ,  1.331    ,   .886    ,  1.801    ,  1.190    /
      DATA TBD( 32, 1),TBD( 32, 2),TBD( 32, 3),TBD( 32, 4),TBD( 32, 5)
     *    /  -.365    ,  -.607    , -1.011    ,  -.030    ,   .196    /
      DATA TBD( 32, 6),TBD( 32, 7),TBD( 32, 8),TBD( 32, 9),TBD( 32,10)
     *    /  2.022    ,  1.508    ,  1.006    ,  2.007    ,  1.332    /
      DATA TBD( 33, 1),TBD( 33, 2),TBD( 33, 3),TBD( 33, 4),TBD( 33, 5)
     *    /  -.273    ,  -.503    ,  -.879    ,  -.178    ,   .152    /
      DATA TBD( 33, 6),TBD( 33, 7),TBD( 33, 8),TBD( 33, 9),TBD( 33,10)
     *    /  2.283    ,  1.704    ,  1.139    ,  2.223    ,  1.481    /
      DATA TBD( 34, 1),TBD( 34, 2),TBD( 34, 3),TBD( 34, 4),TBD( 34, 5)
     *    /  -.198    ,  -.413    ,  -.767    ,  -.374    ,   .090    /
      DATA TBD( 34, 6),TBD( 34, 7),TBD( 34, 8),TBD( 34, 9),TBD( 34,10)
     *    /  2.563    ,  1.916    ,  1.283    ,  2.456    ,  1.643    /
      DATA TBD( 35, 1),TBD( 35, 2),TBD( 35, 3),TBD( 35, 4),TBD( 35, 5)
     *    /  -.130    ,  -.328    ,  -.665    ,  -.652    ,   .008    /
      DATA TBD( 35, 6),TBD( 35, 7),TBD( 35, 8),TBD( 35, 9),TBD( 35,10)
     *    /  2.872    ,  2.149    ,  1.439    ,  2.713    ,  1.820    /
      DATA TBD( 36, 1),TBD( 36, 2),TBD( 36, 3),TBD( 36, 4),TBD( 36, 5)
     *    /  -.082    ,  -.256    ,  -.574    , -1.044    ,  -.099    /
      DATA TBD( 36, 6),TBD( 36, 7),TBD( 36, 8),TBD( 36, 9),TBD( 36,10)
     *    /  3.201    ,  2.398    ,  1.608    ,  2.973    ,  2.003    /
      DATA TBD( 37, 1),TBD( 37, 2),TBD( 37, 3),TBD( 37, 4),TBD( 37, 5)
     *    /  -.012    ,  -.161    ,  -.465    , -1.657    ,  -.230    /
      DATA TBD( 37, 6),TBD( 37, 7),TBD( 37, 8),TBD( 37, 9),TBD( 37,10)
     *    /  3.608    ,  2.709    ,  1.820    ,  3.264    ,  2.203    /
      DATA TBD( 38, 1),TBD( 38, 2),TBD( 38, 3),TBD( 38, 4),TBD( 38, 5)
     *    /   .006    ,  -.106    ,  -.386    , -2.951    ,  -.406    /
      DATA TBD( 38, 6),TBD( 38, 7),TBD( 38, 8),TBD( 38, 9),TBD( 38,10)
     *    /  4.002    ,  3.009    ,  2.025    ,  3.542    ,  2.411    /
      DATA TBD( 39, 1),TBD( 39, 2),TBD( 39, 3),TBD( 39, 4),TBD( 39, 5)
     *    /   .007    ,  -.061    ,  -.314    , -2.965    ,  -.639    /
      DATA TBD( 39, 6),TBD( 39, 7),TBD( 39, 8),TBD( 39, 9),TBD( 39,10)
     *    /  4.422    ,  3.329    ,  2.245    ,   .560    ,  2.630    /
      DATA TBD( 40, 1),TBD( 40, 2),TBD( 40, 3),TBD( 40, 4),TBD( 40, 5)
     *    /  -.013    ,  -.028    ,  -.248    , -2.197    ,  -.957    /
      DATA TBD( 40, 6),TBD( 40, 7),TBD( 40, 8),TBD( 40, 9),TBD( 40,10)
     *    /  4.876    ,  3.676    ,  2.482    ,   .621    ,  2.860    /
      DATA TBD( 41, 1),TBD( 41, 2),TBD( 41, 3),TBD( 41, 4),TBD( 41, 5)
     *    /  -.063    ,  -.012    ,  -.191    , -1.825    , -1.416    /
      DATA TBD( 41, 6),TBD( 41, 7),TBD( 41, 8),TBD( 41, 9),TBD( 41,10)
     *    /  5.353    ,  4.043    ,  2.735    ,   .688    ,  3.103    /
      DATA TBD( 42, 1),TBD( 42, 2),TBD( 42, 3),TBD( 42, 4),TBD( 42, 5)
     *    /  -.153    ,  -.017    ,  -.145    , -1.590    , -2.205    /
      DATA TBD( 42, 6),TBD( 42, 7),TBD( 42, 8),TBD( 42, 9),TBD( 42,10)
     *    /  5.862    ,  4.434    ,  3.005    ,   .759    ,  3.353    /
      DATA TBD( 43, 1),TBD( 43, 2),TBD( 43, 3),TBD( 43, 4),TBD( 43, 5)
     *    /  -.270    ,  -.039    ,  -.105    , -1.420    , -5.524    /
      DATA TBD( 43, 6),TBD( 43, 7),TBD( 43, 8),TBD( 43, 9),TBD( 43,10)
     *    /  6.406    ,  4.854    ,  3.296    ,   .836    ,  3.651    /
      DATA TBD( 44, 1),TBD( 44, 2),TBD( 44, 3),TBD( 44, 4),TBD( 44, 5)
     *    /  -.424    ,  -.083    ,  -.077    , -1.287    , -2.649    /
      DATA TBD( 44, 6),TBD( 44, 7),TBD( 44, 8),TBD( 44, 9),TBD( 44,10)
     *    /  6.984    ,  5.300    ,  3.605    ,   .919    ,   .596    /
      DATA TBD( 45, 1),TBD( 45, 2),TBD( 45, 3),TBD( 45, 4),TBD( 45, 5)
     *    /  -.639    ,  -.157    ,  0.1215   , -1.177    , -2.128    /
      DATA TBD( 45, 6),TBD( 45, 7),TBD( 45, 8),TBD( 45, 9),TBD( 45,10)
     *    /  7.594    ,  5.773    ,  3.9337   ,  1.007    ,   .654    /
      DATA TBD( 46, 1),TBD( 46, 2),TBD( 46, 3),TBD( 46, 4),TBD( 46, 5)
     *    /  -.924    ,  -.259    ,  -.060    , -1.085    , -1.834    /
      DATA TBD( 46, 6),TBD( 46, 7),TBD( 46, 8),TBD( 46, 9),TBD( 46,10)
     *    /  8.235    ,  6.271    ,  4.282    ,  1.101    ,   .717    /
      DATA TBD( 47, 1),TBD( 47, 2),TBD( 47, 3),TBD( 47, 4),TBD( 47, 5)
     *    / -1.303    ,  -.416    ,  -.079    , -1.005    , -1.637    /
      DATA TBD( 47, 6),TBD( 47, 7),TBD( 47, 8),TBD( 47, 9),TBD( 47,10)
     *    /  8.912    ,  6.800    ,  4.653    ,  1.202    ,   .783    /
      DATA TBD( 48, 1),TBD( 48, 2),TBD( 48, 3),TBD( 48, 4),TBD( 48, 5)
     *    / -1.788    ,  -.626    ,  -.126    ,  -.936    , -1.493    /
      DATA TBD( 48, 6),TBD( 48, 7),TBD( 48, 8),TBD( 48, 9),TBD( 48,10)
     *    /  9.627    ,  7.356    ,  5.045    ,  1.310    ,   .854    /
      DATA TBD( 49, 1),TBD( 49, 2),TBD( 49, 3),TBD( 49, 4),TBD( 49, 5)
     *    / -2.401    ,  -.888    ,  -.194    ,  -.873    , -1.378    /
      DATA TBD( 49, 6),TBD( 49, 7),TBD( 49, 8),TBD( 49, 9),TBD( 49,10)
     *    / 10.380    ,  7.943    ,  5.459    ,  1.424    ,   .930    /
      DATA TBD( 50, 1),TBD( 50, 2),TBD( 50, 3),TBD( 50, 4),TBD( 50, 5)
     *    / -3.194    , -1.214    ,  -.287    ,  -.816    , -1.284    /
      DATA TBD( 50, 6),TBD( 50, 7),TBD( 50, 8),TBD( 50, 9),TBD( 50,10)
     *    / 11.166    ,  8.557    ,  5.894    ,  1.546    ,  1.010    /
      DATA TBD( 51, 1),TBD( 51, 2),TBD( 51, 3),TBD( 51, 4),TBD( 51, 5)
     *    / -4.267    , -1.630    ,  -.418    ,  -.772    , -1.212    /
      DATA TBD( 51, 6),TBD( 51, 7),TBD( 51, 8),TBD( 51, 9),TBD( 51,10)
     *    / 11.995    ,  9.203    ,  6.352    ,  1.675    ,  1.096    /
      DATA TBD( 52, 1),TBD( 52, 2),TBD( 52, 3),TBD( 52, 4),TBD( 52, 5)
     *    / -5.852    , -2.147    ,  -.579    ,  -.726    , -1.144    /
      DATA TBD( 52, 6),TBD( 52, 7),TBD( 52, 8),TBD( 52, 9),TBD( 52,10)
     *    / 12.850    ,  9.885    ,  6.835    ,  1.812    ,  1.187    /
      DATA TBD( 53, 1),TBD( 53, 2),TBD( 53, 3),TBD( 53, 4),TBD( 53, 5)

     *    / -8.133    , -2.812    ,  -.783    ,  -.684    , -1.084    /
      DATA TBD( 53, 6),TBD( 53, 7),TBD( 53, 8),TBD( 53, 9),TBD( 53,10)
     *    / 11.933    , 10.608    ,  7.348    ,  1.958    ,  1.284    /
      DATA TBD( 54, 1),TBD( 54, 2),TBD( 54, 3),TBD( 54, 4),TBD( 54, 5)
     *    /-10.742    , -3.652    , -1.022    ,  -.644    , -1.029    /
      DATA TBD( 54, 6),TBD( 54, 7),TBD( 54, 8),TBD( 54, 9),TBD( 54,10)
     *    / 12.919    , 11.382    ,  7.904    ,  2.119    ,  1.391    /
      DATA TBD( 55, 1),TBD( 55, 2),TBD( 55, 3),TBD( 55, 4),TBD( 55, 5)
     *    /-11.460    , -4.832    , -1.334    ,  -.613    ,  -.983    /
      DATA TBD( 55, 6),TBD( 55, 7),TBD( 55, 8),TBD( 55, 9),TBD( 55,10)
     *    /  9.981    , 12.164    ,  8.460    ,  2.282    ,  1.500    /
      DATA TBD( 56, 1),TBD( 56, 2),TBD( 56, 3),TBD( 56, 4),TBD( 56, 5)
     *    /-12.135    , -6.683    , -1.716    ,  -.588    ,  -.942    /
      DATA TBD( 56, 6),TBD( 56, 7),TBD( 56, 8),TBD( 56, 9),TBD( 56,10)
     *    /  3.565    , 12.937    ,  9.036    ,  2.452    ,  1.615    /
      DATA TBD( 57, 1),TBD( 57, 2),TBD( 57, 3),TBD( 57, 4),TBD( 57, 5)
     *    / -9.574    , -8.388    , -2.170    ,  -.564    ,  -.904    /
      DATA TBD( 57, 6),TBD( 57, 7),TBD( 57, 8),TBD( 57, 9),TBD( 57,10)
     *    /  3.843    , 11.953    ,  9.648    ,  2.632    ,  1.735    /
      DATA TBD( 58, 1),TBD( 58, 2),TBD( 58, 3),TBD( 58, 4),TBD( 58, 5)
     *    / -7.817    ,-12.457    , -2.939    ,  -.530    ,  -.859    /
      DATA TBD( 58, 6),TBD( 58, 7),TBD( 58, 8),TBD( 58, 9),TBD( 58,10)
     *    /  4.130    ,  6.285    , 10.535    ,  2.845    ,  1.873    /
      DATA TBD( 59, 1),TBD( 59, 2),TBD( 59, 3),TBD( 59, 4),TBD( 59, 5)
     *    / -7.486    ,-11.016    , -3.431    ,  -.535    ,  -.842    /
      DATA TBD( 59, 6),TBD( 59, 7),TBD( 59, 8),TBD( 59, 9),TBD( 59,10)
     *    /  4.427    ,  9.874    , 10.933    ,  3.018    ,  1.995    /
      DATA TBD( 60, 1),TBD( 60, 2),TBD( 60, 3),TBD( 60, 4),TBD( 60, 5)
     *    / -6.891    ,-12.122    , -4.357    ,  -.530    ,  -.818    /
      DATA TBD( 60, 6),TBD( 60, 7),TBD( 60, 8),TBD( 60, 9),TBD( 60,10)
     *    /  4.741    ,  3.627    , 11.614    ,  3.225    ,  2.135    /
      DATA TBD( 61, 1),TBD( 61, 2),TBD( 61, 3),TBD( 61, 4),TBD( 61, 5)
     *    / -6.429    , -9.616    , -5.696    ,  -.533    ,  -.798    /
      DATA TBD( 61, 6),TBD( 61, 7),TBD( 61, 8),TBD( 61, 9),TBD( 61,10)
     *    /  5.073    ,  3.883    , 12.320    ,  3.442    ,  2.281    /
      DATA TBD( 62, 1),TBD( 62, 2),TBD( 62, 3),TBD( 62, 4),TBD( 62, 5)
     *    / -6.050    , -8.352    , -7.718    ,  -.542    ,  -.782    /
      DATA TBD( 62, 6),TBD( 62, 7),TBD( 62, 8),TBD( 62, 9),TBD( 62,10)
     *    /  5.416    ,  4.149    , 11.276    ,  3.669    ,  2.435    /
      DATA TBD( 63, 1),TBD( 63, 2),TBD( 63, 3),TBD( 63, 4),TBD( 63, 5)
     *    / -5.779    , -7.565    , -9.242    ,  -.564    ,  -.774    /
      DATA TBD( 63, 6),TBD( 63, 7),TBD( 63, 8),TBD( 63, 9),TBD( 63,10)
     *    /  5.773    ,  4.427    , 11.946    ,  3.904    ,  2.595    /
      DATA TBD( 64, 1),TBD( 64, 2),TBD( 64, 3),TBD( 64, 4),TBD( 64, 5)
     *    / -5.525    , -6.980    , -9.498    ,  -.591    ,  -.767    /
      DATA TBD( 64, 6),TBD( 64, 7),TBD( 64, 8),TBD( 64, 9),TBD( 64,10)
     *    /  6.153    ,  4.721    ,  9.242    ,  4.151    ,  2.764    /
      DATA TBD( 65, 1),TBD( 65, 2),TBD( 65, 3),TBD( 65, 4),TBD( 65, 5)
     *    / -5.250    , -6.492    ,-10.423    ,  -.619    ,  -.761    /
      DATA TBD( 65, 6),TBD( 65, 7),TBD( 65, 8),TBD( 65, 9),TBD( 65,10)
     *    /  6.549    ,  5.026    ,  9.748    ,  4.410    ,  2.940    /
      DATA TBD( 66, 1),TBD( 66, 2),TBD( 66, 3),TBD( 66, 4),TBD( 66, 5)
     *    / -5.040    , -6.112    ,-12.255    ,  -.666    ,  -.765    /
      DATA TBD( 66, 6),TBD( 66, 7),TBD( 66, 8),TBD( 66, 9),TBD( 66,10)
     *    /  6.958    ,  5.343    ,  3.704    ,  4.678    ,  3.124    /
      DATA TBD( 67, 1),TBD( 67, 2),TBD( 67, 3),TBD( 67, 4),TBD( 67, 5)
     *    / -4.878    , -5.810    , -9.733    ,  -.723    ,  -.773    /
      DATA TBD( 67, 6),TBD( 67, 7),TBD( 67, 8),TBD( 67, 9),TBD( 67,10)
     *    /  7.387    ,  5.675    ,  3.937    ,  4.958    ,  3.316    /
      DATA TBD( 68, 1),TBD( 68, 2),TBD( 68, 3),TBD( 68, 4),TBD( 68, 5)
     *    / -4.753    , -5.565    , -8.488    ,  -.795    ,  -.790    /
      DATA TBD( 68, 6),TBD( 68, 7),TBD( 68, 8),TBD( 68, 9),TBD( 68,10)
     *    /  7.833    ,  6.022    ,  4.181    ,  5.248    ,  3.515    /
      DATA TBD( 69, 1),TBD( 69, 2),TBD( 69, 3),TBD( 69, 4),TBD( 69, 5)
     *    / -4.652    , -5.361    , -7.701    ,  -.884    ,  -.815    /
      DATA TBD( 69, 6),TBD( 69, 7),TBD( 69, 8),TBD( 69, 9),TBD( 69,10)
     *    /  8.291    ,  6.378    ,  4.432    ,  5.548    ,  3.723    /
      DATA TBD( 70, 1),TBD( 70, 2),TBD( 70, 3),TBD( 70, 4),TBD( 70, 5)
     *    / -4.580    , -5.190    , -7.133    ,  -.988    ,  -.847    /
      DATA TBD( 70, 6),TBD( 70, 7),TBD( 70, 8),TBD( 70, 9),TBD( 70,10)
     *    /  8.759    ,  6.745    ,  4.693    ,  5.858    ,  3.937    /
      DATA TBD( 71, 1),TBD( 71, 2),TBD( 71, 3),TBD( 71, 4),TBD( 71, 5)
     *    / -4.592    , -5.088    , -6.715    , -1.118    ,  -.890    /
      DATA TBD( 71, 6),TBD( 71, 7),TBD( 71, 8),TBD( 71, 9),TBD( 71,10)
     *    /  9.277    ,  7.148    ,  4.977    ,  6.185    ,  4.164    /
      DATA TBD( 72, 1),TBD( 72, 2),TBD( 72, 3),TBD( 72, 4),TBD( 72, 5)
     *    / -4.540    , -4.948    , -6.351    , -1.258    ,  -.937    /
      DATA TBD( 72, 6),TBD( 72, 7),TBD( 72, 8),TBD( 72, 9),TBD( 72,10)
     *    /  9.811    ,  7.565    ,  5.271    ,  6.523    ,  4.399    /
      DATA TBD( 73, 1),TBD( 73, 2),TBD( 73, 3),TBD( 73, 4),TBD( 73, 5)
     *    / -4.499    , -4.823    , -6.048    , -1.421    ,  -.993    /
      DATA TBD( 73, 6),TBD( 73, 7),TBD( 73, 8),TBD( 73, 9),TBD( 73,10)
     *    / 10.364    ,  7.996    ,  5.577    ,  6.872    ,  4.643    /
      DATA TBD( 74, 1),TBD( 74, 2),TBD( 74, 3),TBD( 74, 4),TBD( 74, 5)
     *    / -4.483    , -4.719    , -5.790    , -1.598    , -1.048    /
      DATA TBD( 74, 6),TBD( 74, 7),TBD( 74, 8),TBD( 74, 9),TBD( 74,10)
     *    / 10.929    ,  8.439    ,  5.891    ,  7.232    ,  4.894    /
      DATA TBD( 75, 1),TBD( 75, 2),TBD( 75, 3),TBD( 75, 4),TBD( 75, 5)
     *    / -4.503    , -4.647    , -5.581    , -1.816    , -1.127    /
      DATA TBD( 75, 6),TBD( 75, 7),TBD( 75, 8),TBD( 75, 9),TBD( 75,10)
     *    / 11.520    ,  8.903    ,  6.221    ,  7.605    ,  5.156    /
      DATA TBD( 76, 1),TBD( 76, 2),TBD( 76, 3),TBD( 76, 4),TBD( 76, 5)
     *    / -4.527    , -4.578    , -5.391    , -2.066    , -1.216    /
      DATA TBD( 76, 6),TBD( 76, 7),TBD( 76, 8),TBD( 76, 9),TBD( 76,10)
     *    / 12.140    ,  9.389    ,  6.566    ,  7.990    ,  5.427    /
      DATA TBD( 77, 1),TBD( 77, 2),TBD( 77, 3),TBD( 77, 4),TBD( 77, 5)
     *    / -4.584    , -4.535    , -5.233    , -2.352    , -1.319    /
      DATA TBD( 77, 6),TBD( 77, 7),TBD( 77, 8),TBD( 77, 9),TBD( 77,10)
     *    / 12.787    ,  9.895    ,  6.925    ,  8.388    ,  5.708    /
      DATA TBD( 78, 1),TBD( 78, 2),TBD( 78, 3),TBD( 78, 4),TBD( 78, 5)
     *    / -4.668    , -4.510    , -5.096    , -2.688    , -1.438    /
      DATA TBD( 78, 6),TBD( 78, 7),TBD( 78, 8),TBD( 78, 9),TBD( 78,10)
     *    / 13.451    , 10.418    ,  7.297    ,  8.798    ,  5.998    /
      DATA TBD( 79, 1),TBD( 79, 2),TBD( 79, 3),TBD( 79, 4),TBD( 79, 5)
     *    / -4.803    , -4.523    , -4.990    , -3.084    , -1.576    /
      DATA TBD( 79, 6),TBD( 79, 7),TBD( 79, 8),TBD( 79, 9),TBD( 79,10)
     *    / 14.143    , 10.963    ,  7.686    ,  9.223    ,  6.299    /
      DATA TBD( 80, 1),TBD( 80, 2),TBD( 80, 3),TBD( 80, 4),TBD( 80, 5)
     *    / -4.945    , -4.532    , -4.883    , -3.556    , -1.730    /
      DATA TBD( 80, 6),TBD( 80, 7),TBD( 80, 8),TBD( 80, 9),TBD( 80,10)
     *    / 14.860    , 11.528    ,  8.089    ,  9.659    ,  6.610    /
      DATA TBD( 81, 1),TBD( 81, 2),TBD( 81, 3),TBD( 81, 4),TBD( 81, 5)
     *    / -5.161    , -4.596    , -4.818    , -4.133    , -1.910    /
      DATA TBD( 81, 6),TBD( 81, 7),TBD( 81, 8),TBD( 81, 9),TBD( 81,10)
     *    / 15.595    , 12.108    ,  8.505    , 10.102    ,  6.930    /
      DATA TBD( 82, 1),TBD( 82, 2),TBD( 82, 3),TBD( 82, 4),TBD( 82, 5)
     *    / -5.420    , -4.688    , -4.776    , -4.861    , -2.116    /
      DATA TBD( 82, 6),TBD( 82, 7),TBD( 82, 8),TBD( 82, 9),TBD( 82,10)
     *    / 16.341    , 12.700    ,  8.930    , 10.559    ,  7.258    /
      DATA TBD( 83, 1),TBD( 83, 2),TBD( 83, 3),TBD( 83, 4),TBD( 83, 5)
     *    / -5.742    , -4.817    , -4.756    , -5.924    , -2.353    /
      DATA TBD( 83, 6),TBD( 83, 7),TBD( 83, 8),TBD( 83, 9),TBD( 83,10)
     *    / 17.139    , 13.331    ,  9.383    , 11.042    ,  7.600    /
      DATA TBD( 84, 1),TBD( 84, 2),TBD( 84, 3),TBD( 84, 4),TBD( 84, 5)
     *    / -6.132    , -4.992    , -4.772    , -7.444    , -2.630    /
      DATA TBD( 84, 6),TBD( 84, 7),TBD( 84, 8),TBD( 84, 9),TBD( 84,10)
     *    / 17.942    , 13.969    ,  9.843    ,  9.961    ,  7.949    /
      DATA TBD( 85, 1),TBD( 85, 2),TBD( 85, 3),TBD( 85, 4),TBD( 85, 5)
     *    / -6.545    , -5.173    , -4.787    , -8.862    , -2.932    /
      DATA TBD( 85, 6),TBD( 85, 7),TBD( 85, 8),TBD( 85, 9),TBD( 85,10)
     *    / 18.775    , 14.629    , 10.317    , 10.403    ,  8.307    /
      DATA TBD( 86, 1),TBD( 86, 2),TBD( 86, 3),TBD( 86, 4),TBD( 86, 5)
     *    / -7.052    , -5.402    , -4.833    , -7.912    , -3.285    /
      DATA TBD( 86, 6),TBD( 86, 7),TBD( 86, 8),TBD( 86, 9),TBD( 86,10)
     *    / 19.615    , 15.299    , 10.803    ,  7.754    ,  8.674    /
      DATA TBD( 87, 1),TBD( 87, 2),TBD( 87, 3),TBD( 87, 4),TBD( 87, 5)
     *    / -7.614    , -5.659    , -4.898    , -7.620    , -3.702    /
      DATA TBD( 87, 6),TBD( 87, 7),TBD( 87, 8),TBD( 87, 9),TBD( 87,10)
     *    / 20.461    , 15.977    , 11.296    ,  8.105    ,  9.047    /
      DATA TBD( 88, 1),TBD( 88, 2),TBD( 88, 3),TBD( 88, 4),TBD( 88, 5)
     *    / -8.318    , -5.976    , -4.994    , -7.725    , -4.192    /
      DATA TBD( 88, 6),TBD( 88, 7),TBD( 88, 8),TBD( 88, 9),TBD( 88,10)
     *    / 21.327    , 16.668    , 11.799    ,  8.472    ,  9.428    /
      DATA TBD( 89, 1),TBD( 89, 2),TBD( 89, 3),TBD( 89, 4),TBD( 89, 5)
     *    / -9.150    , -6.313    , -5.091    , -8.127    , -4.784    /
      DATA TBD( 89, 6),TBD( 89, 7),TBD( 89, 8),TBD( 89, 9),TBD( 89,10)
     *    / 22.240    , 17.397    , 12.330    ,  8.870    ,  9.819    /
      DATA TBD( 90, 1),TBD( 90, 2),TBD( 90, 3),TBD( 90, 4),TBD( 90, 5)
     *    /-10.382    , -6.695    , -5.216    , -8.960    , -5.555    /
      DATA TBD( 90, 6),TBD( 90, 7),TBD( 90, 8),TBD( 90, 9),TBD( 90,10)
     *    / 23.161    , 18.140    , 12.868    ,  9.284    , 10.227    /
      DATA TBD( 91, 1),TBD( 91, 2),TBD( 91, 3),TBD( 91, 4),TBD( 91, 5)
     *    /-10.930    , -7.126    , -5.359    ,-10.673    , -6.735    /
      DATA TBD( 91, 6),TBD( 91, 7),TBD( 91, 8),TBD( 91, 9),TBD( 91,10)
     *    / 23.121    , 18.879    , 13.409    ,  9.654    , 10.637    /
      DATA TBD( 92, 1),TBD( 92, 2),TBD( 92, 3),TBD( 92, 4),TBD( 92, 5)
     *    /-12.152    , -7.624    , -5.529    ,-11.158    , -7.842    /
      DATA TBD( 92, 6),TBD( 92, 7),TBD( 92, 8),TBD( 92, 9),TBD( 92,10)
     *    / 24.097    , 19.642    , 13.967    ,  4.148    ,  9.570    /
      DATA TBD( 93, 1),TBD( 93, 2),TBD( 93, 3),TBD( 93, 4),TBD( 93, 5)
     *    /-12.280    , -8.187    , -5.712    , -9.725    , -8.473    /
      DATA TBD( 93, 6),TBD( 93, 7),TBD( 93, 8),TBD( 93, 9),TBD( 93,10)
     *    / 23.658    , 20.425    , 14.536    ,  4.330    ,  6.999    /
      DATA TBD( 94, 1),TBD( 94, 2),TBD( 94, 3),TBD( 94, 4),TBD( 94, 5)
     *    /-12.771    , -8.872    , -5.930    , -8.926    , -7.701    /
      DATA TBD( 94, 6),TBD( 94, 7),TBD( 94, 8),TBD( 94, 9),TBD( 94,10)
     *    / 24.607    , 21.173    , 15.087    ,  4.511    ,  7.296    /
      DATA TBD( 95, 1),TBD( 95, 2),TBD( 95, 3),TBD( 95, 4),TBD( 95, 5)
     *    /-13.513    , -9.743    , -6.176    , -8.416    , -7.388    /
      DATA TBD( 95, 6),TBD( 95, 7),TBD( 95, 8),TBD( 95, 9),TBD( 95,10)
     *    / 25.540    , 21.896    , 15.634    ,  4.697    ,  7.589    /
      DATA TBD( 96, 1),TBD( 96, 2),TBD( 96, 3),TBD( 96, 4),TBD( 96, 5)
     *    /-14.827    ,-10.539    , -6.498    , -7.990    , -7.485    /
      DATA TBD( 96, 6),TBD( 96, 7),TBD( 96, 8),TBD( 96, 9),TBD( 96,10)
     *    / 26.801    , 21.942    , 16.317    ,  4.908    ,  7.931    /
      DATA TBD( 97, 1),TBD( 97, 2),TBD( 97, 3),TBD( 97, 4),TBD( 97, 5)
     *    /-16.272    ,-11.641    , -6.798    , -7.683    , -7.638    /
      DATA TBD( 97, 6),TBD( 97, 7),TBD( 97, 8),TBD( 97, 9),TBD( 97,10)
     *    / 27.898    , 22.785    , 16.930    ,  5.107    ,  8.246    /
      data tbxc( 1),tbx(  1,1),tbx(  1,2),tbx(  1,3),tbx(  1,4)
     *   /'h   '   ,.493002   ,10.5109   ,.322912   ,26.1257   /
      data tbx(  1,5),tbx(  1,6),tbx(  1,7),tbx(  1,8),tbx(  1,9)
     *   / .140191   ,3.14236   ,.040810   ,57.7997   ,.003038   /
      data tbx(  1,10)/1./
      data tbxc(  2),tbx(  2,1),tbx(  2,2),tbx(  2,3),tbx(  2,4)
     *   /'h   '   ,.489918   ,20.6593   ,.262003   ,7.74039   /
      data tbx(  2,5),tbx(  2,6),tbx(  2,7),tbx(  2,8),tbx(  2,9)
     *   / .196767   ,49.5519   ,.049879   ,2.20159   ,.001305   /
      data tbx(  2,10)/1./
      data tbxc(  3),tbx(  3,1),tbx(  3,2),tbx(  3,3),tbx(  3,4)
     *   /'h-1 '   ,.897661   ,53.1368   ,.565616   ,15.1870   /
      data tbx(  3,5),tbx(  3,6),tbx(  3,7),tbx(  3,8),tbx(  3,9)
     *   / .415815   ,186.576   ,.116973   ,3.56709   ,.002389   /
      data tbx(  3,10)/1./
      data tbxc(  4),tbx(  4,1),tbx(  4,2),tbx(  4,3),tbx(  4,4)
     *   /'he  '   ,  .8734   , 9.1037   ,  .6309   , 3.3568   /
      data tbx(  4,5),tbx(  4,6),tbx(  4,7),tbx(  4,8),tbx(  4,9)
     *   /   .3112   ,22.9276   ,  .1780   ,  .9821   ,  .0064   /
      data tbx(  4,10)/1./
      data tbxc(  5),tbx(  5,1),tbx(  5,2),tbx(  5,3),tbx(  5,4)
     *   /'li  '   , 1.1282   , 3.9546   ,  .7508   , 1.0524   /
      data tbx(  5,5),tbx(  5,6),tbx(  5,7),tbx(  5,8),tbx(  5,9)
     *   /   .6175   ,85.3905   ,  .4653   ,168.261   ,  .0377   /
      data tbx(  5,10)/2./
      data tbxc(  6),tbx(  6,1),tbx(  6,2),tbx(  6,3),tbx(  6,4)
     *   /'li+1'   ,  .6968   , 4.6237   ,  .7888   , 1.9557   /
      data tbx(  6,5),tbx(  6,6),tbx(  6,7),tbx(  6,8),tbx(  6,9)
     *   /   .3414   ,  .6316   ,  .1563   ,10.0953   ,  .0167   /
      data tbx(  6,10)/2./
      data tbxc(  7),tbx(  7,1),tbx(  7,2),tbx(  7,3),tbx(  7,4)
     *   /'be  '   , 1.5919   ,43.6427   , 1.1278   , 1.8623   /
      data tbx(  7,5),tbx(  7,6),tbx(  7,7),tbx(  7,8),tbx(  7,9)
     *   /   .5391   ,103.483   ,  .7029   ,  .5420   ,  .0385   /
      data tbx(  7,10)/3./
      data tbxc(  8),tbx(  8,1),tbx(  8,2),tbx(  8,3),tbx(  8,4)
     *   /'be+2'   , 6.2603   ,  .0027   ,  .8849   ,  .8313   /
      data tbx(  8,5),tbx(  8,6),tbx(  8,7),tbx(  8,8),tbx(  8,9)
     *   /   .7993   , 2.2758   ,  .1647   , 5.1146   ,-6.1092   /
      data tbx(  8,10)/3./
      data tbxc(  9),tbx(  9,1),tbx(  9,2),tbx(  9,3),tbx(  9,4)
     *   /'b   '   , 2.0545   ,23.2185   , 1.3326   , 1.0210   /
      data tbx(  9,5),tbx(  9,6),tbx(  9,7),tbx(  9,8),tbx(  9,9)
     *   /  1.0979   ,60.3498   ,  .7068   ,  .1403   , -.1932   /
      data tbx(  9,10)/4./
      data tbxc( 10),tbx( 10,1),tbx( 10,2),tbx( 10,3),tbx( 10,4)
     *   /'c   '   , 2.3100   ,20.8439   , 1.0200   ,10.2075   /
      data tbx( 10,5),tbx( 10,6),tbx( 10,7),tbx( 10,8),tbx( 10,9)
     *   /  1.5886   ,  .5687   ,  .8650   ,51.6512   ,  .2156   /
      data tbx( 10,10)/5./
      data tbxc( 11),tbx( 11,1),tbx( 11,2),tbx( 11,3),tbx( 11,4)
     *   /'cval'   ,2.26069   ,22.6907   ,1.56165   ,.656665   /
      data tbx( 11,5),tbx( 11,6),tbx( 11,7),tbx( 11,8),tbx( 11,9)
     *   / 1.05075   ,9.75618   ,.839259   ,55.5949   ,.286977   /
      data tbx( 11,10)/5./
      data tbxc( 12),tbx( 12,1),tbx( 12,2),tbx( 12,3),tbx( 12,4)
     *   /'n   '   ,12.2126   ,  .0057   , 3.1322   , 9.8933   /
      data tbx( 12,5),tbx( 12,6),tbx( 12,7),tbx( 12,8),tbx( 12,9)
     *   /  2.0125   ,28.9975   , 1.1663   ,  .5826   ,-11.529   /
      data tbx( 12,10)/6./
      data tbxc( 13),tbx( 13,1),tbx( 13,2),tbx( 13,3),tbx( 13,4)
     *   /'o   '   , 3.0485   ,13.2771   , 2.2868   , 5.7011   /
      data tbx( 13,5),tbx( 13,6),tbx( 13,7),tbx( 13,8),tbx( 13,9)
     *   /  1.5463   ,  .3239   ,  .8670   ,32.9089   ,  .2508   /
      data tbx( 13,10)/7./
      data tbxc( 14),tbx( 14,1),tbx( 14,2),tbx( 14,3),tbx( 14,4)
     *   /'o-1 '   ,4.19160   ,12.8573   ,1.63969   ,4.17236   /
      data tbx( 14,5),tbx( 14,6),tbx( 14,7),tbx( 14,8),tbx( 14,9)
     *   / 1.52673   ,47.0179   ,-20.307   ,-.01404   ,21.9412   /
      data tbx( 14,10)/7./
      data tbxc(213),tbx(213,1),tbx(213,2),tbx(213,3),tbx(213,4)
     *   /'o-2 '   ,4.758   ,7.831   ,3.637   ,30.05   /
      data tbx(213,5),tbx(213,6),tbx(213,7),tbx(213,8),tbx(213,9)
     *   / 0.000   ,0.000   ,0.0000   ,0.000   ,1.594   /
      data tbx(213,10)/7./
      data tbxc( 15),tbx( 15,1),tbx( 15,2),tbx( 15,3),tbx( 15,4)
     *   /'f   '   , 3.5392   ,10.2825   , 2.6412   , 4.2944   /
      data tbx( 15,5),tbx( 15,6),tbx( 15,7),tbx( 15,8),tbx( 15,9)
     *   /  1.5170   ,  .2615   , 1.0243   ,26.1476   ,  .2776   /
      data tbx( 15,10)/8./
      data tbxc( 16),tbx( 16,1),tbx( 16,2),tbx( 16,3),tbx( 16,4)
     *   /'f-1 '   ,3.63220   ,5.27756   ,3.51057   ,14.7353   /
      data tbx( 16,5),tbx( 16,6),tbx( 16,7),tbx( 16,8),tbx( 16,9)
     *   / 1.26064   ,.442258   ,.940706   ,47.3437   ,.653396   /
      data tbx( 16,10)/8./
      data tbxc( 17),tbx( 17,1),tbx( 17,2),tbx( 17,3),tbx( 17,4)
     *   /'ne  '   , 3.9553   , 8.4042   , 3.1125   , 3.4262   /
      data tbx( 17,5),tbx( 17,6),tbx( 17,7),tbx( 17,8),tbx( 17,9)
     *   /  1.4546   ,  .2306   , 1.1251   ,21.7184   ,  .3515   /
      data tbx( 17,10)/9./
      data tbxc( 18),tbx( 18,1),tbx( 18,2),tbx( 18,3),tbx( 18,4)
     *   /'na  '   , 4.7626   , 3.2850   , 3.1736   , 8.8422   /
      data tbx( 18,5),tbx( 18,6),tbx( 18,7),tbx( 18,8),tbx( 18,9)
     *   /  1.2674   ,  .3136   , 1.1128   ,129.424   ,  .6760   /
      data tbx( 18,10)/10./
      data tbxc( 19),tbx( 19,1),tbx( 19,2),tbx( 19,3),tbx( 19,4)
     *   /'na+1'   , 3.2565   , 2.6671   , 3.9362   , 6.1153   /
      data tbx( 19,5),tbx( 19,6),tbx( 19,7),tbx( 19,8),tbx( 19,9)
     *   /  1.3998   ,  .2001   , 1.0032   ,14.0390   ,  .4040   /
      data tbx( 19,10)/10./
      data tbxc( 20),tbx( 20,1),tbx( 20,2),tbx( 20,3),tbx( 20,4)
     *   /'mg  '   , 5.4204   , 2.8275   , 2.1735   ,79.2611   /
      data tbx( 20,5),tbx( 20,6),tbx( 20,7),tbx( 20,8),tbx( 20,9)
     *   /  1.2269   ,  .3808   , 2.3073   , 7.1937   ,  .8584   /
      data tbx( 20,10)/11./
      data tbxc( 21),tbx( 21,1),tbx( 21,2),tbx( 21,3),tbx( 21,4)
     *   /'mg+2'   , 3.4988   , 2.1676   , 3.8378   , 4.7542   /
      data tbx( 21,5),tbx( 21,6),tbx( 21,7),tbx( 21,8),tbx( 21,9)
     *   /  1.3284   ,  .1850   ,  .8497   ,10.1411   ,  .4853   /
      data tbx( 21,10)/11./
      data tbxc( 22),tbx( 22,1),tbx( 22,2),tbx( 22,3),tbx( 22,4)
     *   /'al  '   , 6.4202   , 3.0387   , 1.9002   ,  .7426   /
      data tbx( 22,5),tbx( 22,6),tbx( 22,7),tbx( 22,8),tbx( 22,9)
     *   /  1.5936   ,31.5472   , 1.9646   ,85.0886   , 1.1151   /
      data tbx( 22,10)/12./
      data tbxc( 23),tbx( 23,1),tbx( 23,2),tbx( 23,3),tbx( 23,4)
     *   /'al+3'   ,4.17448   ,1.93816   ,3.38760   ,4.14553   /
      data tbx( 23,5),tbx( 23,6),tbx( 23,7),tbx( 23,8),tbx( 23,9)
     *   / 1.20296   ,.228753   ,.528137   ,8.28524   ,.706786   /
      data tbx( 23,10)/12./
      data tbxc( 24),tbx( 24,1),tbx( 24,2),tbx( 24,3),tbx( 24,4)
     *   /'si  '   , 6.2915   , 2.4386   , 3.0353   ,32.3337   /
      data tbx( 24,5),tbx( 24,6),tbx( 24,7),tbx( 24,8),tbx( 24,9)
     *   /  1.9891   ,  .6785   , 1.5410   ,81.6937   , 1.1407   /
      data tbx( 24,10)/13./
      data tbxc( 25),tbx( 25,1),tbx( 25,2),tbx( 25,3),tbx( 25,4)
     *   /'siv '   ,5.66269   ,2.66520   ,3.07164   ,38.6634   /
      data tbx( 25,5),tbx( 25,6),tbx( 25,7),tbx( 25,8),tbx( 25,9)
     *   / 2.62446   ,.916946   ,1.39320   ,93.5458   ,1.24707   /
      data tbx( 25,10)/13./
      data tbxc( 26),tbx( 26,1),tbx( 26,2),tbx( 26,3),tbx( 26,4)
     *   /'si+4'   ,4.43918   ,1.64167   ,3.20345   ,3.43757   /
      data tbx( 26,5),tbx( 26,6),tbx( 26,7),tbx( 26,8),tbx( 26,9)
     *   / 1.19453   ,.214900   ,.416530   ,6.65365   ,.746297   /
      data tbx( 26,10)/13./
      data tbxc( 27),tbx( 27,1),tbx( 27,2),tbx( 27,3),tbx( 27,4)
     *   /'s   '   , 6.9053   , 1.4679   , 5.2034   ,22.2151   /
      data tbx( 27,5),tbx( 27,6),tbx( 27,7),tbx( 27,8),tbx( 27,9)
     *   /  1.4379   ,  .2536   , 1.5863   ,56.1720   ,  .8669   /
      data tbx( 27,10)/15./
      data tbxc( 28),tbx( 28,1),tbx( 28,2),tbx( 28,3),tbx( 28,4)
     *   /'p   '   , 6.4345   , 1.9067   , 4.1791   ,27.1570   /
      data tbx( 28,5),tbx( 28,6),tbx( 28,7),tbx( 28,8),tbx( 28,9)
     *   /  1.7800   ,  .5260   , 1.4908   ,68.1645   , 1.1149   /
      data tbx( 28,10)/14./
      data tbxc( 29),tbx( 29,1),tbx( 29,2),tbx( 29,3),tbx( 29,4)
     *   /'cl  '   ,11.4604   ,  .0104   , 7.1964   , 1.1662   /
      data tbx( 29,5),tbx( 29,6),tbx( 29,7),tbx( 29,8),tbx( 29,9)
     *   /  6.2556   ,18.5194   , 1.6455   ,47.7784   ,-9.5574   /
      data tbx( 29,10)/16./
      data tbxc( 30),tbx( 30,1),tbx( 30,2),tbx( 30,3),tbx( 30,4)
     *   /'cl-1'   ,18.2915   ,  .0066   , 7.2084   , 1.1717   /
      data tbx( 30,5),tbx( 30,6),tbx( 30,7),tbx( 30,8),tbx( 30,9)
     *   /  6.5337   ,19.5424   , 2.3386   ,60.4486   ,-16.378   /
      data tbx( 30,10)/16./
      data tbxc( 31),tbx( 31,1),tbx( 31,2),tbx( 31,3),tbx( 31,4)
     *   /'ar  '   , 7.4845   ,  .9072   , 6.7723   ,14.8407   /
      data tbx( 31,5),tbx( 31,6),tbx( 31,7),tbx( 31,8),tbx( 31,9)
     *   /   .6539   ,43.8983   , 1.6442   ,33.3929   , 1.4445   /
      data tbx( 31,10)/17./
      data tbxc( 32),tbx( 32,1),tbx( 32,2),tbx( 32,3),tbx( 32,4)
     *   /'k   '   , 8.2186   ,12.7949   , 7.4398   ,  .7748   /
      data tbx( 32,5),tbx( 32,6),tbx( 32,7),tbx( 32,8),tbx( 32,9)
     *   /  1.0519   ,213.187   ,  .8659   ,41.6841   , 1.4228   /
      data tbx( 32,10)/18./
      data tbxc( 33),tbx( 33,1),tbx( 33,2),tbx( 33,3),tbx( 33,4)
     *   /'k+1 '   , 7.9578   ,12.6331   , 7.4917   ,  .7674   /
      data tbx( 33,5),tbx( 33,6),tbx( 33,7),tbx( 33,8),tbx( 33,9)
     *   /  6.3590   , -.0020   , 1.1915   ,31.9128   ,-4.9978   /
      data tbx( 33,10)/18./
      data tbxc( 34),tbx( 34,1),tbx( 34,2),tbx( 34,3),tbx( 34,4)
     *   /'ca  '   , 8.6266   ,10.4421   , 7.3873   ,  .6599   /
      data tbx( 34,5),tbx( 34,6),tbx( 34,7),tbx( 34,8),tbx( 34,9)
     *   /  1.5899   ,85.7484   , 1.0211   ,178.437   , 1.3751   /
      data tbx( 34,10)/19./
      data tbxc( 35),tbx( 35,1),tbx( 35,2),tbx( 35,3),tbx( 35,4)
     *   /'ca+2'   ,15.6348   , -.0074   , 7.9518   ,  .6089   /
      data tbx( 35,5),tbx( 35,6),tbx( 35,7),tbx( 35,8),tbx( 35,9)
     *   /  8.4372   ,10.3116   ,  .8537   ,25.9905   ,-14.875   /
      data tbx( 35,10)/19./
      data tbxc( 36),tbx( 36,1),tbx( 36,2),tbx( 36,3),tbx( 36,4)
     *   /'sc  '   , 9.1890   , 9.0213   , 7.3679   ,  .5729   /
      data tbx( 36,5),tbx( 36,6),tbx( 36,7),tbx( 36,8),tbx( 36,9)
     *   /  1.6409   ,136.108   , 1.4680   ,51.3531   , 1.3329   /
      data tbx( 36,10)/20./
      data tbxc( 37),tbx( 37,1),tbx( 37,2),tbx( 37,3),tbx( 37,4)
     *   /'sc+3'   ,13.4008   ,.298540   ,8.02730   ,7.96290   /
      data tbx( 37,5),tbx( 37,6),tbx( 37,7),tbx( 37,8),tbx( 37,9)
     *   / 1.65943   ,-.28604   ,1.57936   ,16.0662   ,-6.6667   /
      data tbx( 37,10)/20./
      data tbxc( 38),tbx( 38,1),tbx( 38,2),tbx( 38,3),tbx( 38,4)
     *   /'ti  '   , 9.7595   , 7.8508   , 7.3558   ,  .5000   /
      data tbx( 38,5),tbx( 38,6),tbx( 38,7),tbx( 38,8),tbx( 38,9)
     *   /  1.6991   ,35.6338   , 1.9021   ,116.105   , 1.2807   /
      data tbx( 38,10)/21./
      data tbxc( 39),tbx( 39,1),tbx( 39,2),tbx( 39,3),tbx( 39,4)
     *   /'ti+2'   ,9.11423   ,7.52430   ,7.62174   ,.457585   /
      data tbx( 39,5),tbx( 39,6),tbx( 39,7),tbx( 39,8),tbx( 39,9)
     *   / 2.27930   ,19.5361   ,.087899   ,61.6558   ,.897155   /
      data tbx( 39,10)/21./
      data tbxc( 40),tbx( 40,1),tbx( 40,2),tbx( 40,3),tbx( 40,4)
     *   /'ti+3'   ,17.7344   ,.220610   ,8.73816   ,7.04716   /
      data tbx( 40,5),tbx( 40,6),tbx( 40,7),tbx( 40,8),tbx( 40,9)
     *   / 5.25691   ,-.15762   ,1.92134   ,15.9768   ,-14.652   /
      data tbx( 40,10)/21./
      data tbxc( 41),tbx( 41,1),tbx( 41,2),tbx( 41,3),tbx( 41,4)
     *   /'ti+4'   ,19.5114   ,.178847   ,8.23473   ,6.67018   /
      data tbx( 41,5),tbx( 41,6),tbx( 41,7),tbx( 41,8),tbx( 41,9)
     *   / 2.01341   ,-.29263   ,1.52080   ,12.9464   ,-13.280   /
      data tbx( 41,10)/21./
      data tbxc( 42),tbx( 42,1),tbx( 42,2),tbx( 42,3),tbx( 42,4)
     *   /'v   '   ,10.2971   , 6.8657   , 7.3511   ,  .4385   /
      data tbx( 42,5),tbx( 42,6),tbx( 42,7),tbx( 42,8),tbx( 42,9)
     *   /  2.0703   ,26.8938   , 2.0571   ,102.478   , 1.2199   /
      data tbx( 42,10)/22./
      data tbxc( 43),tbx( 43,1),tbx( 43,2),tbx( 43,3),tbx( 43,4)
     *   /'v+2 '   ,10.1060   , 6.8818   , 7.3541   ,  .4409   /
      data tbx( 43,5),tbx( 43,6),tbx( 43,7),tbx( 43,8),tbx( 43,9)
     *   /  2.2884   ,20.3004   ,  .0223   ,115.122   , 1.2298   /
      data tbx( 43,10)/22./
      data tbxc( 44),tbx( 44,1),tbx( 44,2),tbx( 44,3),tbx( 44,4)
     *   /'v+3 '   ,9.43141   ,6.39535   ,7.74190   ,.383349   /
      data tbx( 44,5),tbx( 44,6),tbx( 44,7),tbx( 44,8),tbx( 44,9)
     *   / 2.15343   ,15.1908   ,.016865   ,63.9690   ,.656565   /
      data tbx( 44,10)/22./
      data tbxc( 45),tbx( 45,1),tbx( 45,2),tbx( 45,3),tbx( 45,4)
     *   /'v+5 '   ,15.6887   ,.679003   ,8.14208   ,5.40135   /
      data tbx( 45,5),tbx( 45,6),tbx( 45,7),tbx( 45,8),tbx( 45,9)
     *   / 2.03081   ,9.97278   ,-9.5760   ,.940464   ,1.71430   /
      data tbx( 45,10)/22./
      data tbxc( 46),tbx( 46,1),tbx( 46,2),tbx( 46,3),tbx( 46,4)
     *   /'cr  '   ,10.6406   , 6.1038   , 7.3537   ,  .3920   /
      data tbx( 46,5),tbx( 46,6),tbx( 46,7),tbx( 46,8),tbx( 46,9)
     *   /  3.3240   ,20.2626   , 1.4922   ,98.7399   , 1.1832   /
      data tbx( 46,10)/23./
      data tbxc( 47),tbx( 47,1),tbx( 47,2),tbx( 47,3),tbx( 47,4)
     *   /'cr+2'   ,9.54034   ,5.66078   ,7.75090   ,.344261   /
      data tbx( 47,5),tbx( 47,6),tbx( 47,7),tbx( 47,8),tbx( 47,9)
     *   / 3.58274   ,13.3075   ,.509107   ,32.4224   ,.616898   /
      data tbx( 47,10)/23./
      data tbxc( 48),tbx( 48,1),tbx( 48,2),tbx( 48,3),tbx( 48,4)
     *   /'cr+3'   ,9.68090   ,5.59463   ,7.81136   ,.334393   /
      data tbx( 48,5),tbx( 48,6),tbx( 48,7),tbx( 48,8),tbx( 48,9)
     *   / 2.87603   ,12.8288   ,.113575   ,32.8761   ,.518275   /
      data tbx( 48,10)/23./
      data tbxc( 49),tbx( 49,1),tbx( 49,2),tbx( 49,3),tbx( 49,4)
     *   /'mn  '   ,11.2819   , 5.3409   , 7.3573   ,  .3432   /
      data tbx( 49,5),tbx( 49,6),tbx( 49,7),tbx( 49,8),tbx( 49,9)
     *   /  3.0193   ,17.8674   , 2.2441   ,83.7543   , 1.0896   /
      data tbx( 49,10)/24./
      data tbxc( 50),tbx( 50,1),tbx( 50,2),tbx( 50,3),tbx( 50,4)
     *   /'mn+2'   ,10.8061   , 5.2796   , 7.3620   ,  .3435   /
      data tbx( 50,5),tbx( 50,6),tbx( 50,7),tbx( 50,8),tbx( 50,9)
     *   /  3.5268   ,14.3430   ,  .2184   ,41.3235   , 1.0874   /
      data tbx( 50,10)/24./
      data tbxc( 51),tbx( 51,1),tbx( 51,2),tbx( 51,3),tbx( 51,4)
     *   /'mn+3'   ,9.84521   ,4.91797   ,7.87194   ,.294393   /
      data tbx( 51,5),tbx( 51,6),tbx( 51,7),tbx( 51,8),tbx( 51,9)
     *   / 3.56531   ,10.8171   ,.323613   ,24.1281   ,.393974   /
      data tbx( 51,10)/24./
      data tbxc( 52),tbx( 52,1),tbx( 52,2),tbx( 52,3),tbx( 52,4)
     *   /'mn+4'   ,9.96253   ,4.84850   ,7.97057   ,.283303   /
      data tbx( 52,5),tbx( 52,6),tbx( 52,7),tbx( 52,8),tbx( 52,9)
     *   / 2.76067   ,10.4852   ,.054447   ,27.5730   ,.251877   /
      data tbx( 52,10)/24./
      data tbxc( 53),tbx( 53,1),tbx( 53,2),tbx( 53,3),tbx( 53,4)
     *   /'fe  '   ,11.7695   , 4.7611   , 7.3573   ,  .3072   /
      data tbx( 53,5),tbx( 53,6),tbx( 53,7),tbx( 53,8),tbx( 53,9)
     *   /  3.5222   ,15.3535   , 2.3045   ,76.8805   , 1.0369   /
      data tbx( 53,10)/25./
      data tbxc( 54),tbx( 54,1),tbx( 54,2),tbx( 54,3),tbx( 54,4)
     *   /'fe+2'   ,11.0424   , 4.6538   , 7.3740   ,  .3053   /
      data tbx( 54,5),tbx( 54,6),tbx( 54,7),tbx( 54,8),tbx( 54,9)
     *   /  4.1346   ,12.0546   ,  .4399   ,31.2809   , 1.0097   /
      data tbx( 54,10)/25./
      data tbxc( 55),tbx( 55,1),tbx( 55,2),tbx( 55,3),tbx( 55,4)
     *   /'fe+3'   ,11.1764   , 4.6147   , 7.3863   ,  .3005   /
      data tbx( 55,5),tbx( 55,6),tbx( 55,7),tbx( 55,8),tbx( 55,9)
     *   /  3.3948   ,11.6729   ,  .0724   ,38.5566   ,  .9707   /
      data tbx( 55,10)/25./
      data tbxc( 56),tbx( 56,1),tbx( 56,2),tbx( 56,3),tbx( 56,4)
     *   /'co  '   ,12.2841   , 4.2791   , 7.3409   ,  .2784   /
      data tbx( 56,5),tbx( 56,6),tbx( 56,7),tbx( 56,8),tbx( 56,9)
     *   /  4.0034   ,13.5359   , 2.3488   ,71.1692   , 1.0118   /
      data tbx( 56,10)/26./
      data tbxc( 57),tbx( 57,1),tbx( 57,2),tbx( 57,3),tbx( 57,4)
     *   /'co+2'   ,11.2296   , 4.1231   , 7.3883   ,  .2726   /
      data tbx( 57,5),tbx( 57,6),tbx( 57,7),tbx( 57,8),tbx( 57,9)
     *   /  4.7393   ,10.2443   ,  .7108   ,25.6466   ,  .9324   /
      data tbx( 57,10)/26./
      data tbxc( 58),tbx( 58,1),tbx( 58,2),tbx( 58,3),tbx( 58,4)
     *   /'co+3'   ,10.3380   ,3.90969   ,7.88173   ,.238668   /
      data tbx( 58,5),tbx( 58,6),tbx( 58,7),tbx( 58,8),tbx( 58,9)
     *   / 4.76795   ,8.35583   ,.725591   ,18.3491   ,.286667   /
      data tbx( 58,10)/26./
      data tbxc( 59),tbx( 59,1),tbx( 59,2),tbx( 59,3),tbx( 59,4)
     *   /'ni  '   ,12.8376   , 3.8785   , 7.2920   ,  .2565   /
      data tbx( 59,5),tbx( 59,6),tbx( 59,7),tbx( 59,8),tbx( 59,9)
     *   /  4.4438   ,12.1763   , 2.3800   ,66.3421   , 1.0341   /
      data tbx( 59,10)/27./
      data tbxc( 60),tbx( 60,1),tbx( 60,2),tbx( 60,3),tbx( 60,4)
     *   /'ni+2'   ,11.4166   , 3.6766   , 7.4005   ,  .2449   /
      data tbx( 60,5),tbx( 60,6),tbx( 60,7),tbx( 60,8),tbx( 60,9)
     *   /  5.3442   , 8.8730   ,  .9773   ,22.1626   ,  .8614   /
      data tbx( 60,10)/27./
      data tbxc( 61),tbx( 61,1),tbx( 61,2),tbx( 61,3),tbx( 61,4)
     *   /'ni+3'   ,10.7806   ,3.54770   ,7.75868   ,.223140   /
      data tbx( 61,5),tbx( 61,6),tbx( 61,7),tbx( 61,8),tbx( 61,9)
     *   / 5.22746   ,7.64468   ,.847114   ,16.9673   ,.386044   /
      data tbx( 61,10)/27./
      data tbxc( 62),tbx( 62,1),tbx( 62,2),tbx( 62,3),tbx( 62,4)
     *   /'cu  '   ,13.3380   , 3.5828   , 7.1676   ,  .2470   /
      data tbx( 62,5),tbx( 62,6),tbx( 62,7),tbx( 62,8),tbx( 62,9)
     *   /  5.6158   ,11.3966   , 1.6735   ,64.8126   , 1.1910   /
      data tbx( 62,10)/28./
      data tbxc( 63),tbx( 63,1),tbx( 63,2),tbx( 63,3),tbx( 63,4)
     *   /'cu+1'   ,11.9475   , 3.3669   , 7.3573   ,  .2274   /
      data tbx( 63,5),tbx( 63,6),tbx( 63,7),tbx( 63,8),tbx( 63,9)
     *   /  6.2455   , 8.6625   , 1.5578   ,25.8487   ,  .8900   /
      data tbx( 63,10)/28./
      data tbxc( 64),tbx( 64,1),tbx( 64,2),tbx( 64,3),tbx( 64,4)
     *   /'cu+2'   ,11.8168   ,3.37484   ,7.11181   ,.244078   /
      data tbx( 64,5),tbx( 64,6),tbx( 64,7),tbx( 64,8),tbx( 64,9)
     *   / 5.78135   ,7.98760   ,1.14523   ,19.8970   ,1.14431   /
      data tbx( 64,10)/28./
      data tbxc( 65),tbx( 65,1),tbx( 65,2),tbx( 65,3),tbx( 65,4)
     *   /'zn  '   ,14.0743   , 3.2655   , 7.0318   ,  .2333   /
      data tbx( 65,5),tbx( 65,6),tbx( 65,7),tbx( 65,8),tbx( 65,9)
     *   /  5.1652   ,10.3163   , 2.4100   ,58.7097   , 1.3041   /
      data tbx( 65,10)/29./
      data tbxc( 66),tbx( 66,1),tbx( 66,2),tbx( 66,3),tbx( 66,4)
     *   /'zn+2'   ,11.9719   , 2.9946   , 7.3862   ,  .2031   /
      data tbx( 66,5),tbx( 66,6),tbx( 66,7),tbx( 66,8),tbx( 66,9)
     *   /  6.4668   , 7.0826   , 1.3940   ,18.0995   ,  .7807   /
      data tbx( 66,10)/29./
      data tbxc( 67),tbx( 67,1),tbx( 67,2),tbx( 67,3),tbx( 67,4)
     *   /'ga  '   ,15.2354   , 3.0669   , 6.7006   ,  .2412   /
      data tbx( 67,5),tbx( 67,6),tbx( 67,7),tbx( 67,8),tbx( 67,9)
     *   /  4.3591   ,10.7805   , 2.9623   ,61.4135   , 1.7189   /
      data tbx( 67,10)/30./
      data tbxc( 68),tbx( 68,1),tbx( 68,2),tbx( 68,3),tbx( 68,4)
     *   /'ga+3'   ,12.6920   ,2.81262   ,6.69883   ,.227890   /
      data tbx( 68,5),tbx( 68,6),tbx( 68,7),tbx( 68,8),tbx( 68,9)
     *   / 6.06692   ,6.36441   ,1.00660   ,14.4122   ,1.53545   /
      data tbx( 68,10)/30./
      data tbxc( 69),tbx( 69,1),tbx( 69,2),tbx( 69,3),tbx( 69,4)
     *   /'ge  '   ,16.0816   , 2.8509   , 6.3747   ,  .2516   /
      data tbx( 69,5),tbx( 69,6),tbx( 69,7),tbx( 69,8),tbx( 69,9)
     *   /  3.7068   ,11.4468   , 3.6830   ,54.7625   , 2.1313   /
      data tbx( 69,10)/31./
      data tbxc( 70),tbx( 70,1),tbx( 70,2),tbx( 70,3),tbx( 70,4)
     *   /'ge+4'   ,12.9172   ,2.53718   ,6.70003   ,.205855   /
      data tbx( 70,5),tbx( 70,6),tbx( 70,7),tbx( 70,8),tbx( 70,9)
     *   / 6.06791   ,5.47913   ,.859041   ,11.6030   ,1.45572   /
      data tbx( 70,10)/31./
      data tbxc( 71),tbx( 71,1),tbx( 71,2),tbx( 71,3),tbx( 71,4)
     *   /'as  '   ,16.6723   , 2.6345   , 6.0701   ,  .2647   /
      data tbx( 71,5),tbx( 71,6),tbx( 71,7),tbx( 71,8),tbx( 71,9)
     *   /  3.4313   ,12.9479   , 4.2779   ,47.7972   , 2.5310   /
      data tbx( 71,10)/32./
      data tbxc( 72),tbx( 72,1),tbx( 72,2),tbx( 72,3),tbx( 72,4)
     *   /'se  '   ,17.0006   , 2.4098   , 5.8196   ,  .2726   /
      data tbx( 72,5),tbx( 72,6),tbx( 72,7),tbx( 72,8),tbx( 72,9)
     *   /  3.9731   ,15.2372   , 4.3543   ,43.8163   , 2.8409   /
      data tbx( 72,10)/33./
      data tbxc( 73),tbx( 73,1),tbx( 73,2),tbx( 73,3),tbx( 73,4)
     *   /'br  '   ,17.1789   , 2.1723   , 5.2358   ,16.5796   /
      data tbx( 73,5),tbx( 73,6),tbx( 73,7),tbx( 73,8),tbx( 73,9)
     *   /  5.6377   ,  .2609   , 3.9851   ,41.4328   , 2.9557   /
      data tbx( 73,10)/34./
      data tbxc( 74),tbx( 74,1),tbx( 74,2),tbx( 74,3),tbx( 74,4)
     *   /'br-1'   ,17.1718   , 2.2059   , 6.3338   ,19.3345   /
      data tbx( 74,5),tbx( 74,6),tbx( 74,7),tbx( 74,8),tbx( 74,9)
     *   /  5.5754   ,  .2871   , 3.7272   ,58.1535   , 3.1776   /
      data tbx( 74,10)/34./
      data tbxc( 75),tbx( 75,1),tbx( 75,2),tbx( 75,3),tbx( 75,4)
     *   /'kr  '   ,17.3555   , 1.9384   , 6.7286   ,16.5623   /
      data tbx( 75,5),tbx( 75,6),tbx( 75,7),tbx( 75,8),tbx( 75,9)
     *   /  5.5493   ,  .2261   , 3.5375   ,39.3972   , 2.8250   /
      data tbx( 75,10)/35./
      data tbxc( 76),tbx( 76,1),tbx( 76,2),tbx( 76,3),tbx( 76,4)
     *   /'rb  '   ,17.1784   , 1.7888   , 9.6435   ,17.3151   /
      data tbx( 76,5),tbx( 76,6),tbx( 76,7),tbx( 76,8),tbx( 76,9)
     *   /  5.1399   ,  .2748   , 1.5292   ,164.934   , 3.4873   /
      data tbx( 76,10)/36./
      data tbxc( 77),tbx( 77,1),tbx( 77,2),tbx( 77,3),tbx( 77,4)
     *   /'rb+1'   ,17.5816   , 1.7139   , 7.6598   ,14.7957   /
      data tbx( 77,5),tbx( 77,6),tbx( 77,7),tbx( 77,8),tbx( 77,9)
     *   /  5.8981   ,  .1603   , 2.7817   ,31.2087   , 2.0782   /
      data tbx( 77,10)/36./
      data tbxc( 78),tbx( 78,1),tbx( 78,2),tbx( 78,3),tbx( 78,4)
     *   /'sr  '   ,17.5663   , 1.5564   , 9.8184   ,14.0988   /
      data tbx( 78,5),tbx( 78,6),tbx( 78,7),tbx( 78,8),tbx( 78,9)
     *   /  5.4220   ,  .1664   , 2.6694   ,132.376   , 2.5064   /
      data tbx( 78,10)/37./
      data tbxc( 79),tbx( 79,1),tbx( 79,2),tbx( 79,3),tbx( 79,4)
     *   /'sr+2'   ,18.0874   , 1.4907   , 8.1373   ,12.6963   /
      data tbx( 79,5),tbx( 79,6),tbx( 79,7),tbx( 79,8),tbx( 79,9)
     *   /  2.5654   ,24.5651   ,-34.193   , -.0138   ,41.4025   /
      data tbx( 79,10)/37./
      data tbxc( 80),tbx( 80,1),tbx( 80,2),tbx( 80,3),tbx( 80,4)
     *   /'y   '   ,17.7760   ,1.40290   ,10.2946   ,12.8006   /
      data tbx( 80,5),tbx( 80,6),tbx( 80,7),tbx( 80,8),tbx( 80,9)
     *   / 5.72629   ,.125599   ,3.26588   ,104.354   ,1.91213   /
      data tbx( 80,10)/38./
      data tbxc( 81),tbx( 81,1),tbx( 81,2),tbx( 81,3),tbx( 81,4)
     *   /'y+3 '   ,17.9268   ,1.35417   ,9.15310   ,11.2145   /
      data tbx( 81,5),tbx( 81,6),tbx( 81,7),tbx( 81,8),tbx( 81,9)
     *   / 1.76795   ,22.6599   ,-33.108   ,-.01319   ,40.2602   /
      data tbx( 81,10)/38./
      data tbxc( 82),tbx( 82,1),tbx( 82,2),tbx( 82,3),tbx( 82,4)
     *   /'zr  '   ,17.8765   ,1.27618   ,10.9480   ,11.9160   /
      data tbx( 82,5),tbx( 82,6),tbx( 82,7),tbx( 82,8),tbx( 82,9)
     *   / 5.41732   ,.117622   ,3.65721   ,87.6627   ,2.06929   /
      data tbx( 82,10)/39./
      data tbxc( 83),tbx( 83,1),tbx( 83,2),tbx( 83,3),tbx( 83,4)
     *   /'zr+4'   ,18.1668   ,1.21480   ,10.0562   ,10.1483   /
      data tbx( 83,5),tbx( 83,6),tbx( 83,7),tbx( 83,8),tbx( 83,9)
     *   / 1.01118   ,21.6054   ,-2.6479   ,-.10276   ,9.41454   /
      data tbx( 83,10)/39./
      data tbxc( 84),tbx( 84,1),tbx( 84,2),tbx( 84,3),tbx( 84,4)
     *   /'nb  '   ,17.6142   ,1.18865   ,12.0144   ,11.7660   /
      data tbx( 84,5),tbx( 84,6),tbx( 84,7),tbx( 84,8),tbx( 84,9)
     *   / 4.04183   ,.204785   ,3.53346   ,69.7957   ,3.75591   /
      data tbx( 84,10)/40./
      data tbxc( 85),tbx( 85,1),tbx( 85,2),tbx( 85,3),tbx( 85,4)
     *   /'nb+3'   ,19.8812   ,.019175   ,18.0653   ,1.13305   /
      data tbx( 85,5),tbx( 85,6),tbx( 85,7),tbx( 85,8),tbx( 85,9)
     *   / 11.0177   ,10.1621   ,1.94715   ,28.3389   ,-12.912   /
      data tbx( 85,10)/40./
      data tbxc( 86),tbx( 86,1),tbx( 86,2),tbx( 86,3),tbx( 86,4)
     *   /'nb+5'   ,17.9163   ,1.12446   ,13.3417   ,.028781   /
      data tbx( 86,5),tbx( 86,6),tbx( 86,7),tbx( 86,8),tbx( 86,9)
     *   / 10.7990   ,9.28206   ,.337905   ,25.7228   ,-6.3934   /
      data tbx( 86,10)/40./
      data tbxc( 87),tbx( 87,1),tbx( 87,2),tbx( 87,3),tbx( 87,4)
     *   /'mo  '   , 3.7025   ,  .2772   ,17.2356   , 1.0958   /
      data tbx( 87,5),tbx( 87,6),tbx( 87,7),tbx( 87,8),tbx( 87,9)
     *   / 12.8876   ,11.0040   , 3.7429   ,61.6584   , 4.3875   /
      data tbx( 87,10)/41./
      data tbxc( 88),tbx( 88,1),tbx( 88,2),tbx( 88,3),tbx( 88,4)
     *   /'mo+3'   ,21.1664   ,.014734   ,18.2017   ,1.03031   /
      data tbx( 88,5),tbx( 88,6),tbx( 88,7),tbx( 88,8),tbx( 88,9)
     *   / 11.7423   ,9.53659   ,2.30951   ,26.6307   ,-14.421   /
      data tbx( 88,10)/41./
      data tbxc( 89),tbx( 89,1),tbx( 89,2),tbx( 89,3),tbx( 89,4)
     *   /'mo+5'   ,21.0149   ,.014345   ,18.0992   ,1.02238   /
      data tbx( 89,5),tbx( 89,6),tbx( 89,7),tbx( 89,8),tbx( 89,9)
     *   / 11.4632   ,8.78809   ,.740625   ,23.3452   ,-14.316   /
      data tbx( 89,10)/41./
      data tbxc( 90),tbx( 90,1),tbx( 90,2),tbx( 90,3),tbx( 90,4)
     *   /'mo+6'   ,17.8871   ,1.03649   ,11.1750   ,8.48061   /
      data tbx( 90,5),tbx( 90,6),tbx( 90,7),tbx( 90,8),tbx( 90,9)
     *   / 6.57891   ,.058881   ,.0000   ,.0000    ,.344941   /
      data tbx( 90,10)/41./
      data tbxc( 91),tbx( 91,1),tbx( 91,2),tbx( 91,3),tbx( 91,4)
     *   /'tc  '   ,19.1301   ,.864132   ,11.0948   ,8.14487   /
      data tbx( 91,5),tbx( 91,6),tbx( 91,7),tbx( 91,8),tbx( 91,9)
     *   / 4.64901   ,21.5707   ,2.71263   ,86.8472   ,5.40428   /
      data tbx( 91,10)/42./
      data tbxc( 92),tbx( 92,1),tbx( 92,2),tbx( 92,3),tbx( 92,4)
     *   /'ru  '   ,19.2674   ,.808520   ,12.9182   ,8.43467   /
      data tbx( 92,5),tbx( 92,6),tbx( 92,7),tbx( 92,8),tbx( 92,9)
     *   / 4.86337   ,24.7997   ,1.56756   ,94.2928   ,5.37874   /
      data tbx( 92,10)/43./
      data tbxc( 93),tbx( 93,1),tbx( 93,2),tbx( 93,3),tbx( 93,4)
     *   /'ru+3'   ,18.5638   ,.847329   ,13.2885   ,8.37164   /
      data tbx( 93,5),tbx( 93,6),tbx( 93,7),tbx( 93,8),tbx( 93,9)
     *   / 9.32602   ,.017662   ,3.00964   ,22.8870   ,-3.1892   /
      data tbx( 93,10)/43./
      data tbxc( 94),tbx( 94,1),tbx( 94,2),tbx( 94,3),tbx( 94,4)
     *   /'ru+4'   ,18.5003   ,.844582   ,13.1787   ,8.12534   /
      data tbx( 94,5),tbx( 94,6),tbx( 94,7),tbx( 94,8),tbx( 94,9)
     *   / 4.71304   ,.036495   ,2.18535   ,20.8504   ,1.42357   /
      data tbx( 94,10)/43./
      data tbxc( 95),tbx( 95,1),tbx( 95,2),tbx( 95,3),tbx( 95,4)
     *   /'rh  '   ,19.2957   ,.751536   ,14.3501   ,8.21758   /
      data tbx( 95,5),tbx( 95,6),tbx( 95,7),tbx( 95,8),tbx( 95,9)
     *   / 4.73425   ,25.8749   ,1.28918   ,98.6062   ,5.32800   /
      data tbx( 95,10)/44./
      data tbxc( 96),tbx( 96,1),tbx( 96,2),tbx( 96,3),tbx( 96,4)
     *   /'rh+3'   ,18.8785   ,.764252   ,14.1259   ,7.84438   /
      data tbx( 96,5),tbx( 96,6),tbx( 96,7),tbx( 96,8),tbx( 96,9)
     *   / 3.32515   ,21.2487   ,-6.1989   ,-.01036   ,11.8678   /
      data tbx( 96,10)/44./
      data tbxc( 97),tbx( 97,1),tbx( 97,2),tbx( 97,3),tbx( 97,4)
     *   /'rh+4'   ,18.8545   ,.760825   ,13.9806   ,7.62436   /
      data tbx( 97,5),tbx( 97,6),tbx( 97,7),tbx( 97,8),tbx( 97,9)
     *   / 2.53464   ,19.3317   ,-5.6526   ,-.01020   ,11.2835   /
      data tbx( 97,10)/44./
      data tbxc( 98),tbx( 98,1),tbx( 98,2),tbx( 98,3),tbx( 98,4)
     *   /'pd  '   ,19.3319   ,.698655   ,15.5017   ,7.98929   /
      data tbx( 98,5),tbx( 98,6),tbx( 98,7),tbx( 98,8),tbx( 98,9)
     *   / 5.29537   ,25.2052   ,.605844   ,76.8986   ,5.26593   /
      data tbx( 98,10)/45./
      data tbxc( 99),tbx( 99,1),tbx( 99,2),tbx( 99,3),tbx( 99,4)
     *   /'pd+2'   ,19.1701   ,.696219   ,15.2096   ,7.55573   /
      data tbx( 99,5),tbx( 99,6),tbx( 99,7),tbx( 99,8),tbx( 99,9)
     *   / 4.32234   ,22.5057   ,.0000   ,.0000   ,5.29160   /
      data tbx( 99,10)/45./
      data tbxc(100),tbx(100,1),tbx(100,2),tbx(100,3),tbx(100,4)
     *   /'pd+4'   ,19.2493   ,.683839   ,14.7900   ,7.14833   /
      data tbx(100,5),tbx(100,6),tbx(100,7),tbx(100,8),tbx(100,9)
     *   / 2.89289   ,17.9144   ,-7.9492   ,.005127   ,13.0174   /
      data tbx(100,10)/45./
      data tbxc(101),tbx(101,1),tbx(101,2),tbx(101,3),tbx(101,4)
     *   /'ag  '   ,19.2808   ,  .6446   ,16.6885   , 7.4726   /
      data tbx(101,5),tbx(101,6),tbx(101,7),tbx(101,8),tbx(101,9)
     *   /  4.8045   ,24.6605   , 1.0463   ,99.8156   , 5.1790   /
      data tbx(101,10)/46./
      data tbxc(102),tbx(102,1),tbx(102,2),tbx(102,3),tbx(102,4)
     *   /'ag+1'   ,19.1812   ,.646179   ,15.9719   ,7.19123   /
      data tbx(102,5),tbx(102,6),tbx(102,7),tbx(102,8),tbx(102,9)
     *   / 5.27475   ,21.7326   ,.357534   ,66.1147   ,5.21572   /
      data tbx(102,10)/46./
      data tbxc(103),tbx(103,1),tbx(103,2),tbx(103,3),tbx(103,4)
     *   /'ag+2'   ,19.1643   ,.645643   ,16.2456   ,7.18544   /
      data tbx(103,5),tbx(103,6),tbx(103,7),tbx(103,8),tbx(103,9)
     *   / 4.37090   ,21.4072   ,.0000   ,.0000   ,5.21404   /
      data tbx(103,10)/46./
      data tbxc(104),tbx(104,1),tbx(104,2),tbx(104,3),tbx(104,4)
     *   /'cd  '   ,19.2214   ,  .5946   ,17.6444   , 6.9089   /
      data tbx(104,5),tbx(104,6),tbx(104,7),tbx(104,8),tbx(104,9)
     *   /  4.4610   ,24.7008   , 1.6029   ,87.4825   , 5.0694   /
      data tbx(104,10)/47./
      data tbxc(105),tbx(105,1),tbx(105,2),tbx(105,3),tbx(105,4)
     *   /'cd+2'   ,19.1514   ,.597922   ,17.2535   ,6.80639   /
      data tbx(105,5),tbx(105,6),tbx(105,7),tbx(105,8),tbx(105,9)
     *   / 4.47128   ,20.2521   ,.0000   ,.0000   ,5.11937   /
      data tbx(105,10)/47./
      data tbxc(106),tbx(106,1),tbx(106,2),tbx(106,3),tbx(106,4)
     *   /'in  '   ,19.1624   ,  .5476   ,18.5596   , 6.3776   /
      data tbx(106,5),tbx(106,6),tbx(106,7),tbx(106,8),tbx(106,9)
     *   /  4.2948   ,25.8499   , 2.0396   ,92.8029   , 4.9391   /
      data tbx(106,10)/48./
      data tbxc(107),tbx(107,1),tbx(107,2),tbx(107,3),tbx(107,4)
     *   /'in+3'   ,19.1045   ,.551522   ,18.1108   ,6.32470   /
      data tbx(107,5),tbx(107,6),tbx(107,7),tbx(107,8),tbx(107,9)
     *   / 3.78897   ,17.3595   ,.0000   ,.0000   ,4.99635   /
      data tbx(107,10)/48./
      data tbxc(108),tbx(108,1),tbx(108,2),tbx(108,3),tbx(108,4)
     *   /'sn  '   ,19.1889   , 5.8303   ,19.1005   ,  .5031   /
      data tbx(108,5),tbx(108,6),tbx(108,7),tbx(108,8),tbx(108,9)
     *   /  4.4585   ,26.8909   , 2.4663   ,83.9571   , 4.7821   /
      data tbx(108,10)/49./
      data tbxc(109),tbx(109,1),tbx(109,2),tbx(109,3),tbx(109,4)
     *   /'sn+2'   ,19.1094   ,  .5036   ,19.0548   , 5.8378   /
      data tbx(109,5),tbx(109,6),tbx(109,7),tbx(109,8),tbx(109,9)
     *   /  4.5648   ,23.3752   ,  .4870   ,62.2061   , 4.7861   /
      data tbx(109,10)/49./
      data tbxc(110),tbx(110,1),tbx(110,2),tbx(110,3),tbx(110,4)
     *   /'sn+4'   ,18.9333   , 5.7640   ,19.7131   ,  .4655   /
      data tbx(110,5),tbx(110,6),tbx(110,7),tbx(110,8),tbx(110,9)
     *   /  3.4182   ,14.0049   ,  .0193   , -.7583   , 3.9182   /
      data tbx(110,10)/49./
      data tbxc(111),tbx(111,1),tbx(111,2),tbx(111,3),tbx(111,4)
     *   /'sb  '   ,19.6418   , 5.3034   ,19.0455   ,  .4607   /
      data tbx(111,5),tbx(111,6),tbx(111,7),tbx(111,8),tbx(111,9)
     *   /  5.0371   ,27.9074   , 2.6827   ,75.2825   , 4.5909   /
      data tbx(111,10)/50./
      data tbxc(112),tbx(112,1),tbx(112,2),tbx(112,3),tbx(112,4)
     *   /'sb+3'   ,18.9755   ,.467196   ,18.9330   ,5.22126   /
      data tbx(112,5),tbx(112,6),tbx(112,7),tbx(112,8),tbx(112,9)
     *   / 5.10789   ,19.5902   ,.288753   ,55.5113   ,4.69626   /
      data tbx(112,10)/50./
      data tbxc(113),tbx(113,1),tbx(113,2),tbx(113,3),tbx(113,4)
     *   /'sb+5'   ,19.8685   ,5.44853   ,19.0302   ,.467973   /
      data tbx(113,5),tbx(113,6),tbx(113,7),tbx(113,8),tbx(113,9)
     *   / 2.41253   ,14.1259   ,.0000   ,.0000   ,4.69263   /
      data tbx(113,10)/50./
      data tbxc(114),tbx(114,1),tbx(114,2),tbx(114,3),tbx(114,4)
     *   /'te  '   ,19.9644   ,4.81742   ,19.0138   ,.420885   /
      data tbx(114,5),tbx(114,6),tbx(114,7),tbx(114,8),tbx(114,9)
     *   / 6.14487   ,28.5284   ,2.52390   ,70.8403   ,4.35200   /
      data tbx(114,10)/51./
      data tbxc(115),tbx(115,1),tbx(115,2),tbx(115,3),tbx(115,4)
     *   /'i   '   ,20.1472   , 4.3470   ,18.9949   ,  .3814   /
      data tbx(115,5),tbx(115,6),tbx(115,7),tbx(115,8),tbx(115,9)
     *   /  7.5138   ,27.7660   , 2.2735   ,66.8776   , 4.0712   /
      data tbx(115,10)/52./
      data tbxc(116),tbx(116,1),tbx(116,2),tbx(116,3),tbx(116,4)
     *   /'i-1 '   ,20.2332   , 4.3579   ,18.9970   ,  .3815   /
      data tbx(116,5),tbx(116,6),tbx(116,7),tbx(116,8),tbx(116,9)
     *   /  7.8069   ,29.5259   , 2.8868   ,84.9304   , 4.0714   /
      data tbx(116,10)/52./
      data tbxc(117),tbx(117,1),tbx(117,2),tbx(117,3),tbx(117,4)
     *   /'xe  '   ,20.2933   , 3.9282   ,19.0298   ,  .3440   /
      data tbx(117,5),tbx(117,6),tbx(117,7),tbx(117,8),tbx(117,9)
     *   /  8.9767   ,26.4659   , 1.9900   ,64.2658   , 3.7118   /
      data tbx(117,10)/53./
      data tbxc(118),tbx(118,1),tbx(118,2),tbx(118,3),tbx(118,4)
     *   /'cs  '   ,20.3892   , 3.5690   ,19.1062   ,  .3107   /
      data tbx(118,5),tbx(118,6),tbx(118,7),tbx(118,8),tbx(118,9)
     *   / 10.6620   ,24.3879   , 1.4953   ,213.904   , 3.3352   /
      data tbx(118,10)/54./
      data tbxc(119),tbx(119,1),tbx(119,2),tbx(119,3),tbx(119,4)
     *   /'cs+1'   ,20.3524   , 3.5520   ,19.1278   ,  .3086   /
      data tbx(119,5),tbx(119,6),tbx(119,7),tbx(119,8),tbx(119,9)
     *   / 10.2821   ,23.7128   ,  .9615   ,59.4565   , 3.2791   /
      data tbx(119,10)/54./
      data tbxc(120),tbx(120,1),tbx(120,2),tbx(120,3),tbx(120,4)
     *   /'ba  '   ,20.3361   , 3.2160   ,19.2970   ,  .2756   /
      data tbx(120,5),tbx(120,6),tbx(120,7),tbx(120,8),tbx(120,9)
     *   / 10.8880   ,20.2073   , 2.6959   ,167.202   , 2.7731   /
      data tbx(120,10)/55./
      data tbxc(121),tbx(121,1),tbx(121,2),tbx(121,3),tbx(121,4)
     *   /'ba+2'   ,20.1807   ,3.21367   ,19.1136   ,.283310   /
      data tbx(121,5),tbx(121,6),tbx(121,7),tbx(121,8),tbx(121,9)
     *   / 10.9054   ,20.0558   ,.773634   ,51.7460   ,3.02902   /
      data tbx(121,10)/55./
      data tbxc(122),tbx(122,1),tbx(122,2),tbx(122,3),tbx(122,4)
     *   /'la  '   ,20.5780   ,2.94817   ,19.5990   ,.244475   /
      data tbx(122,5),tbx(122,6),tbx(122,7),tbx(122,8),tbx(122,9)
     *   / 11.3727   ,18.7726   ,3.28719   ,133.124   ,2.14678   /
      data tbx(122,10)/56./
      data tbxc(123),tbx(123,1),tbx(123,2),tbx(123,3),tbx(123,4)
     *   /'la+3'   ,20.2489   ,2.92070   ,19.3763   ,.250698   /
      data tbx(123,5),tbx(123,6),tbx(123,7),tbx(123,8),tbx(123,9)
     *   / 11.6323   ,17.8211   ,.336048   ,54.9453   ,2.40860   /
      data tbx(123,10)/56./
      data tbxc(124),tbx(124,1),tbx(124,2),tbx(124,3),tbx(124,4)
     *   /'ce  '   ,21.1671   ,2.81219   ,19.7695   ,.226836   /
      data tbx(124,5),tbx(124,6),tbx(124,7),tbx(124,8),tbx(124,9)
     *   / 11.8513   ,17.6083   ,3.33049   ,127.113   ,1.86264   /
      data tbx(124,10)/57./
      data tbxc(125),tbx(125,1),tbx(125,2),tbx(125,3),tbx(125,4)
     *   /'ce+3'   ,20.8036   ,2.77691   ,19.5590   ,.231540   /
      data tbx(125,5),tbx(125,6),tbx(125,7),tbx(125,8),tbx(125,9)
     *   / 11.9369   ,16.5408   ,.612376   ,43.1692   ,2.09013   /
      data tbx(125,10)/57./
      data tbxc(126),tbx(126,1),tbx(126,2),tbx(126,3),tbx(126,4)
     *   /'ce+4'   ,20.3235   ,2.65941   ,19.8186   ,.218850   /
      data tbx(126,5),tbx(126,6),tbx(126,7),tbx(126,8),tbx(126,9)
     *   / 12.1233   ,15.7992   ,.144583   ,62.2355   ,1.59180   /
      data tbx(126,10)/57./
      data tbxc(127),tbx(127,1),tbx(127,2),tbx(127,3),tbx(127,4)
     *   /'pr  '   ,22.0440   ,2.77393   ,19.6697   ,.222087   /
      data tbx(127,5),tbx(127,6),tbx(127,7),tbx(127,8),tbx(127,9)
     *   / 12.3856   ,16.7669   ,2.82428   ,143.644   ,2.05830   /
      data tbx(127,10)/58./
      data tbxc(128),tbx(128,1),tbx(128,2),tbx(128,3),tbx(128,4)
     *   /'pr+3'   ,21.3727   ,2.64520   ,19.7491   ,.214299   /
      data tbx(128,5),tbx(128,6),tbx(128,7),tbx(128,8),tbx(128,9)
     *   / 12.1329   ,15.3230   ,.975180   ,36.4065   ,1.77132   /
      data tbx(128,10)/58./
      data tbxc(129),tbx(129,1),tbx(129,2),tbx(129,3),tbx(129,4)
     *   /'pr+4'   ,20.9413   ,2.54467   ,20.0539   ,.202481   /
      data tbx(129,5),tbx(129,6),tbx(129,7),tbx(129,8),tbx(129,9)
     *   / 12.4668   ,14.8137   ,.296689   ,45.4643   ,1.24285   /
      data tbx(129,10)/58./
      data tbxc(130),tbx(130,1),tbx(130,2),tbx(130,3),tbx(130,4)
     *   /'nd  '   ,22.6845   ,2.66248   ,19.6847   ,.210628   /
      data tbx(130,5),tbx(130,6),tbx(130,7),tbx(130,8),tbx(130,9)
     *   / 12.7740   ,15.8850   ,2.85137   ,137.903   ,1.98486   /
      data tbx(130,10)/59./
      data tbxc(131),tbx(131,1),tbx(131,2),tbx(131,3),tbx(131,4)
     *   /'nd+3'   ,21.9610   ,2.52722   ,19.9339   ,.199237   /
      data tbx(131,5),tbx(131,6),tbx(131,7),tbx(131,8),tbx(131,9)
     *   / 12.1200   ,14.1783   ,1.51031   ,30.8717   ,1.47588   /
      data tbx(131,10)/59./
      data tbxc(132),tbx(132,1),tbx(132,2),tbx(132,3),tbx(132,4)
     *   /'pm  '   ,23.3405   ,2.56270   ,19.6095   ,.202088   /
      data tbx(132,5),tbx(132,6),tbx(132,7),tbx(132,8),tbx(132,9)
     *   / 13.1235   ,15.1009   ,2.87516   ,132.721   ,2.02876   /
      data tbx(132,10)/60./
      data tbxc(133),tbx(133,1),tbx(133,2),tbx(133,3),tbx(133,4)
     *   /'pm+3'   ,22.5527   ,2.41740   ,20.1108   ,.185769   /
      data tbx(133,5),tbx(133,6),tbx(133,7),tbx(133,8),tbx(133,9)
     *   / 12.0671   ,13.1275   ,2.07492   ,27.4491   ,1.19499   /
      data tbx(133,10)/60./
      data tbxc(134),tbx(134,1),tbx(134,2),tbx(134,3),tbx(134,4)
     *   /'sm  '   ,24.0042   ,2.47274   ,19.4258   ,.196451   /
      data tbx(134,5),tbx(134,6),tbx(134,7),tbx(134,8),tbx(134,9)
     *   / 13.4396   ,14.3996   ,2.89604   ,128.007   ,2.20963   /
      data tbx(134,10)/61./
      data tbxc(135),tbx(135,1),tbx(135,2),tbx(135,3),tbx(135,4)
     *   /'sm+3'   ,23.1504   ,2.31641   ,20.2599   ,.174081   /
      data tbx(135,5),tbx(135,6),tbx(135,7),tbx(135,8),tbx(135,9)
     *   / 11.9202   ,12.1571   ,2.71488   ,24.8242   ,.954586   /
      data tbx(135,10)/61./
      data tbxc(136),tbx(136,1),tbx(136,2),tbx(136,3),tbx(136,4)
     *   /'eu  '   ,24.6274   , 2.3879   ,19.0886   ,  .1942   /
      data tbx(136,5),tbx(136,6),tbx(136,7),tbx(136,8),tbx(136,9)
     *   / 13.7603   ,13.7546   , 2.9227   ,123.174   , 2.5745   /
      data tbx(136,10)/62./
      data tbxc(137),tbx(137,1),tbx(137,2),tbx(137,3),tbx(137,4)
     *   /'eu+2'   ,24.0063   ,2.27783   ,19.9504   ,.173530   /
      data tbx(137,5),tbx(137,6),tbx(137,7),tbx(137,8),tbx(137,9)
     *   / 11.8034   ,11.6096   ,3.87243   ,26.5156   ,1.36389   /
      data tbx(137,10)/62./
      data tbxc(138),tbx(138,1),tbx(138,2),tbx(138,3),tbx(138,4)
     *   /'eu+3'   ,23.7497   ,2.22258   ,20.3745   ,.163940   /
      data tbx(138,5),tbx(138,6),tbx(138,7),tbx(138,8),tbx(138,9)
     *   / 11.8509   ,11.3110   ,3.26503   ,22.9966   ,.759344   /
      data tbx(138,10)/62./
      data tbxc(139),tbx(139,1),tbx(139,2),tbx(139,3),tbx(139,4)
     *   /'gd  '   ,25.0709   ,2.25341   ,19.0798   ,.181951   /
      data tbx(139,5),tbx(139,6),tbx(139,7),tbx(139,8),tbx(139,9)
     *   / 13.8518   ,12.9331   ,3.54545   ,101.398   ,2.41960   /
      data tbx(139,10)/63./
      data tbxc(140),tbx(140,1),tbx(140,2),tbx(140,3),tbx(140,4)
     *   /'gd+3'   ,24.3466   ,2.13553   ,20.4208   ,.155525   /
      data tbx(140,5),tbx(140,6),tbx(140,7),tbx(140,8),tbx(140,9)
     *   / 11.8708   ,10.5782   ,3.71490   ,21.7029   ,.645089   /
      data tbx(140,10)/63./
      data tbxc(141),tbx(141,1),tbx(141,2),tbx(141,3),tbx(141,4)
     *   /'tb  '   ,25.8976   ,2.24256   ,18.2185   ,.196143   /
      data tbx(141,5),tbx(141,6),tbx(141,7),tbx(141,8),tbx(141,9)
     *   / 14.3167   ,12.6648   ,2.95354   ,115.362   ,3.58324   /
      data tbx(141,10)/64./
      data tbxc(142),tbx(142,1),tbx(142,2),tbx(142,3),tbx(142,4)
     *   /'tb+3'   ,24.9559   ,2.05601   ,20.3271   ,.149525   /
      data tbx(142,5),tbx(142,6),tbx(142,7),tbx(142,8),tbx(142,9)
     *   / 12.2471   ,10.0499   ,3.77300   ,21.2773   ,.691967   /
      data tbx(142,10)/64./
      data tbxc(143),tbx(143,1),tbx(143,2),tbx(143,3),tbx(143,4)
     *   /'dy  '   ,26.5070   ,2.18020   ,17.6383   ,.202172   /
      data tbx(143,5),tbx(143,6),tbx(143,7),tbx(143,8),tbx(143,9)
     *   / 14.5596   ,12.1899   ,2.96577   ,111.874   ,4.29728   /
      data tbx(143,10)/65./
      data tbxc(144),tbx(144,1),tbx(144,2),tbx(144,3),tbx(144,4)
     *   /'dy+3'   ,25.5395   ,1.98040   ,20.2861   ,.143384   /
      data tbx(144,5),tbx(144,6),tbx(144,7),tbx(144,8),tbx(144,9)
     *   / 11.9812   ,9.34972   ,4.50073   ,19.5810   ,.689690   /
      data tbx(144,10)/65./
      data tbxc(145),tbx(145,1),tbx(145,2),tbx(145,3),tbx(145,4)
     *   /'ho  '   ,26.9049   ,2.07051   ,17.2940   ,.197940   /
      data tbx(145,5),tbx(145,6),tbx(145,7),tbx(145,8),tbx(145,9)
     *   / 14.5583   ,11.4407   ,3.63837   ,92.6566   ,4.56796   /
      data tbx(145,10)/66./
      data tbxc(146),tbx(146,1),tbx(146,2),tbx(146,3),tbx(146,4)
     *   /'ho+3'   ,26.1296   ,1.91072   ,20.0994   ,.139358   /
      data tbx(146,5),tbx(146,6),tbx(146,7),tbx(146,8),tbx(146,9)
     *   / 11.9788   ,8.80018   ,4.93676   ,18.5908   ,.852795   /
      data tbx(146,10)/66./
      data tbxc(147),tbx(147,1),tbx(147,2),tbx(147,3),tbx(147,4)
     *   /'er  '   ,27.6563   ,2.07356   ,16.4285   ,.223545   /
      data tbx(147,5),tbx(147,6),tbx(147,7),tbx(147,8),tbx(147,9)
     *   / 14.9779   ,11.3604   ,2.98233   ,105.703   ,5.92046   /
      data tbx(147,10)/67./
      data tbxc(148),tbx(148,1),tbx(148,2),tbx(148,3),tbx(148,4)
     *   /'er+3'   ,26.7220   ,1.84659   ,19.7748   ,.137290   /
      data tbx(148,5),tbx(148,6),tbx(148,7),tbx(148,8),tbx(148,9)
     *   / 12.1506   ,8.36225   ,5.17379   ,17.8974   ,1.17613   /
      data tbx(148,10)/67./
      data tbxc(149),tbx(149,1),tbx(149,2),tbx(149,3),tbx(149,4)
     *   /'tm  '   ,28.1819   ,2.02859   ,15.8851   ,.238849   /
      data tbx(149,5),tbx(149,6),tbx(149,7),tbx(149,8),tbx(149,9)
     *   / 15.1542   ,10.9975   ,2.98706   ,102.961   ,6.75621   /
      data tbx(149,10)/68./
      data tbxc(150),tbx(150,1),tbx(150,2),tbx(150,3),tbx(150,4)
     *   /'tm+3'   ,27.3083   ,1.78711   ,19.3320   ,.136974   /
      data tbx(150,5),tbx(150,6),tbx(150,7),tbx(150,8),tbx(150,9)
     *   / 12.3339   ,7.96778   ,5.38348   ,17.2922   ,1.63929   /
      data tbx(150,10)/68./
      data tbxc(151),tbx(151,1),tbx(151,2),tbx(151,3),tbx(151,4)
     *   /'yb  '   ,28.6641   ,1.98890   ,15.4345   ,.257119   /
      data tbx(151,5),tbx(151,6),tbx(151,7),tbx(151,8),tbx(151,9)
     *   / 15.3087   ,10.6647   ,2.98963   ,100.417   ,7.56672   /
      data tbx(151,10)/69./
      data tbxc(152),tbx(152,1),tbx(152,2),tbx(152,3),tbx(152,4)
     *   /'yb+2'   ,28.1209   ,1.78503   ,17.6817   ,.159970   /
      data tbx(152,5),tbx(152,6),tbx(152,7),tbx(152,8),tbx(152,9)
     *   / 13.3335   ,8.18304   ,5.14657   ,20.3900   ,3.70983   /
      data tbx(152,10)/69./
      data tbxc(153),tbx(153,1),tbx(153,2),tbx(153,3),tbx(153,4)
     *   /'yb+3'   ,27.8917   ,1.73272   ,18.7614   ,.138790   /
      data tbx(153,5),tbx(153,6),tbx(153,7),tbx(153,8),tbx(153,9)
     *   / 12.6072   ,7.64412   ,5.47647   ,16.8153   ,2.26001   /
      data tbx(153,10)/69./
      data tbxc(154),tbx(154,1),tbx(154,2),tbx(154,3),tbx(154,4)
     *   /'lu  '   ,28.9476   ,1.90182   ,15.2208   ,9.98519   /
      data tbx(154,5),tbx(154,6),tbx(154,7),tbx(154,8),tbx(154,9)
     *   / 15.1000   ,.261033   ,3.71601   ,84.3298   ,7.97628   /
      data tbx(154,10)/70./
      data tbxc(155),tbx(155,1),tbx(155,2),tbx(155,3),tbx(155,4)
     *   /'lu+3'   ,28.4628   ,1.68216   ,18.1210   ,.142292   /
      data tbx(155,5),tbx(155,6),tbx(155,7),tbx(155,8),tbx(155,9)
     *   / 12.8429   ,7.33727   ,5.59415   ,16.3535   ,2.97573   /
      data tbx(155,10)/70./
      data tbxc(156),tbx(156,1),tbx(156,2),tbx(156,3),tbx(156,4)
     *   /'hf  '   ,29.1440   ,1.83262   ,15.1726   ,9.59990   /
      data tbx(156,5),tbx(156,6),tbx(156,7),tbx(156,8),tbx(156,9)
     *   / 14.7586   ,.275116   ,4.30013   ,72.0290   ,8.58154   /
      data tbx(156,10)/71./
      data tbxc(157),tbx(157,1),tbx(157,2),tbx(157,3),tbx(157,4)
     *   /'hf+4'   ,28.8131   ,1.59136   ,18.4601   ,.128903   /
      data tbx(157,5),tbx(157,6),tbx(157,7),tbx(157,8),tbx(157,9)
     *   / 12.7285   ,6.76232   ,5.59927   ,14.0366   ,2.39699   /
      data tbx(157,10)/71./
      data tbxc(158),tbx(158,1),tbx(158,2),tbx(158,3),tbx(158,4)
     *   /'ta  '   ,29.2024   ,1.77333   ,15.2293   ,9.37046   /
      data tbx(158,5),tbx(158,6),tbx(158,7),tbx(158,8),tbx(158,9)
     *   / 14.5135   ,.295977   ,4.76492   ,63.3644   ,9.24354   /
      data tbx(158,10)/72./
      data tbxc(159),tbx(159,1),tbx(159,2),tbx(159,3),tbx(159,4)
     *   /'ta+5'   ,29.1587   ,1.50711   ,18.8407   ,.116741   /
      data tbx(159,5),tbx(159,6),tbx(159,7),tbx(159,8),tbx(159,9)
     *   / 12.8268   ,6.31524   ,5.38695   ,12.4244   ,1.78555   /
      data tbx(159,10)/72./
      data tbxc(160),tbx(160,1),tbx(160,2),tbx(160,3),tbx(160,4)
     *   /'w   '   ,29.0818   ,1.72029   ,15.4300   ,9.22590   /
      data tbx(160,5),tbx(160,6),tbx(160,7),tbx(160,8),tbx(160,9)
     *   / 14.4327   ,.321703   ,5.11982   ,57.0560   ,9.88750   /
      data tbx(160,10)/73./
      data tbxc(161),tbx(161,1),tbx(161,2),tbx(161,3),tbx(161,4)
     *   /'w+6 '   ,29.4936   ,1.42755   ,19.3763   ,.104621   /
      data tbx(161,5),tbx(161,6),tbx(161,7),tbx(161,8),tbx(161,9)
     *   / 13.0544   ,5.93667   ,5.06412   ,11.1972   ,1.01074   /
      data tbx(161,10)/73./
      data tbxc(162),tbx(162,1),tbx(162,2),tbx(162,3),tbx(162,4)
     *   /'re  '   ,28.7621   ,1.67191   ,15.7189   ,9.09227   /
      data tbx(162,5),tbx(162,6),tbx(162,7),tbx(162,8),tbx(162,9)
     *   / 14.5564   ,.350500   ,5.44174   ,52.0861   ,10.4720   /
      data tbx(162,10)/74./
      data tbxc(163),tbx(163,1),tbx(163,2),tbx(163,3),tbx(163,4)
     *   /'os  '   ,28.1894   ,1.62903   ,16.1550   ,8.97948   /
      data tbx(163,5),tbx(163,6),tbx(163,7),tbx(163,8),tbx(163,9)
     *   / 14.9305   ,.382661   ,5.67589   ,48.1647   ,11.0005   /
      data tbx(163,10)/75./
      data tbxc(164),tbx(164,1),tbx(164,2),tbx(164,3),tbx(164,4)
     *   /'os+4'   ,30.4190   ,1.37113   ,15.2637   ,6.84706   /
      data tbx(164,5),tbx(164,6),tbx(164,7),tbx(164,8),tbx(164,9)
     *   / 14.7458   ,.165191   ,5.06795   ,18.0030   ,6.49804   /
      data tbx(164,10)/75./
      data tbxc(165),tbx(165,1),tbx(165,2),tbx(165,3),tbx(165,4)
     *   /'ir  '   ,27.3049   ,1.59279   ,16.7296   ,8.86553   /
      data tbx(165,5),tbx(165,6),tbx(165,7),tbx(165,8),tbx(165,9)
     *   / 15.6115   ,.417916   ,5.83377   ,45.0011   ,11.4722   /
      data tbx(165,10)/76./
      data tbxc(166),tbx(166,1),tbx(166,2),tbx(166,3),tbx(166,4)
     *   /'ir+3'   ,30.4156   ,1.34323   ,15.8620   ,7.10909   /
      data tbx(166,5),tbx(166,6),tbx(166,7),tbx(166,8),tbx(166,9)
     *   / 13.6145   ,.204633   ,5.82008   ,20.3254   ,8.27903   /
      data tbx(166,10)/76./
      data tbxc(167),tbx(167,1),tbx(167,2),tbx(167,3),tbx(167,4)
     *   /'ir+4'   ,30.7058   ,1.30923   ,15.5512   ,6.71983   /
      data tbx(167,5),tbx(167,6),tbx(167,7),tbx(167,8),tbx(167,9)
     *   / 14.2326   ,.167252   ,5.53672   ,17.4911   ,6.96824   /
      data tbx(167,10)/76./
      data tbxc(168),tbx(168,1),tbx(168,2),tbx(168,3),tbx(168,4)
     *   /'pt  '   ,27.0059   ,1.51293   ,17.7639   ,8.81174   /
      data tbx(168,5),tbx(168,6),tbx(168,7),tbx(168,8),tbx(168,9)
     *   / 15.7131   ,.424593   ,5.78370   ,38.6103   ,11.6883   /
      data tbx(168,10)/77./
      data tbxc(169),tbx(169,1),tbx(169,2),tbx(169,3),tbx(169,4)
     *   /'pt+2'   ,29.8429   ,1.32927   ,16.7224   ,7.38979   /
      data tbx(169,5),tbx(169,6),tbx(169,7),tbx(169,8),tbx(169,9)
     *   / 13.2153   ,.263297   ,6.35234   ,22.9426   ,9.85329   /
      data tbx(169,10)/77./
      data tbxc(170),tbx(170,1),tbx(170,2),tbx(170,3),tbx(170,4)
     *   /'pt+4'   ,30.9612   ,1.24813   ,15.9829   ,6.60834   /
      data tbx(170,5),tbx(170,6),tbx(170,7),tbx(170,8),tbx(170,9)
     *   / 13.7348   ,.168640   ,5.92034   ,16.9392   ,7.39534   /
      data tbx(170,10)/77./
      data tbxc(171),tbx(171,1),tbx(171,2),tbx(171,3),tbx(171,4)
     *   /'au  '   ,16.8819   ,  .4611   ,18.5913   , 8.6216   /
      data tbx(171,5),tbx(171,6),tbx(171,7),tbx(171,8),tbx(171,9)
     *   / 25.5582   , 1.4826   , 5.8600   ,36.3956   ,12.0658   /
      data tbx(171,10)/78./
      data tbxc(172),tbx(172,1),tbx(172,2),tbx(172,3),tbx(172,4)
     *   /'au+1'   ,28.0109   ,1.35321   ,17.8204   ,7.73950   /
      data tbx(172,5),tbx(172,6),tbx(172,7),tbx(172,8),tbx(172,9)
     *   / 14.3359   ,.356752   ,6.58077   ,26.4043   ,11.2299   /
      data tbx(172,10)/78./
      data tbxc(173),tbx(173,1),tbx(173,2),tbx(173,3),tbx(173,4)
     *   /'au+3'   ,30.6886   ,1.21990   ,16.9029   ,6.82872   /
      data tbx(173,5),tbx(173,6),tbx(173,7),tbx(173,8),tbx(173,9)
     *   / 12.7801   ,.212867   ,6.52354   ,18.6590   ,9.09680   /
      data tbx(173,10)/78./
      data tbxc(174),tbx(174,1),tbx(174,2),tbx(174,3),tbx(174,4)
     *   /'hg  '   ,20.6809   ,  .5450   ,19.0417   , 8.4484   /
      data tbx(174,5),tbx(174,6),tbx(174,7),tbx(174,8),tbx(174,9)
     *   / 21.6575   , 1.5729   , 5.9676   ,38.3246   ,12.6089   /
      data tbx(174,10)/79./
      data tbxc(175),tbx(175,1),tbx(175,2),tbx(175,3),tbx(175,4)
     *   /'hg+1'   ,25.0853   ,1.39507   ,18.4973   ,7.65105   /
      data tbx(175,5),tbx(175,6),tbx(175,7),tbx(175,8),tbx(175,9)
     *   / 16.8883   ,.443378   ,6.48216   ,28.2262   ,12.0205   /
      data tbx(175,10)/79./
      data tbxc(176),tbx(176,1),tbx(176,2),tbx(176,3),tbx(176,4)
     *   /'hg+2'   ,29.5641   ,1.21152   ,18.0600   ,7.05639   /
      data tbx(176,5),tbx(176,6),tbx(176,7),tbx(176,8),tbx(176,9)
     *   / 12.8374   ,.284738   ,6.89912   ,20.7482   ,10.6268   /
      data tbx(176,10)/79./
      data tbxc(177),tbx(177,1),tbx(177,2),tbx(177,3),tbx(177,4)
     *   /'tl  '   ,27.5446   ,.655150   ,19.1584   ,8.70751   /
      data tbx(177,5),tbx(177,6),tbx(177,7),tbx(177,8),tbx(177,9)
     *   / 15.5380   ,1.96347   ,5.52593   ,45.8149   ,13.1746   /
      data tbx(177,10)/80./
      data tbxc(178),tbx(178,1),tbx(178,2),tbx(178,3),tbx(178,4)
     *   /'tl+1'   ,21.3985   ,1.47110   ,20.4723   ,.517394   /
      data tbx(178,5),tbx(178,6),tbx(178,7),tbx(178,8),tbx(178,9)
     *   / 18.7478   ,7.43463   ,6.82847   ,28.8482   ,12.5258   /
      data tbx(178,10)/80./
      data tbxc(179),tbx(179,1),tbx(179,2),tbx(179,3),tbx(179,4)
     *   /'tl+3'   ,30.8695   ,1.10080   ,18.3841   ,6.53852   /
      data tbx(179,5),tbx(179,6),tbx(179,7),tbx(179,8),tbx(179,9)
     *   / 11.9328   ,.219074   ,7.00574   ,17.2114   ,9.80270   /
      data tbx(179,10)/80./
      data tbxc(180),tbx(180,1),tbx(180,2),tbx(180,3),tbx(180,4)
     *   /'pb  '   ,31.0617   ,  .6902   ,13.0637   , 2.3576   /
      data tbx(180,5),tbx(180,6),tbx(180,7),tbx(180,8),tbx(180,9)
     *   / 18.4420   , 8.6180   , 5.9696   ,47.2579   ,13.4118   /
      data tbx(180,10)/81./
      data tbxc(181),tbx(181,1),tbx(181,2),tbx(181,3),tbx(181,4)
     *   /'pb+2'   ,21.7886   ,1.33660   ,19.5682   ,.488383   /
      data tbx(181,5),tbx(181,6),tbx(181,7),tbx(181,8),tbx(181,9)
     *   / 19.1406   ,6.77270   ,7.01107   ,23.8132   ,12.4734   /
      data tbx(181,10)/81./
      data tbxc(182),tbx(182,1),tbx(182,2),tbx(182,3),tbx(182,4)
     *   /'pb+4'   ,32.1244   ,1.00566   ,18.8003   ,6.10926   /
      data tbx(182,5),tbx(182,6),tbx(182,7),tbx(182,8),tbx(182,9)
     *   / 12.0175   ,.147041   ,6.96886   ,14.7140   ,8.08428   /
      data tbx(182,10)/81./
      data tbxc(183),tbx(183,1),tbx(183,2),tbx(183,3),tbx(183,4)
     *   /'bi  '   ,33.3689   ,  .7040   ,12.9510   , 2.9238   /
      data tbx(183,5),tbx(183,6),tbx(183,7),tbx(183,8),tbx(183,9)
     *   / 16.5877   , 8.7937   , 6.4692   ,48.0093   ,13.5782   /
      data tbx(183,10)/82./
      data tbxc(184),tbx(184,1),tbx(184,2),tbx(184,3),tbx(184,4)
     *   /'bi+3'   ,21.8053   ,1.23560   ,19.5026   ,6.24149   /
      data tbx(184,5),tbx(184,6),tbx(184,7),tbx(184,8),tbx(184,9)
     *   / 19.1053   ,.469999   ,7.10295   ,20.3185   ,12.4711   /
      data tbx(184,10)/82./
      data tbxc(185),tbx(185,1),tbx(185,2),tbx(185,3),tbx(185,4)
     *   /'bi+5'   ,33.5364   ,.916540   ,25.0946   ,.039042   /
      data tbx(185,5),tbx(185,6),tbx(185,7),tbx(185,8),tbx(185,9)
     *   / 19.2497   ,5.71414   ,6.91555   ,12.8285   ,-6.7994   /
      data tbx(185,10)/82./
      data tbxc(186),tbx(186,1),tbx(186,2),tbx(186,3),tbx(186,4)
     *   /'po  '   ,34.6726   ,.700999   ,15.4733   ,3.55078   /
      data tbx(186,5),tbx(186,6),tbx(186,7),tbx(186,8),tbx(186,9)
     *   / 13.1138   ,9.55642   ,7.02588   ,47.0045   ,13.6770   /
      data tbx(186,10)/83./
      data tbxc(187),tbx(187,1),tbx(187,2),tbx(187,3),tbx(187,4)
     *   /'at  '   ,35.3163   ,.685870   ,19.0211   ,3.97458   /
      data tbx(187,5),tbx(187,6),tbx(187,7),tbx(187,8),tbx(187,9)
     *   / 9.49887   ,11.3824   ,7.42518   ,45.4715   ,13.7108   /
      data tbx(187,10)/84./
      data tbxc(188),tbx(188,1),tbx(188,2),tbx(188,3),tbx(188,4)
     *   /'rn  '   ,35.5631   ,  .6631   ,21.2816   , 4.0691   /
      data tbx(188,5),tbx(188,6),tbx(188,7),tbx(188,8),tbx(188,9)
     *   /  8.0037   ,14.0422   , 7.4433   ,44.2473   ,13.6905   /
      data tbx(188,10)/85./
      data tbxc(189),tbx(189,1),tbx(189,2),tbx(189,3),tbx(189,4)
     *   /'fr  '   ,35.9299   ,.646453   ,23.0547   ,4.17619   /
      data tbx(189,5),tbx(189,6),tbx(189,7),tbx(189,8),tbx(189,9)
     *   / 12.1439   ,23.1052   ,2.11253   ,150.645   ,13.7247   /
      data tbx(189,10)/86./
      data tbxc(190),tbx(190,1),tbx(190,2),tbx(190,3),tbx(190,4)
     *   /'ra  '   ,35.7630   ,.616341   ,22.9064   ,3.87135   /
      data tbx(190,5),tbx(190,6),tbx(190,7),tbx(190,8),tbx(190,9)
     *   / 12.4739   ,19.9887   ,3.21097   ,142.325   ,13.6211   /
      data tbx(190,10)/87./
      data tbxc(191),tbx(191,1),tbx(191,2),tbx(191,3),tbx(191,4)
     *   /'ra+2'   ,35.2150   ,.604909   ,21.6700   ,3.57670   /
      data tbx(191,5),tbx(191,6),tbx(191,7),tbx(191,8),tbx(191,9)
     *   / 7.91342   ,12.6010   ,7.65078   ,29.8436   ,13.5431   /
      data tbx(191,10)/87./
      data tbxc(192),tbx(192,1),tbx(192,2),tbx(192,3),tbx(192,4)
     *   /'ac  '   ,35.6597   ,.589092   ,23.1032   ,3.65155   /
      data tbx(192,5),tbx(192,6),tbx(192,7),tbx(192,8),tbx(192,9)
     *   / 12.5977   ,18.5990   ,4.08655   ,117.020   ,13.5266   /
      data tbx(192,10)/88./
      data tbxc(193),tbx(193,1),tbx(193,2),tbx(193,3),tbx(193,4)
     *   /'ac+3'   ,35.1736   ,.579689   ,22.1112   ,3.41437   /
      data tbx(193,5),tbx(193,6),tbx(193,7),tbx(193,8),tbx(193,9)
     *   / 8.19216   ,12.9187   ,7.05545   ,25.9443   ,13.4637   /
      data tbx(193,10)/88./
      data tbxc(194),tbx(194,1),tbx(194,2),tbx(194,3),tbx(194,4)
     *   /'th  '   ,35.5645   ,.563359   ,23.4219   ,3.46204   /
      data tbx(194,5),tbx(194,6),tbx(194,7),tbx(194,8),tbx(194,9)
     *   / 12.7473   ,17.8309   ,4.80703   ,99.1722   ,13.4314   /
      data tbx(194,10)/89./
      data tbxc(195),tbx(195,1),tbx(195,2),tbx(195,3),tbx(195,4)
     *   /'th+4'   ,35.1007   ,.555054   ,22.4418   ,3.24498   /
      data tbx(195,5),tbx(195,6),tbx(195,7),tbx(195,8),tbx(195,9)
     *   / 9.78554   ,13.4661   ,5.29444   ,23.9533   ,13.3760   /
      data tbx(195,10)/89./
      data tbxc(196),tbx(196,1),tbx(196,2),tbx(196,3),tbx(196,4)
     *   /'pa  '   ,35.8847   ,.547751   ,23.2948   ,3.41519   /
      data tbx(196,5),tbx(196,6),tbx(196,7),tbx(196,8),tbx(196,9)
     *   / 14.1891   ,16.9235   ,4.17287   ,105.251   ,13.4287   /
      data tbx(196,10)/90./
      data tbxc(197),tbx(197,1),tbx(197,2),tbx(197,3),tbx(197,4)
     *   /'u   '   ,36.0228   ,  .5293   ,23.4128   , 3.3253   /
      data tbx(197,5),tbx(197,6),tbx(197,7),tbx(197,8),tbx(197,9)
     *   / 14.9491   ,16.0927   , 4.1880   ,100.613   ,13.3966   /
      data tbx(197,10)/91./
      data tbxc(198),tbx(198,1),tbx(198,2),tbx(198,3),tbx(198,4)
     *   /'u+3 '  ,35.5747   ,.520480   ,22.5259   ,3.12293   /
      data tbx(198,5),tbx(198,6),tbx(198,7),tbx(198,8),tbx(198,9)
     *   / 12.2165   ,12.7148   ,5.37073   ,26.3394   ,13.3092   /
      data tbx(198,10)/91./
      data tbxc(199),tbx(199,1),tbx(199,2),tbx(199,3),tbx(199,4)
     *   /'u+4 '  ,35.3715   ,.516598   ,22.5326   ,3.05053   /
      data tbx(199,5),tbx(199,6),tbx(199,7),tbx(199,8),tbx(199,9)
     *   / 12.0291   ,12.5723   ,4.79840   ,23.4582   ,13.2671   /
      data tbx(199,10)/91./
      data tbxc(200),tbx(200,1),tbx(200,2),tbx(200,3),tbx(200,4)
     *   /'u+6 '  ,34.8509   ,.507079   ,22.7584   ,2.89030   /
      data tbx(200,5),tbx(200,6),tbx(200,7),tbx(200,8),tbx(200,9)
     *   / 14.0099   ,13.1767   ,1.21457   ,25.2017   ,13.1665   /
      data tbx(200,10)/91./
      data tbxc(201),tbx(201,1),tbx(201,2),tbx(201,3),tbx(201,4)
     *   /'np  '   ,36.1874   ,.511929   ,23.5964   ,3.25396   /
      data tbx(201,5),tbx(201,6),tbx(201,7),tbx(201,8),tbx(201,9)
     *   / 15.6402   ,15.3622   ,4.18550   ,97.4908   ,13.3573   /
      data tbx(201,10)/92./
      data tbxc(202),tbx(202,1),tbx(202,2),tbx(202,3),tbx(202,4)
     *   /'np+3'   ,35.7074   ,.502322   ,22.6130   ,3.03807   /
      data tbx(202,5),tbx(202,6),tbx(202,7),tbx(202,8),tbx(202,9)
     *   / 12.9898   ,12.1449   ,5.43227   ,25.4928   ,13.2544   /
      data tbx(202,10)/92./
      data tbxc(203),tbx(203,1),tbx(203,2),tbx(203,3),tbx(203,4)
     *   /'np+4'   ,35.5103   ,.498626   ,22.5787   ,2.96627   /
      data tbx(203,5),tbx(203,6),tbx(203,7),tbx(203,8),tbx(203,9)
     *   / 12.7766   ,11.9484   ,4.92159   ,22.7502   ,13.2116   /
      data tbx(203,10)/92./
      data tbxc(204),tbx(204,1),tbx(204,2),tbx(204,3),tbx(204,4)
     *   /'np+6'   ,35.0136   ,.489810   ,22.7286   ,2.81099   /
      data tbx(204,5),tbx(204,6),tbx(204,7),tbx(204,8),tbx(204,9)
     *   / 14.3884   ,12.3300   ,1.75669   ,22.6581   ,13.1130   /
      data tbx(204,10)/92./
      data tbxc(205),tbx(205,1),tbx(205,2),tbx(205,3),tbx(205,4)
     *   /'pu  '   ,36.5254   ,.499384   ,23.8083   ,3.26371   /

      data tbx(205,5),tbx(205,6),tbx(205,7),tbx(205,8),tbx(205,9)
     *   / 16.7707   ,14.9455   ,3.47947   ,105.980   ,13.3812   /
      data tbx(205,10)/93./
      data tbxc(206),tbx(206,1),tbx(206,2),tbx(206,3),tbx(206,4)
     *   /'pu+3'   ,35.8400   ,.484938   ,22.7169   ,2.96118   /
      data tbx(206,5),tbx(206,6),tbx(206,7),tbx(206,8),tbx(206,9)
     *   / 13.5807   ,11.5331   ,5.66016   ,24.3992   ,13.1991   /
      data tbx(206,10)/93./
      data tbxc(207),tbx(207,1),tbx(207,2),tbx(207,3),tbx(207,4)
     *   /'pu+4'   ,35.6493   ,.481422   ,22.6460   ,2.89020   /
      data tbx(207,5),tbx(207,6),tbx(207,7),tbx(207,8),tbx(207,9)
     *   / 13.3595   ,11.3160   ,5.18831   ,21.8301   ,13.1555   /
      data tbx(207,10)/93./
      data tbxc(208),tbx(208,1),tbx(208,2),tbx(208,3),tbx(208,4)
     *   /'pu+6'   ,35.1736   ,.473204   ,22.7181   ,2.73848   /
      data tbx(208,5),tbx(208,6),tbx(208,7),tbx(208,8),tbx(208,9)
     *   / 14.7635   ,11.5530   ,2.28678   ,20.9303   ,13.0582   /
      data tbx(208,10)/93./
      data tbxc(209),tbx(209,1),tbx(209,2),tbx(209,3),tbx(209,4)
     *   /'am  '   ,36.6706   ,.483629   ,24.0992   ,3.20647   /
      data tbx(209,5),tbx(209,6),tbx(209,7),tbx(209,8),tbx(209,9)
     *   / 17.3415   ,14.3136   ,3.49331   ,102.273   ,13.3592   /
      data tbx(209,10)/94./
      data tbxc(210),tbx(210,1),tbx(210,2),tbx(210,3),tbx(210,4)
     *   /'cm  '   ,36.6488   ,.465154   ,24.4096   ,3.08997   /
      data tbx(210,5),tbx(210,6),tbx(210,7),tbx(210,8),tbx(210,9)
     *   / 17.3990   ,13.4346   ,4.21665   ,88.4834   ,13.2887   /
      data tbx(210,10)/95./
      data tbxc(211),tbx(211,1),tbx(211,2),tbx(211,3),tbx(211,4)
     *   /'bk  '   ,36.7881   ,.451018   ,24.7736   ,3.04619   /
      data tbx(211,5),tbx(211,6),tbx(211,7),tbx(211,8),tbx(211,9)
     *   / 17.8919   ,12.8946   ,4.23284   ,86.0030   ,13.2754   /
      data tbx(211,10)/96./
      data tbxc(212),tbx(212,1),tbx(212,2),tbx(212,3),tbx(212,4)
     *   /'cf  '   ,36.9185   ,.437533   ,25.1995   ,3.00775   /
      data tbx(212,5),tbx(212,6),tbx(212,7),tbx(212,8),tbx(212,9)
     *   / 18.3317   ,12.4044   ,4.24391   ,83.7881   ,13.2674   /
      data tbx(212,10)/97./
      END
C
